/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

var searchFrame = top.frames["searchFrame"];
var mainFrame = top.frames["mainFrame"];

jQuery(document).ready(function(){	
	if (top.window.opener){
		var cachedFont = jQuery("#contrast", top.window.opener.skin.document.body);
		if (cachedFont && cachedFont.val() && cachedFont.val() != "") {
			var font = cachedFont.val();
			changeStyleProperty(font, "contrast");
		}
	   
		var cachedScale = jQuery("#scale", top.window.opener.skin.document.body);
		if (cachedScale && cachedScale.val() && cachedScale.val() != "") {
			var scale = cachedScale.val();
			changeStyleProperty(scale, "scale");
		}
	}
});

function loadGlossary() {
	var path = "/europa/crs?";
	var query = top.location.search.toString().substr(1);
	//alert("redirecting to: " + top.location.protocol + "//" + top.location.host + path + query);
	if(query.indexOf('&bravais=true') != -1) {
		var glossaryResId = query.substring(8, query.indexOf('.html') + 5);
		location.replace('../../../' + 'Glossary/' + glossaryResId);
	} else if(query.indexOf('content=') != 0) {
		location.replace(top.location.protocol + "//" + top.location.host + path + query);
	} else {
		// for Deployed course case
		var glossaryResId = query.substr(8);
		location.replace('../../../' + glossaryResId);
	}
}

function findTerms() {
	showAllTerms();
	var i = 0;
	var keywords = mainFrame.document.getElementById("keywords").innerHTML.split("|");
	var term = searchFrame.document.getElementById('searchWord').value;
	var found = false;
	if(!searchFrame.document.getElementById('exactMatch').checked) {
		for(var i=0; i<keywords.length; i++) {
			var dublicateCount = 0;
			var itemId = keywords[i];
			if(keywords[i].lastIndexOf("__") != -1) {
				dublicateCount = keywords[i].substring(keywords[i].lastIndexOf("__")+2);
				itemId = keywords[i].substring(0, keywords[i].lastIndexOf("__"));
				if(!(dublicateCount > 0)) {
					dublicateCount = 0;
				}
			}
			for(var j=0; j<=dublicateCount; j++) {
				var item;
				if(j==0)
					item = mainFrame.document.getElementById(itemId);
				else
					item = mainFrame.document.getElementById(itemId + "__" + j);
				if(typeof(item)=='undefined' || item == null)
					continue;
				if (itemId.toLowerCase().indexOf(term.toLowerCase()) == -1 && itemId.toUpperCase().indexOf(term.toUpperCase()) == -1)
					item.style.display = 'none';
				else
					found = true;	
			}
		}
	} else {
		for(var i=0; i<keywords.length; i++) {
			var dublicateCount = 0;
			var itemId = keywords[i];
			if(keywords[i].lastIndexOf("__") != -1) {
				dublicateCount = keywords[i].substring(keywords[i].lastIndexOf("__")+2);
				itemId = keywords[i].substring(0, keywords[i].lastIndexOf("__"));
				if(!(dublicateCount > 0)) {
					dublicateCount = 0;
				}
			}
			if(itemId != term) {
				for(var j=0; j<=dublicateCount; j++) {
					var item;
					if(j==0)
						item = mainFrame.document.getElementById(itemId);
					else
						item = mainFrame.document.getElementById(itemId + "__" + j);
					if(typeof(item)!='undefined' && item != null) {
						item.style.display = 'none';
					}
				}
			} else found = true;
		}
	}
	if(!found)
		mainFrame.document.getElementById('notFound').style.display = 'block';
}

function showAllTerms() {
	mainFrame.document.getElementById('notFound').style.display = 'none';
	var keywords = mainFrame.document.getElementById("keywords").innerHTML.split("|");
	for(var i=0; i<keywords.length; i++) {
		var itemId = keywords[i];
		var dublicateCount = 0;
		if(keywords[i].lastIndexOf("__") != -1) {
			dublicateCount = keywords[i].substring(keywords[i].lastIndexOf("__")+2);
			itemId = keywords[i].substring(0, keywords[i].lastIndexOf("__"));
			if(!(dublicateCount > 0)) {
				dublicateCount = 0;
			}
		}
		for(var j=0; j<=dublicateCount; j++) {
			var item;
			if(j==0)
				item = mainFrame.document.getElementById(itemId);
			else
				item = mainFrame.document.getElementById(itemId + "__" + j);
			if(typeof(item)!='undefined' && item != null)
				item.style.display = 'block';
		}
	}
}


/**
* style changer 
*
*/
function changeStyleProperty(value, what) {
	var elementsToRestyle = jQuery("body, div, a, span", mainFrame.document); 
	//elementsToRestyle += jQuery("body, div, a, span, p, input", searchFrame.document); 
	//contrast restyling 
	if (value == "highContrast") {
		jQuery("body, div, a, span", mainFrame.document).each(function(index, elem) {
				var jElem = jQuery(elem);
				
				jElem.css({
					"background-color" : "black",
					"color": "yellow"
				});
			});	
		jQuery("body, div, a, span, p, input", searchFrame.document).each(function(index, elem) {
				var jElem = jQuery(elem);
				
				jElem.css({
					"background-color" : "black",
					"color": "yellow"
				});
			});					
	} else if (value == "normalContrast") {					
		jQuery("body, div, a, span", mainFrame.document).each(function(index, elem) {
				var jElem = jQuery(elem);
				
				if (jElem.attr("normalCss")) {
					var normalCssValues = jElem.attr("normalCss").split("|");

					jElem.css("background-color", normalCssValues[0]);
					jElem.css("color", normalCssValues[1]);
				}
			
			});
		jQuery("body, div, a, span, p, input", searchFrame.document).each(function(index, elem) {
				var jElem = jQuery(elem);
				
				if (jElem.attr("normalCss")) {
					var normalCssValues = jElem.attr("normalCss").split("|");

					jElem.css("background-color", normalCssValues[0]);
					jElem.css("color", normalCssValues[1]);
				}
			
			});
	}
	
	if (what == "scale") { 
		jQuery("body, div, a, span", mainFrame.document).each(function(index, elem) {
				if (value != "") {
					elem.style.fontSize = value + "px";
				}
			}); 
		jQuery("body, div, a, span, p, input", searchFrame.document).each(function(index, elem) {
				if (value != "") {
					elem.style.fontSize = value + "px";
				}
			});				
	}
			
}	