/*
	
	Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
	All rights reserved.
	
	This file and related documentation are protected by copyright and
	are distributed under licenses regarding their use, copying, distribution,
	and decompilation. No part of this product or related documentation may
	be reproduced or transmitted in any form or by any means, electronic or
	mechanical, for any purpose, without the express written permission of
	Xyleme, Inc.
	
 */



var questionsData = new Array();

//notifications
var langShowSolution = typeof(document.langShowSolution)!='undefined' ? document.langShowSolution : CRE_Frame.document.langShowSolution;
var langAttemptRemaining = typeof(document.langAttemptRemaining)!='undefined' ? document.langAttemptRemaining : CRE_Frame.document.langAttemptRemaining;
var langAttemptsRemaining = typeof(document.langAttemptsRemaining)!='undefined' ? document.langAttemptsRemaining : CRE_Frame.document.langAttemptsRemaining;
var langSubmit = typeof(document.langSubmit)!='undefined' ? document.langSubmit : CRE_Frame.document.langSubmit;
var langUserAnswer = typeof(document.langUserAnswer)!='undefined' ? document.langUserAnswer : CRE_Frame.document.langUserAnswer;
var langReset = typeof(document.langReset)!='undefined' ? document.langReset : CRE_Frame.document.langReset;

function DragQuestionData() {

	this.id = 0;
	this.debugMode = false;
	this.distractorType = '';
	this.imageOffset = 0;	//for matching drag image
	
	this.highlightDropArea = false;
	this.highlightDropAreaBorder = ""; //highlighting color
	this.dragDropMode = "Assessment";
	this.showFeedback = false;
	this.showSolution = false;
	this.iaMode = false;
	this.displayAreaSpecified = false;
	this.hotSpotCount = 0;
	this.destinationMatch = "";
	
	this.startX = 0; // mouse starting positions
	this.startY = 0; 
	this.offsetX = 0; // current element offset 
	this.offsetY = 0;
	this.dragElement = null; // needs to be passed from BDOnMouseDown to BDOnMouseMove 
	this.dragSecondElement = null;
	this.oldZIndex = 0; // we temporarily increase the z-index during drag 
	this.debug = ""; 	
	this.snapEndX = 0;
	this.snapEndY = 0;
	
	this.dropX = 0;
	this.dropY = 0;
	
	/*for dnd sequencing*/
	this.dragElemStartX = 0;
	this.dragElemStartY = 0;
	/*--for dnd sequencing--*/
	
    this.offsets = new Array();
    this.leftOffsets = new Array();
    this.topOffsets = new Array();
    
    this.baseLeft = 0;
	this.baseTop = 0;

	this.buttonState = "Submit";
	
	this.targetsCount = 0;
	this.dragMatches = new Array();
	this.snapTimer = null;
	
	this.minTextWidth = 100;
    this.outlinemaps = new Array();
	
	this.userPositions = new Array();
	this.startPositions = new Array();
	this.newPositions = new Array();
	
	this.snapTimers = new Array();
	this.snapCurrent = 0;
	this.alreadyOnTarget = 0;
	this.lastOnTarget = false;
	//array to contain number of elements on each destination elem
	this.spotsOnTarget = new Array();
	//to define whether arrange of question's elements took place or not
	this.arranged = false;
	
	// -------------------------------
	// --- init function for areas object ---
	areasConfig.prototype.init = function(idf, qid) {
		var tds = document.getElementById("WebMatchingActivity_" + qid).getElementsByTagName("td");
		for (var j=0;j<tds.length;j++) {
			for (var i=0;i<tds.length;i++) {
				var idx = Number(j) + 1;
				if (tds[i].id == idf + idx) {
					//var coords = findPos(tds[i]);
					this.list[j] = new Array();
					this.list[j][0] = tds[i].id; //id
					this.list[j][1] = tds[i]; //object reference
					this.list[j][2] = jQuery(tds[i]).position().left;//coords[0]; //left coordinate
					this.list[j][3] = jQuery(tds[i]).width();//coords[1]; //right coordinate
					this.list[j][4] = jQuery(tds[i]).position().top;//coords[2]; //top coordinate
					this.list[j][5] = jQuery(tds[i]).position().top + jQuery(tds[i]).height();//coords[3]; //bottom coordinate
				}
			}
		}
	}	
			
	addQuestionData(this);
	this.getParamValue = function(param) {
		return this[param];
	}

	this.setParam = function (param, value)	{
		this[param] = value;
	}

}

// -------------------------------
// --- object constructor for page areas ---
function areasConfig() {
    this.list = new Array();
}


// --------------------------------------
// --- add new Data to questionsData array ---
function addQuestionData(data) {
    questionsData[questionsData.length] = data;
}

// ----------------------------------
// --- get question of given quid ---
function getQuestionData(id) {    
    for (i=0; i<questionsData.length; i++) {
        if (questionsData[i].id == id) {
            return questionsData[i];
        }
    }
    return null;
}


/**********************common functions for drag questions****************************/
/*
retrieves question qid
@param element is node to search .
@param target is id or peace of it to search for.
*/
function getQidFromNode(element, target) {
	var found = false;
	if (typeof(element) != "undefined") {
		if (typeof(element.id) != "undefined" && element.id.indexOf(target) >= 0) {
			found = true;
		}
		
		while (!found && element.parentNode) {
			if (typeof(element.id) != "undefined" && element.id.indexOf(target) >= 0) {
				found = true;
				break;
			}
			
			element = element.parentNode;
		}
		
		if (!found) {
			element = findChildNode(element, target);
		}
		
		if (element !=null && typeof(element.id) != "undefined") {
			return qid = element.id.substr(target.length);
		} 		
	}
	return null;
}

/*
@param element is node to search in.
@param target is id or peace of it to search for.
*/
function findChildNode(element, target){
	try{
		var descendant = element.getElementsByTagName('*');

			for (var i=0;i < descendant.length;i++) {
				if (typeof(descendant[i].id) != "undefined" && descendant[i].id.indexOf(target) >= 0) {
					return descendant[i];
			}
		} 
	} catch(e) {
		return null;
	}
	return null;
}

function getAllSources(qid) {
	// check the match only for non distractor elements
	var destinations = new Array();
	var matches = getQuestionData(qid).getParamValue("dragMatches");
	var i = 0;
	//destinations are each even element in array
	while (i < matches.length - 2) {
		destinations[i/2] =  matches[i];
		
		i = i + 2;
	}
	
	return destinations;
}

// get all destination elements
function getAllDestinations(qid) {
	// check the match only for non distractor elements
	var destinations = new Array();
	var matches = getQuestionData(qid).getParamValue("dragMatches");
	var i = 0;
	//destinations are each even element in array
	while (i < matches.length - 2) {
		destinations[i/2] =  matches[i+1];
		
		i = i + 2;
	}
	
	return destinations;
}

function getDestinationElement(qid, elemId) {
	// check the match only for non distractor elements
	var DISTRACTOR_TYPE = getQuestionData(qid).getParamValue("distractorType");
	if (elemId.substring(0, 10) != DISTRACTOR_TYPE) {

		var matches = getQuestionData(qid).getParamValue("dragMatches");
		// get matched element 
		for (var i=0; i < matches.length; i++) {
			if (matches[i] == elemId) {
				return byId(matches[i+1]);
			}
		}			
	} else {
		return null;
	}
	return null;	
}

function snapBack(qid, what, startX, startY, endX, endY, steps) {
	if (qid != null){
		var questionData = getQuestionData(qid);
		var _dragElement = questionData.getParamValue(what);	
		var snapCurrent = questionData.getParamValue("snapCurrent")+1;
		questionData.setParam("snapCurrent", snapCurrent);
		
		if (snapCurrent == 1) {
			var multi = 0;
		} else {
			var multi = (1 - Math.pow(0.9, snapCurrent - 1)) / (1 - Math.pow(0.9, steps - 1));
		}

		var snapX = endX + (startX - endX) * multi;
		var snapY = endY + (startY - endY) * multi;
		
		// Move layer to new position		
		if (_dragElement!= null) {
			_dragElement.style.left = (snapX) + 'px';
			_dragElement.style.top = (snapY) + 'px';
			questionData.setParam(what,_dragElement);	
		}

		// Have we done all the "steps"?
		if (snapCurrent == steps) {
			clearInterval(questionData.getParamValue("snapTimer"));
			_dragElement=null;
			questionData.setParam(what,_dragElement);	
		}
		questionData.setParam("snapX", snapX);
		questionData.setParam("snapY", snapY);
	}
}
	
function snapBackAll(qid, startsName, endsName, steps) {
	var questionData = getQuestionData(qid);
	var snapCurrent = questionData.getParamValue("snapCurrent")+1;
	var starts = questionData.getParamValue(startsName);
	var ends = questionData.getParamValue(endsName);
	questionData.setParam("snapCurrent",snapCurrent);
	
	// Have we done all the "steps"?
	if (snapCurrent == steps) {
		clearInterval(questionData.getParamValue("snapTimer"));
	}
	
	var sources = getAllSources(qid);
	for (var i = 0; i < sources.length; i++) {
		var multi;
		if (snapCurrent == 1) {
			multi = 0;
		} else {
			multi = (1 - Math.pow(0.9, snapCurrent - 1)) / (1 - Math.pow(0.9, steps - 1));
		}

		var startX = parseInt(starts[i].X);
		var startY = parseInt(starts[i].Y);
		var endX = parseInt(ends[i].X);
		var endY = parseInt(ends[i].Y);
		var snapX = endX + (startX - endX) * multi;
		var snapY = endY + (startY - endY) * multi;

		var target = byId(sources[i]);
		// Move layer to new position		
		if (target != null) {
			target.style.left = (snapX) + 'px';
			target.style.top = (snapY) + 'px';
		}	
	}
}

function restorePosition(qid, beginning_x, beginning_y, e) {
	var questionData = getQuestionData(qid);
	var _startX = questionData.getParamValue("startX");	
	var _startY = questionData.getParamValue("startY");	
	var _offsetX = questionData.getParamValue("offsetX");	
	var _offsetY = questionData.getParamValue("offsetY");		
	questionData.setParam("snapEndX", parseInt(beginning_x));
	questionData.setParam("snapEndY", parseInt(beginning_y));
	questionData.setParam("snapCurrent",0);
	
	if (e == null) 
		var e = window.event;
	questionData.setParam("dropX", _offsetX + e.clientX - _startX);	
	questionData.setParam("dropY", _offsetY + e.clientY - _startY);	
	
	// to make possible quick click on button ( switching between show user res -> show correct)
	clearInterval(questionData.getParamValue("snapTimer"));
	
	var snapTimer = setInterval("snapBack('" +qid + "','dragElement'," + questionData.getParamValue('snapEndX') + "," + questionData.getParamValue('snapEndY') + "," + getQuestionData(qid).getParamValue('dropX') + "," + getQuestionData(qid).getParamValue('dropY')+ ",15)", 10);		
	questionData.setParam("snapTimer", snapTimer);
}

function restoreAllPositions(qid) {
	var questionData = getQuestionData(qid);
	
	// to make possible quick click on button ( switching between show user res -> show correct)
	clearInterval(questionData.getParamValue("snapTimer"));
	
	var snapTimer = setInterval("snapBackAll('" +qid + "','startPositions','userPositions',15 )", 10);
	questionData.setParam("snapTimer", snapTimer);
}

function showUserAnswer(qid) {
	var questionData = getQuestionData(qid);
	
	// to make possible quick click on button ( switching between show user res -> show correct)
	clearInterval(questionData.getParamValue("snapTimer"));
	
	var snapTimer = setInterval("snapBackAll('" +qid + "','userPositions','startPositions',15 )", 10);
	questionData.setParam("snapTimer", snapTimer);
	setButtonTitle(qid, langShowSolution);	
}

function setButtonTitle(qid, title) {
	var button = byId(qid + "_submitBtn")
	if (button != null && typeof(button) != 'undefined') {
		button.value = title;
	}
}

function changeSpotsOnTarget(qid, destination, value) {
	var questionData = getQuestionData(qid);
	var destinations = getAllDestinations(qid);
	var spotsOnTarget = questionData.getParamValue("spotsOnTarget");	
	for(var i=0; i < destinations.length; i++) {
		if (destination == destinations[i]) { 
			spotsOnTarget[i] = spotsOnTarget[i] + value;
		}
	}
	questionData.setParam("spotsOnTarget",spotsOnTarget);
}

function getSpotsOnTarget(qid, destination) {
	var questionData = getQuestionData(qid);
	var destinations = getAllDestinations(qid);
	var spotsOnTarget = questionData.getParamValue("spotsOnTarget");	
	for(var i=0; i < destinations.length; i++) {
		if (destination == destinations[i]) { 
			return spotsOnTarget[i];
			break;
		}
	}
}

/*Cleans array with spots on target counter*/
function clearSpotsOnTarget (qid) {
	var questionData = getQuestionData(qid);
	var destinations = getAllDestinations(qid);
	var spotsOnTarget = questionData.getParamValue("spotsOnTarget");	
	for(var i=0; i < destinations.length; i++) {
			spotsOnTarget[i] = 0;
	}
	questionData.setParam("spotsOnTarget",spotsOnTarget);
}

/**********************common functions for drag questions****************************/