/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/


var MIN_TEXT_WIDTH = 100;
scorableContent = true;   //Used by CRE to determine if the page is scorable               // defined in questions.js
IMAQ = true
var isQuestionDone = false;

var imaquestions = new Array();
var outlinemaps = new Array();
var offsets = new Array();
var j$ = jQuery.noConflict();
var selectedArea = null;

function InitImaHotSpotMD()
{
    addEvent(document, 'mousedown', imaMDDrawFigure);
}

function InitImaHotSpotMO()
{
    addEvent(document, 'mouseover', imaMDDrawFigure);
}

function InitImaLoadHotSpotMD()
{
    addEvent(document, 'mousedown', imaOnMouseDown);
}

function InitImaLoadHotSpotMO()
{
    addEvent(document, 'mouseover', imaOnMouseDown);
}

function hideAll() {
	for (var i=0; i < HOT_SPOT_COUNT; i++) {
		var elem = document.getElementById('divLinkSpot' + i);
		if (typeof(elem) != 'undefined') {
			elem.style.visibility = 'hidden';
			elem.style.display = 'none';
		}
		//TODO: Add multi flash objects support (on the same page in IE)
		var flashMovie = getFlashMovieObject("FlashMovie");

		if (flashMovie != null && typeof(flashMovie) != 'undefined') {
			for (var k=0; k < flashMovie.length; k++) {
				if (isDecendant(flashMovie[k], elem)) {				
					try {
						flashMovie[k].Rewind();
					}
					catch(err) {
					}
				}
			}
		}
	}
	for(var i=0; i<outlinemaps.length; i++)
		if(outlinemaps[i] != null)
			outlinemaps[i].clear();
}

function paintOutlineMaps(target,index){
	var coordsmas = target.coords;
	if (coordsmas == null || typeof(coordsmas) == 'undefined') return;
	var coords = coordsmas.split(',');
	
	if(target.shape.toLowerCase() == "rect") {
		outlinemaps[index].drawRect(parseInt(coords[0]) + parseInt(offsets[index]), parseInt(coords[1]), coords[2]-coords[0], coords[3]-coords[1]);
	}
	if(target.shape.toLowerCase() == "circle")
		outlinemaps[index].drawEllipse((coords[0]-coords[2]) + parseInt(offsets[index]), coords[1]-coords[2], 2 * parseInt(coords[2]), 2 * parseInt(coords[2]));
	if(target.shape.toLowerCase() == "poly") {
		var xs = new Array();
		for(var i=0; i<coords.length/2; i++)
			xs[i] = parseInt(coords[2*i]) + parseInt(offsets[index]);
			var ys = new Array();
			for(var i=0; i<coords.length/2; i++)
				ys[i] = parseInt(coords[2*i+1]);
				outlinemaps[index].drawPolygon(xs, ys);
			}
		outlinemaps[index].paint();
}

function playFlashMovie(){
	var flashMovie = getFlashMovieObject("FlashMovie");
	if (flashMovie != null && typeof(flashMovie) != 'undefined') {
		if (flashMovie != null && typeof(flashMovie) != 'undefined') {
			for (var k=0; k < flashMovie.length; k++) {
				if (isDecendant(flashMovie[k], element)) {					
					try {
						flashMovie[k].Play();
					}
					catch(err) {
					}
				}
			}
		}
	}
}

function imaOnMouseDown(e)
{  
    // IE is retarded and doesn't pass the event object
    if (e == null)
        e = window.event; 	
    // IE uses srcElement, others use target
    var target = e.target != null ? e.target : e.srcElement;
    var id = target.id;
	
	if (typeof(id) == "undefined" || id.indexOf("LinkSpot") != 0)
		return;
	id = 'div' + id;
	var element = document.getElementById(id);
	if (typeof(element) == 'undefined') {
	    return;
	}
	// for IE, left click == 1
    // for Firefox, left click == 0
    if (e.button == 1 && window.event != null || e.button == 0)
    {                  
          // grab the mouse position
          var posx = 0;
          var posy = 0;
          if (!e) var e = window.event;
          if (e.PageX || e.PageY) {
               posx = e.PageX;
               posy = e.PageY;
          }
          else if (e.clientX || e.clientY) {
               posx = e.clientX + document.documentElement.scrollLeft;
               posy = e.clientY + document.documentElement.scrollTop;
          }
		posx += 10;
		posy += 10; //target.offsetHeight*2/3;		
		var width = target.offsetWidth;		
		if (element.innerHTML.length > MIN_TEXT_WIDTH && width < MIN_TEXT_WIDTH)
			width = MIN_TEXT_WIDTH * 2;
		
		if (DISPLAY_AREA_SPECIFIED != null && DISPLAY_AREA_SPECIFIED) {
			element.className= 'shownContent';
			element.style.display = 'block';
			element.style.visibility = 'visible';
		} 
		/*else {		
			element.style.display = 'block';
			element.style.visibility = 'visible';
			element.style.left = posx - element.offsetParent.offsetLeft + "px";		
			element.style.top = posy - element.offsetParent.offsetTop + "px";		
			
		}
		*/
		// To play flash under IE
		playFlashMovie();
		return target;
    }
}

function imaMDDrawFigure(e)
{  
    var target = imaOnMouseDown(e);
    drawFigure(target, false, true);	
}


function drawFigure(target, isRemoveMouseDownEventEnabled, isClearOther) {
	
	if (typeof(target) == "undefined" || target == null) return;
	var index = parseInt(target.parentNode.name.substring(3));

	if(outlinemaps[index] != null) {
		if(isClearOther) 
			outlinemaps[index].clear();
		paintOutlineMaps(target,index);
	}
	
	if (isRemoveMouseDownEventEnabled) {
		removeEvent(document, 'mousedown', imaMDDrawFigure);
		removeEvent(document, 'mouseover', imaMDDrawFigure);
	}
}

function getOffset(element, wrap)
{
	if(element.children) {
		for(var i=0; i<element.children.length; i++)
		{
			if(element.children[i].tagName == "IMG")
			{
				return element.children[i].offsetLeft;
			}
		}
	} else {
		var children = element.childNodes;
		for(var i=0; i<element.childNodes.length; i++)
		{
			if(element.childNodes[i].tagName == "IMG")
			{
				return element.childNodes[i].offsetLeft;
			}
		}
	}
	return 0;
}

function imDrawLinkSpot(id)
{
    var target = document.getElementById(id);
	if (typeof(target) == "undefined" || target == null) return;
	var index = parseInt(target.parentNode.name.substring(3));
	if(outlinemaps[index] != null) {
		paintOutlineMaps(target,index);
	}
}

function showContent(elemID) {	
	
	// NOT IMPLEMENTED FOR MOUSE OVER

/*	var element = document.getElementById(elemID);
	if(typeof(element) == 'undefined')	
	    return;
	
	hideAll();
	
	if (DISPLAY_AREA_SPECIFIED != null && DISPLAY_AREA_SPECIFIED) {
			element.className= 'showedContent';
			element.style.display = 'block';
			element.style.visibility = 'visible';
		} else {		
			element.style.display = 'block';
			element.style.visibility = 'visible';
			element.style.left = posx + "px";		
			element.style.top = posy + "px";		
			element.style.width = width + "px";
		}*/
}

function ImageMapAssessmentQuestion()
{
    this.randomize = false;
    this.redraw = function ()
        {
            //redraw the attempts left (as it goes from XSLT so the number is incorrect)
            var at = document.getElementById(this.guid + "_at_limit"); // change text node informing of remaining attempts
	
			if (this.attempts == 1) 
				at.firstChild.nodeValue = document.langYouHave + " " + this.attempts + " " + document.langAttemptRemaining + ". ";
			else  
				at.firstChild.nodeValue = document.langYouHave + " " + this.attempts + " " + document.langAttemptsRemaining + ". ";
				
           
            //evaluate question
            //if question is done, add +1 attempt and call handleWebImageMapAssessment Activity 
            //  to render the question result. Attempts are decreased in this function by 1   
            //if question is not done yet (there are some spare attempts)
            //  show the clear checkboxes, right attempts 
            //  ommitted (AND all hints which were shown before)
            if (this.attempts == 0 || this.result == "correct") {
			
			
				var userAnswer = this.userAnswer.substr(3);
				var elem = document.getElementById(userAnswer);
				drawFigure(elem, true);
				
                this.attempts = this.attempts + 1; //increase attempts as handle ImageMapAssessmentActivity 
                                                   //will decrease it back when evaluating
				handleImageMapAssessment(this.userAnswer, this.guid, "", true);
            }
        }
}

// Extend basic Question type
ImageMapAssessmentQuestion.prototype = new Question;

// --------------------------------------
// --- add question to question array ---
function addImageMapAssessmentQuestion(question)
{
    imaquestions[imaquestions.length] = question;
    addQuestion(question);
}

// -------------------------------------------------
// --- set parameters for all questions in array ---
function setImageMapAssessmentQuestions()
{
    for (l=0; l<document.forms.length; l++) {
        var fname = document.forms[l].name;     
        if (fname.toLowerCase().indexOf("questionform") == -1) continue;
        var fid = document.forms[l].id;
        if (fid.toLowerCase().indexOf("imagemapassessment") == -1) continue;

        var wab_id = fname.substr(13);
        
        var wab_obj = document.getElementById("wab_"+wab_id);
        newImageMapAssessmentQuestion = new ImageMapAssessmentQuestion();
        newImageMapAssessmentQuestion.setParam("guid", wab_id);
        var params = wab_obj.attributes;    
        var param;

        newImageMapAssessmentQuestion.setParam("attempts", 
                wab_obj.getAttribute("data-wab_AttemptLimit"));      
        newImageMapAssessmentQuestion.setParam("showHint", 
                wab_obj.getAttribute("data-wab_ShowHint"));  
        newImageMapAssessmentQuestion.setParam("showFeedback", 
                wab_obj.getAttribute("data-wab_ShowFeedback"));  
        newImageMapAssessmentQuestion.setParam("showAdvice", 
                wab_obj.getAttribute("data-wab_showAdvice")); 				
        newImageMapAssessmentQuestion.setParam("hintActive", 
                wab_obj.getAttribute("data-wab_hint_active"));       
        newImageMapAssessmentQuestion.setParam("corectAnswer", 
                wab_obj.getAttribute("data-wab_correct_answer"));
        newImageMapAssessmentQuestion.setParam("rollupWeight", 
                wab_obj.getAttribute("data-wab_RollupWeight"));

        addImageMapAssessmentQuestion(newImageMapAssessmentQuestion);
    }
}

// ------------------------------------------------------------
// --- handling submited form of ImageMapAssessmentquestion ---
function handleImageMapAssessment(chosenAnwId, qid, msg, redraw)
{
	// ---imagemapquiz variables---
	var doneBtn = document.getElementById(qid + "_doneBtn");
	// ---imagemapquiz variables---

	var currentQuestion = getQuestion(qid);
	var at_limit = currentQuestion.getParamValue("attempts");
	
	getQuestion(qid).setParam("userAnswer", chosenAnwId);
	var anws = currentQuestion.getParamValue("corectAnswer"); // get correct answer(s)
	
	anws = anws.split("|"); // split them by "|" to the anws array
	var sfeedback = getFeedbackMode(currentQuestion);	
	var showAdvice = currentQuestion.getParamValue("showAdvice");	

	var qmatch = false;
	for (var i=0; i < anws.length; i++) {
		var anw = anws[i];
		if (chosenAnwId == anw) {
			qmatch = true;
			break;
		} 
	}
	if (qmatch == true) { /////////// CORRECT ANSWER!
		isQuestionDone = true;
		currentQuestion.setParam("result", "correct"); // set question result
		setDisabled(qid); // mark question options disabled
		removeOnMouseEventsFromLinks() ; 
		if (doneBtn != null) {
			show(qid + "_doneBtn");
			doneBtn.disabled = false;
		}
	} else { ///////// INCORRECT ANSWER! (not all correct anws checked or one or more incorrect anws)
		
		//if last attempt show also correct answers (depending on feedback) and disable question

		currentQuestion.setParam("result", "incorrect"); // set question result
		if (at_limit <= 1) {
			setDisabled(qid); // mark question options disabled
			removeOnMouseEventsFromLinks();
			if (doneBtn != null) {
				show(qid + "_doneBtn");
				doneBtn.disabled = false;
			}
		}
	}
	
	handleAdvice(qid, showAdvice, at_limit, qmatch); // show Advice  
	handleHint(qid, currentQuestion, at_limit, qmatch); // show Hint
	handleFeedback(qid, sfeedback, at_limit, qmatch); // show Feedback

	//setAttemptLimit(qid,at_limit);  // decrease attempts + update tailed text
	at_limit -= 1;
	currentQuestion.setParam("attempts",at_limit); // set remaining attempts
	var at = document.getElementById(qid + "_at_limit"); // change text node informing of remaining attempts
	at.firstChild.nodeValue = " ";
	var isCorrect = getQuestion(qid).getParamValue("result");
	if (isCorrect != "correct") {
		if (at_limit == 1) {
			at.firstChild.nodeValue = document.langYouHave + " " + at_limit + " "+ document.langAttemptRemaining + ". ";
		} else  {
			at.firstChild.nodeValue = document.langYouHave + " " + at_limit + " "+ document.langAttemptsRemaining + ". ";
		}	
	} 
	
	if (!redraw) {
		currentQuestion.setUserResult();//send result to CRE here!
		setUserResults();
	}
	
} // end of some option was selected   
	
function removeOnMouseEventsFromLinks() {
	for (var i=0; i < HOT_SPOT_COUNT; i++) {
		var elem = document.getElementById('LinkSpot' + i);
		if (elem != null){
			elem.onmouseout = null;
			elem.onmousedown = null;
			elem.onmouseover = null;
		}
	}
	j$('.ImageMapAssessmentBody area').unbind('keydown');
	j$('.ImageMapAssessmentBody area').unbind('focusin');
	hideOutlineMaps();
}
function hideOutlineMaps(){
	for (var i=0; i<outlinemaps.length; i++) {
		if (outlinemaps[i] != null) {
			outlinemaps[i].clear();
		}
	}
}
// -------------------------------
// --- init the whole CRE page ---
function initImageMapAssessmentPage() {   
    setImageMapAssessmentQuestions();
    getUserResults(imaquestions);
}

jQuery(document).ready(function(){
	j$('.ImageMapAssessmentBody area').bind({
		keydown :function(event){
			hideOutlineMaps();
			//space or enter was pressed
			for (var i = 0; i < outlinemaps.length; i++) {
				if (outlinemaps[i] != null) {
					outlinemaps[i].clear();	
				}
			}
			if (event.keyCode == 32 || event.keyCode == 13) {
				var target = event.currentTarget;
				if ( j$.browser.msie && target != null){
					target = selectedArea;
				}
				handleImageMapAssessment("div" + target.id, j$('#' + target.id).attr("questionid"));
				playFlashMovie();
			}
		},
		focusin : function (){
			if ( j$.browser.msie ) {
				selectedArea = this;
			}
			var target = this;
			if (typeof(target) == "undefined" || target == null) {
				return;
			}
			var index = parseInt(target.parentNode.name.substring(3));
			if(outlinemaps[index] != null) {
				paintOutlineMaps(target,index);
			}
		}
	});
});

//window.onload = initQuestionPage();
