/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

scorableContent = true;   //Used by CRE to determine if the page is scorable              
VAQ = true				   // defined in questions.js
var mcquestions = new Array();

// ---------------------------------
// --- definition of Object type ---
function VideoAssessmentQuestion(){
}

// Extend basic Question type
VideoAssessmentQuestion.prototype = new Question;

function getMovie() {
        var M$ =  navigator.appName.indexOf("Microsoft")!=-1
        return (M$ ? window : document)["flash"]
}

function initAll() {
	var movie = getMovie();
	
	if (typeof(movie.sendAnswerStart)== 'undefined') {
		setTimeout("initAll()", 300);
		return;
	}
	
	movie.sendAnswerStart(arrAnswerStart);
	movie.sendAnswerEnd(arrAnswerEnd);
	movie.sendCuePoint(arrCue);
	movie.sendQuestions(arrQuestions);
	movie.sendPath(videoFilePath);
	movie.sendPositiveFeedback(arrPositiveFeedbacks);
	movie.sendNegativeFeedback(arrNegativeFeedbacks);
}

function sortByCue() {
	var temp;
    for ( i = 0; i < (arrCue.length - 1); i++) {
         for(j = 1; j < arrCue.length; j++) { 
             if (arrCue[j] < arrCue[j-1]) {
				// swap cue
				temp = arrCue[j];
				arrCue[j] = arrCue[j-1];
				arrCue[j-1] = temp;
				
				// swap other
				temp = arrAnswerStart[j];
				arrAnswerStart[j] = arrAnswerStart[j-1];
				arrAnswerStart[j-1] = temp;				
				
				temp = arrAnswerEnd[j];
				arrAnswerEnd[j] = arrAnswerEnd[j-1];
				arrAnswerEnd[j-1] = temp;				
				
				temp = arrQuestions[j];
				arrQuestions[j] = arrQuestions[j-1];
				arrQuestions[j-1] = temp;
				
				temp = arrPositiveFeedbacks[j];
				arrPositiveFeedbacks[j] = arrPositiveFeedbacks[j-1];
				arrPositiveFeedbacks[j-1] = temp;
				
				temp = arrNegativeFeedbacks[j];
				arrNegativeFeedbacks[j] = arrNegativeFeedbacks[j-1];
				arrNegativeFeedbacks[j-1] = temp;
			}
		}
	}
}

// --------------------------------------
// --- add question to question array ---
function addVideoAssessmentQuestion(question) {
    mcquestions[mcquestions.length] = question;
    addQuestion(question);
}

// -------------------------------------------------
// --- set parameters for all questions in array ---
function setVideoAssessmentQuestions() {
  
  for (l=0; l<document.forms.length; l++) {
        var fname = document.forms[l].name;     
        if (fname.toLowerCase().indexOf("questionform") == -1) continue;
        var fid = document.forms[l].id;
        if (fid.toLowerCase().indexOf("webvideoassessment") == -1) continue;

        var wab_id = fname.substr(13);
        
        var wab_obj = document.getElementById("wab_" + wab_id); 
		
		newVideoAssessmentQuestion = new VideoAssessmentQuestion();

		newVideoAssessmentQuestion.setParam("guid", wab_id);
		
        var params = wab_obj.attributes;    
        var param;
		
        newVideoAssessmentQuestion.setParam("attempts", 0);      
        newVideoAssessmentQuestion.setParam("showFeedback", "false");      
        newVideoAssessmentQuestion.setParam("corectAnswer", "true");
        newVideoAssessmentQuestion.setParam("rollupWeight", wab_obj.getAttribute("wab_RollupWeight"));
		
        addVideoAssessmentQuestion(newVideoAssessmentQuestion); 
    }	
}

// ------------------------------------------------------------
// --- handling submited form of WebVideoAssessment question ---
function handleWebVideoAssessmentActivity(qid, msg, redraw) {

	var movie = getMovie();

	if (typeof(qid)== 'undefined' || typeof(movie)== 'undefined' || typeof(movie.sendAnswerStart)== 'undefined') {
		setTimeout("handleWebVideoAssessmentActivity('"+qid+"','"+msg+"', '"+redraw+"')", 300);
		return;
	}
	
	var currentQuestion = getQuestion(qid);
	var doneBtn = document.getElementById(qid + "_doneBtn");

	currentQuestion.setParam("userAnswer", movie.getQuestionStatus()+"|");
	currentQuestion.setParam("attempts", 0);
	
	if (movie.getQuestionStatus()) {
		currentQuestion.setParam("result", "correct");
	} else {
		currentQuestion.setParam("result", "incorrect");
	}

	setDisabled(qid);		
	
	if (doneBtn != null) {
		show(qid + "_doneBtn");
		doneBtn.disabled = false;
	}	
	
	if (!redraw) {
		currentQuestion.setUserResult();//send result to CRE here!
		setUserResults();
	}	
}

// -------------------------------
// --- init the whole CRE page ---

function initVideoAssessmentPage() {   
    setVideoAssessmentQuestions();
    getUserResults(mcquestions);
}