/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/
	DNDSQ = true;               // defined in questions.js
	var dndsquestions = new Array();

	var buttonState = "Submit";
	//notifications
	var langAttemptRemaining = typeof(document.langAttemptRemaining)!='undefined' ? document.langAttemptRemaining : CRE_Frame.document.langAttemptRemaining;
	var langAttemptsRemaining = typeof(document.langAttemptsRemaining)!='undefined' ? document.langAttemptsRemaining : CRE_Frame.document.langAttemptsRemaining;
	var langShowSolution = typeof(document.langShowSolution)!='undefined' ? document.langShowSolution : CRE_Frame.document.langShowSolution;
	var langSubmit = typeof(document.langSubmit)!='undefined' ? document.langSubmit : CRE_Frame.document.langSubmit;
	var langUserAnswer = typeof(document.langUserAnswer)!='undefined' ? document.langUserAnswer : CRE_Frame.document.langUserAnswer;
	var langReset = typeof(document.langReset)!='undefined' ? document.langReset : CRE_Frame.document.langReset;
	
	var correctOrder=[];
	var randomOrder=[];
	var user_answer=[];
	var storedAnswer=[];
	//var qid=null;
	var currentQuestion = null;
	var j$ = jQuery.noConflict();
	
jQuery.fn.extend({ 
	//prevent the user from selecting text while dragging sortable LIs
	preventTextSelection : function() { 
		this.each(function() { 
			this.onselectstart = function() { return false; }; 
			this.unselectable = "on"; 
			jQuery(this).css('-moz-user-select', 'none'); 
		}); 
	} 
});

function returnAttr(selected, obj){
	var attr = j$(selected).attr(obj);
	return (typeof attr=='undefined' || attr=='undefined') ? null : attr;
}

DNDSQuestion.prototype = new Question;
	
function addDNDSQuestion(question) {
	dndsquestions[dndsquestions.length] = question;
	addQuestion(question);
}
	
function initDNDSPage() { 
    setDNDSQuestions();
	getUserResults(dndsquestions);
}


function setDNDSQuestions() {
	jQuery(".SequenceActivity form[id*='WebDNDSequenceActivity'] input.WebActivityBehavior").each(function(i, selected){ 
		
		var qid = j$(selected).attr('id').replace('wab_','');

		var isAssessment = (returnAttr(selected, 'wab_Mode')=='Practice') ? false : true;
			
		newDNDSQuestion = new DNDSQuestion();
		newDNDSQuestion.setParam("guid",			qid);
		newDNDSQuestion.setParam("mode",			returnAttr(selected, "wab_Mode"));
		newDNDSQuestion.setParam("attempts",		returnAttr(selected, "wab_AttemptLimit"));
		newDNDSQuestion.setParam("showHint",		returnAttr(selected, "wab_ShowHint"));
		newDNDSQuestion.setParam("showAdvice",	returnAttr(selected, "wab_showAdvice"));
		newDNDSQuestion.setParam("showFeedback",	returnAttr(selected, "wab_ShowFeedback"));
		newDNDSQuestion.setParam("hintActive",	returnAttr(selected, "wab_hint_active"));
		newDNDSQuestion.setParam("showSolution",	returnAttr(selected, "wab_dnd_showsolution"));
		newDNDSQuestion.setParam("rollupWeight",	returnAttr(selected, "wab_RollupWeight"));
		newDNDSQuestion.setParam("corectAnswer",	returnAttr(selected, "wab_correct_answer"));
		newDNDSQuestion.setParam("buttonState",	"Submit");
		
		addDNDSQuestion(newDNDSQuestion);
		if (!isAssessment) {
			API.Terminate("");
		}	
		sortOptions(qid);
	
	});
}

function DNDSQuestion() {
    this.redraw = function () {
		sortOptions(this.guid);
	};
}

function sortOptions(qid){
	currentQuestion = getQuestion(qid);
	correctOrder = currentQuestion.getParamValue('corectAnswer');//get the items in the correct order
	correctOrder = correctOrder.substring(0,correctOrder.length-1).split('|');//get rid of trailing pipe

	//prepare a randomized order option for the LIs
	randomOrder = correctOrder.slice(0);
	while (randomOrder[0]==correctOrder[0] || randomOrder[correctOrder.length-1]==correctOrder[correctOrder.length-1]) {
		randomOrder = randomOrder.sort(randomSort);							 
	}
	
	currentQuestion.setParam("randomOrder", randomOrder);
	
	//prepare a stored userAnswer order option for the LIs
	var at_limit = parseInt(currentQuestion.getParamValue("attempts"));
	storedAnswer = currentQuestion.getParamValue("userAnswer");//has an answer already been submitted?
	if (storedAnswer != null){
		storedAnswer=storedAnswer.substring(0,storedAnswer.length-1).split('|');
	} else {
		storedAnswer = [];
	}
	if (storedAnswer.length > 0){
		if (storedAnswer.join(',')==correctOrder.join(',') || at_limit<1) {
			redraw(storedAnswer,at_limit, qid);
		} else {
			redraw(randomOrder,at_limit, qid);
		}
	}
	else {
		draw(qid);
	}
}

function draw(qid){
	j$('#sortableList_' + qid).sortable({
		axis:'y',
		stop: function(event, ui){
			redrawLIStyle();
		}
	});

	var maxHeight = 0;
	j$.each(correctOrder,function(key,value){
		if (j$('#' + value).height() > maxHeight){
			maxHeight = j$('#' + value).height();
		}
		
		j$('#link' + value).keydown(function(event){
			if (event.keyCode == 38 || event.keyCode == 40) {
				if (event.keyCode == 40){
					j$('#' + this.parentNode.id).insertAfter(j$('#' + this.parentNode.id).next());
				} else{
					j$('#' + this.parentNode.id).insertBefore(j$('#' + this.parentNode.id).prev());
				}
				j$('#' + this.parentNode.id).css('opacity', '0.01');
				j$('#' + this.parentNode.id).animate({ opacity: '1' }, 500 );
				redrawLIStyle();
				j$('#sortableList_' + qid).sortable('refresh');				
				this.focus();
			}
		});
	});
	maxHeight-=10;
	j$("#sortableList_" + qid + " li a div[id*='dnds_source_item']").css('height', maxHeight + 'px');	
	redrawLIStyle();
	j$('#sortableList_' + qid).sortable('refresh');
}

function redraw(optionOrder,at_limit, qid){
	j$.each(optionOrder,function(key,value){
		j$('#'+value).appendTo(j$('#sortableList_' + qid));
	});
	setAttemptText(at_limit, qid)
	//evaluate question
	currentQuestion = getQuestion(qid);	
	if (at_limit == 0 || currentQuestion.result == "correct") {
		
		currentQuestion.attempts = at_limit + 1; //increase attempts as handleWebDNDSActivity 
		                                   //will decrease it back when evaluating
		handleWebDNDSActivity(qid, true);
	    }
}

function randomSort(a,b) {
	//randomizes the order of the distractors
    var temp = parseInt( Math.random()*10 );
    var isOddOrEven = temp%2;
    var isPosOrNeg = temp>5 ? 1 : -1;
    return(isOddOrEven*isPosOrNeg);
}

function redrawLIStyle() {
	j$("ul[id*='sortableList'] li:odd a div").removeClass("Dark").addClass("Light");
	j$("ul[id*='sortableList'] li:even a div").removeClass("Light").addClass("Dark");
} 

function handleWebDNDSActivity(qid, redraw) {//executed when the submit button is clicked
	var submitBtn = document.getElementById(qid + "_SubmitButton");
	var doneBtn = document.getElementById(qid + "_doneBtn");
	currentQuestion = getQuestion(qid);	
	correctOrder = currentQuestion.getParamValue('corectAnswer');//get the items in the correct order
	correctOrder = correctOrder.substring(0,correctOrder.length-1).split('|');//get rid of trailing pipe
	user_answer = currentQuestion.getParamValue("userAnswer");
	if(user_answer)
		user_answer = user_answer.substring(0,user_answer.length-1).split('|');//get rid of trailing pipe
	randomOrder = currentQuestion.getParamValue('randomOrder');
	buttonState = currentQuestion.getParamValue('buttonState');

	if (buttonState == "Submit"){
		evalSubmit(qid, redraw);
	} else if (buttonState == "Reset") {
		j$.each(randomOrder,function(key,value){
			j$('#'+value).appendTo(j$('#sortableList_' + qid));
		});
		j$("#"+qid+"_feedback_q_ir_try").css({
			"display" : "none",
			"visibility" : "hidden"
		});

		buttonState = "Submit";
		currentQuestion.setParam('buttonState','Submit');
		setButtonTitle(qid, langSubmit);
		//re-enable dragging of LIs
		j$('#sortableList_' + qid).sortable('option','disabled', false );
		redrawLIStyle();
	} else if (buttonState == "ShowUser") {
		j$.each(user_answer,function(key,value){
			j$('#'+value).appendTo(j$('#sortableList_' + qid));
		});
		buttonState = "ShowCorrect";
		currentQuestion.setParam('buttonState','ShowCorrect');
		setButtonTitle(qid, langShowSolution);
		redrawLIStyle();
		if (doneBtn != null) {
				doneBtn.style.marginLeft = "0px";
				show(qid + "_submitBtn");
				show(qid + "_doneBtn");
				doneBtn.disabled = false;
			}
	} 
	else if (buttonState == "ShowCorrect") {
		j$.each(correctOrder,function(key,value){
			j$('#'+value).appendTo(j$('#sortableList_' + qid));
		});
		buttonState = "ShowUser";
		currentQuestion.setParam('buttonState','ShowUser');
		setButtonTitle(qid, langUserAnswer);
		redrawLIStyle();
		if (doneBtn != null) {
				doneBtn.style.marginLeft = "0px";
				show(qid + "_submitBtn");
				show(qid + "_doneBtn");
				doneBtn.disabled = false;
			}
	}
}

function evalSubmit(qid, redraw){//if (buttonState == "Submit")
	var doneBtn = document.getElementById(qid + "_doneBtn");
	
	var at_limit = parseInt(currentQuestion.getParamValue("attempts"));
	at_limit--;

	var sfeedback = getFeedbackMode(currentQuestion);

	var showAdvice = currentQuestion.getParamValue("showAdvice");

	//record the user's answer
	user_answer = [];
	j$('#sortableList_' + qid + ' li').each(function(){
		user_answer.push(j$(this).attr('id'));							
	});
	currentQuestion.setParam("userAnswer", user_answer.join('|')+'|');
	//is the user's answer correct?
	var allCorrect = (correctOrder.join(',') == user_answer.join(',')) ? true : false;

	if (allCorrect) {
		//prevent sortables from being dragged
		j$('#sortableList_' + qid).sortable('option','disabled', true );
		
		currentQuestion.setParam("result", "correct"); // set question result
		
		setDisabled(qid); // mark question options disabled
		if (doneBtn != null) {
			show(qid + "_doneBtn");
			doneBtn.disabled = false;
		}
	} else {	
		currentQuestion.setParam("result", "incorrect"); // set question result
		
		if (at_limit != 0) {
			buttonState = "Reset";
			currentQuestion.setParam('buttonState','Reset');
			setButtonTitle(qid, langReset);
		}
		handleIncorrect(at_limit, qid);
	}
	
	handleAdvice(qid, showAdvice, at_limit + 1, allCorrect); // Show Advice // at_limit + 1 for compatibility with other questions, becouse handleAdvice expect what last at_limit value can't be lower then 1; 
	handleHint(qid, currentQuestion, at_limit + 1, allCorrect);
	handleFeedback(qid, sfeedback, at_limit + 1, allCorrect);
	
	if (at_limit < 1){
		j$('#popup_next').css('visibility','visible').show();
	}
	currentQuestion.setParam("attempts",""+at_limit);
	setAttemptText(at_limit, qid);
	if(!redraw){
		 currentQuestion.setUserResult();//send result to CRE here!
		setUserResults();
	}
}

function handleIncorrect(at_limit, qid){
	if (at_limit == 0){	
		//prevent sortables from being dragged
		j$('#sortableList_' + qid).sortable('option','disabled', true );
		
		var saShowSolution = currentQuestion.getParamValue("showSolution") == "true" ? true : false;
		if (saShowSolution) {
			currentQuestion.setParam('buttonState','ShowCorrect');
			setButtonTitle(qid, langShowSolution);
		} else {
			setDisabled(qid);
			var doneBtn = document.getElementById(qid + "_doneBtn");
			if (doneBtn != null) {
				show(qid + "_doneBtn");
				doneBtn.disabled = false;
			}
		}
	}
}

function setAttemptText(at_limit, qid){
	var at = document.getElementById(qid + "_at_limit"); // change text node informing of remaining attempts
	at.firstChild.nodeValue = "";
	var isCorrect = getQuestion(qid).getParamValue("result");
	if (isCorrect != "correct") {
		if (at_limit == 1) 
			at.firstChild.nodeValue = "(" + at_limit + " "+ document.langAttemptRemaining + ")";
		else
			at.firstChild.nodeValue = "(" + at_limit + " "+ document.langAttemptsRemaining + ")";
	}
}

