/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/


// --------------------------------------------------
// JS functions for Questions Web Pages
// --------------------------------------------------
//
var CRE = null;   //reference to main CRE object
var CRE_frame = null;   //reference to main CRE frame
var scorableContent = false;   //Used by CRE to determine if the page is scorable
var questions = new Array();
var SAQ, MCQ, MAQ, FBQ, GridQ, DNDQ, DNDSQ, MatrixQ, BMCQ, IMAQ, VAQ, BDQ, DWA, IMQ, GS, EA, LedgerQ, SHTQ;		   // Types of questions we support. Add new when available!

var resourceId = "resourceId";
// defines browser's type
var isIE  = (navigator.appVersion.indexOf("MSIE") != -1) ? true : false;

//  global variables to use by all questions
var quizWidthMargin = 0;
var quizHeightMargin = 0;

// global variable to define whether question were Initialized or no.
var isQuestionsPageInited = false;

var img_path = "ContentPackages/Core/Transforms/media/";

// server side player type variables
var delay = 12;                          // delay between requests (ms)
var attemptsCounter = 0;                 // maximum amount of attempts to try to load CMI data
var activeRequest = "";
var isVariablesInited = false;

// Constants
var ShowFeedback = {
    all : 'true',
    none : 'false',
    general : 'General Feedback Only'
}
var DescKeys = {
    count : "c",
    arrangement : "a",
    subq : "s",
    flagged : "f"
}

// Check of CRE object   
// PerformanceSupport(HTML) - use own CRE where don't present SE object
var isRealCRE = function(){
  if(CRE && CRE.SE){
    return true;
  }
  return false;
}

// get communication mode from CRE flags or return "false" when PST or preview Page(Topic) level
var clientSide = function(){ return isRealCRE() ? CRE.isClientSide : false; }
var serverSide = function(){ return isRealCRE() ? CRE.isServerSide : false; }

// --- definition of Object type ---
function Question() {
    this.guid = "";
    this.interactionId = ""; 
    this.attempts = 0;
    this.showHint = false;
    this.showFeedback = false;
    this.hintActive = false;
    this.userAnswer = null;
    this.result = null;
    this.corectAnswer = "";
    this.leaveCorrectBetweenAttempts = false;
    this.getParamValue = function(param)
    	{
    	    return this[param];
    	}
    
    this.setParam = function (param, value)
    	{
    	    this[param] = value;
    	}
    
    this.setUserResult = function()
    {
        if(this.userAnswer != null)
            setAnswer(this.guid, this.userAnswer);
        setResult(this.guid, this.result);
        setAttemptCount(this.guid, this.attempts);
        if(!this.isSubQuestion) { // omit image map quiz subquestions
            setQuestionWeight(this.guid, this.rollupWeight);
        } else {
            setQuestionWeight(this.guid, 0);
            setValueToDesc(this.guid, DescKeys.subq, "subq");
        }
        if (isRealCRE()) CRE.updateNavigation();
    }
    this.restoreFlagStatus = function()
    {   
    	if (mode == "review") {
    		jQuery('div[data-guid=' + this.guid + ']').hide();
    	} else {
	        if (getFlagStatus(this.guid) === 'true') {
	           jQuery('div[data-guid=' + this.guid + ']').toggleClass('flagged');
	        }
    	}        
    }
	// for Pastiche app package
    this.checkSubmit = null;
    this.handleActivity = null;
    this.message = null;
	this.title = null;
}


var mode = "";
var initialized = false;
function initQuestionPage(){
	isQuestionsPageInited = true;
	getResourcePageID();
    
    notify("Initialization", "INFO");
    var win;
    if (getRequestParameter("mode") != null){   // Check if we are running from Europa-CRE > ScoreCard
        CRE = window.parent.W_CRE;
        mode = getRequestParameter("mode");
    } else {                                    // Check if we are running in Europa-CRE
        GetCRE(window);
        mode = "";
    }
    GetAPI(window);                         // seems we are running in 3rd party RTE, so get API
	if(mode != "review" && serverSide()){
		CRE.CONNECTOR.newAPIData();
		getAPIData();
	}else{
		isVariablesInited = true;
		initPageWithQuestions();
	}
}

function getAPIData(){
  if(attemptsCounter++ < 1000){

	if(CRE.CONNECTOR.APIData.initialized == null){
		if(activeRequest != "API.Initialize"){
			API.Initialize("");
			activeRequest = "API.Initialize";
		}
		setTimeout(getAPIData,delay)
		return;
	}
	if(CRE.CONNECTOR.APIData.initialized == "false"){
		initialized = true;
	}
	if(CRE.CONNECTOR.APIData.initialized == "true"){
	// Get all interactions parameters data for curent page by one request
		if(CRE.CONNECTOR.APIData.interactions_count == -1){
			if(activeRequest != "getInteractionsData"){
				API.getInteractionsData("");
				activeRequest = "getInteractionsData";
			}
			setTimeout(getAPIData,delay)
			return;
		}
	
	}
	isVariablesInited = true;
	initialized = true;
  }

	if(initialized || attemptsCounter > 1000){
		initPageWithQuestions();
	}
}

function initPageWithQuestions() {
    var result = false;
    var resetScore = false;
	if(mode != "review"){
		if(!serverSide()){
		  result = APIinitialize();
		  resetScore = (APIgetValue("cmi.interactions._count") > 0); //some questions are already answered
		}else{     
			result = CRE.CONNECTOR.APIData.initialized;
			resetScore = (CRE.CONNECTOR.APIData.interactions_count > 0); //some questions are already answered      
		}
	}
    initialized = result=="true" ? true : false;
    
    if (SAQ)  //check if we have SAQuestions
    {   //alert("Go SAQ");
        initSAPage();
    }
    if (MCQ)  //check if we have MCQuestions
    {   //alert("Go MCQ");
        initMCPage();
    }
    if (MAQ)  //check if we have MAQuestions
    {   //alert("Go MAQ");
        initMAPage();
    }
    if (FBQ)  //check if we have FBQuestions
    {   //alert("Go FBQ");
        initFBPage();
    }
	if (GridQ)  //check if we have Grid Questions
    {
        initGridQPage();
    }
	if(DNDQ)
	{
		initDNDPage();
	}
	if(DNDSQ)
	{
		initDNDSPage(); //check if we have Drag and Drop Sequencing Activity Questions
	}
	if(BDQ)
	{
		initBDPage();
	}
	if (MatrixQ)  //check if we have MatrixQuestions
    {  
        initMatrixPage();
    }
	if (BMCQ)  //check if we have BMCQuestions
    {  
        initBMCPage();
    }
	if (IMAQ)  //check if we have ImageMapAssessmentQuestions
    {  
        initImageMapAssessmentPage();
    }
	if (VAQ)  //check if we have VideoAssessmentQuestions
    {  
        initVideoAssessmentPage();
    }
	if (IMQ)  //check if we have ImageMapQuizQuestions
    {  
        initImageMapQuizPage();
    }
	if (GS)  //check if we have GameshowQuestions
    {  
        initGameshowPage();
    }
    if (DWA)  //check if we have DocWriter Activity
    {  
        initDocWriterPage();
    }
	if (EA)  //check if we have Easy Activity
    {  
        initEAPage();
    }
    if (LedgerQ) { //check if we have Ledger Activity
        initLedgerPage();
    }    
	if (SHTQ) { //check if we have SelectHotText Activity
        initSHTPage();
    }
    if (resetScore) {
        setUserResults();
    }
    if (!hasQuestionsLeft() && mode != "review" && initialized ) {
        APIterminate();

    }
}


// --------------------------------------
// --- add question to questions array ---
function addQuestion(question) {
    //initialize question interaction ID
    var nextId = questions.length + 1;
    question.interactionId = resourceId + "-" + nextId;
    
    questions[questions.length] = question;
}


// ----------------------------------
// --- get question of given quid ---
function getQuestion(guid) {    
    if (questions.length == 0 && !isQuestionsPageInited) {
        initQuestionPage();
    }
   
    for (var i=0; i<questions.length; i++) {
        if (questions[i].guid == guid || questions[i].guid == '_' + guid) {
            return questions[i];
        }
    }
    return null;
}

// --- get question of given quid ---
function getQuestionWithoutInit(guid) {       
    for (var i=0; i<questions.length; i++) {
        if (questions[i].guid == guid || questions[i].guid == '_' + guid) {
            return questions[i];
        }
    }
    return null;
}

function getInteractionIdFromGuid(guid) {
     for (var i=0; i<questions.length; i++) {
        if (questions[i].guid == guid || questions[i].guid == '_' + guid) {
            return questions[i].interactionId;
        }
    }
    return null;
}

function getGuidFromInteractionId(interaction) {
     for (var i=0; i<questions.length; i++) {
        if (questions[i].interactionId == interaction) {
            return questions[i].guid;
        }
    }
    return null;
}

// ---------------------------------------
// --- set number of attemps remaining ---
function setAttemptLimit(qid,at_limit) {
    at_limit -= 1;
    getQuestion(qid).setParam("attempts",at_limit); // set remaining attempts
    var at = document.getElementById(qid + "_at_limit"); // change text node informing of remaining attempts
	at.firstChild.nodeValue = "";
	var isCorrect = getQuestion(qid).getParamValue("result");
	if (isCorrect != "correct") {
		if (at_limit == 1) 
			at.firstChild.nodeValue = "(" + at_limit + " "+ document.langAttemptRemaining + ")";
		else
			at.firstChild.nodeValue = "(" + at_limit + " "+ document.langAttemptsRemaining + ")";		
	}
}

// -----------------------------
// --- get hint if available ---
function getHint(qid,h) {
    var h_array = h.split(".");
    var b=0;
    do b++; //selected hint
    while (h_array[b-1] == 0); // only active hints (value is 1)
    var hint_id = qid + "_hint_" + b;  // create hint_id from qid (question id)
    h_array[b-1] = 0; // set hint as used
    getQuestion(qid).setParam("hintActive",h_array.join("."));
    return hint_id;
}

function getHintActived(qid,h) {
    var h_array = h.split(".");
    var b = 0;
    do b++; //randomly selected hint
    while (h_array[b-1] != 0); // only active hints (value is 1)
    var hint_id = qid + "_hint_" + b;  // create hint_id from qid (question id)
    return hint_id;
}

function getHintContentActived(qid,h) {
    var h_array = h.split(".");
    var b = 0;
    do b++; //randomly selected hint
    while (h_array[b-1] != 0); // only active hints (value is 1)
    var hint_id = qid + "_hint_content_" + b;  // create hint_id from qid (question id)
    return hint_id;
}

function hasQuestionsLeft() {
    var qstn;
	if (questions.length == 0) {
		return false;
	}

    for (var i=0; i < questions.length; i++) {
        qstn = questions[i];
        if (qstn.result != "correct" && qstn.attempts > 0) {
			return true;
        }
    }
    return false;
}

// ------------------------------------
// --- set user score to CRE object ---
function setUserResults() {
    var qstn;
    var totalWeight = 0;
    var totalScore = 0;
	var score = 0;
	var weight = 0;
	var completed = true;

	if (questions.length == 0) {
		notify("No questions", "INFO");
		return;
	}

    for (var i=0; i<questions.length; i++) {
        qstn = questions[i];
		if (qstn.isSubQuestion)
			continue;
		if (qstn.userAnswer == null) {
			completed = false;
			continue;
		}
        if (qstn.result != "correct" && qstn.attempts > 0) {
			completed = false;
			continue;
        }
		weight = (qstn.rollupWeight != null) ? qstn.rollupWeight : 1;
		totalWeight += parseFloat(weight);
		score = (qstn.result == "correct") ? 1 : 0;
		totalScore += score*weight;
	}
    
    if (completed) {
      var weightedScore = totalScore / totalWeight;
      if (totalWeight == 0) // protection from division by zero
        weightedScore = 0;
      notify('QuestionPage: Total Score = ' + weightedScore, "INFO");
      setTotalScore("" + weightedScore);
      APIsetValue("cmi.completion_status", "completed", qstn.guid);
      APIsetValue("cmi.exit", "suspend", qstn.guid);
      disableFlagging();
      APIterminate();
      remindToGo();
    }
}

// --------------------------------------------------------------------
// --- update question object with any existing data present in CRE ---
function getUserResults(questionsGroup){
    var qstn;
    if ((!isRealCRE() && mode != "review") && !isPastiche) {             // this function works for Europa-CRE only!
        return;
    }
	
    for (var i=0; i<questionsGroup.length; i++) {
        qstn = questionsGroup[i];
		
        if (getAnswer(qstn.guid) != null) {
			qstn.userAnswer = getAnswer(qstn.guid);
		}
		
        //Next line is solely for scorecard use
        if (qstn.userAnswer == "") {
			setAnswer(qstn.guid, "");
		}
		
        if (getResult(qstn.guid) != null) {
			qstn.result = getResult(qstn.guid); 
		}
		
        if (getAttemptCount(qstn.guid) != null) qstn.attempts = getAttemptCount(qstn.guid);
        if (qstn.userAnswer != null || (window.ImageMapQuizQuestion && (qstn instanceof ImageMapQuizQuestion)) || (window.GameshowQuestion && (qstn instanceof GameshowQuestion))) qstn.redraw();
        // if flagging is enabled - restore flag status 
        qstn.restoreFlagStatus();
        if(mode == "review") {			// We are in ScoreCard review mode, so disable question.
            setDisabled(qstn.guid);
            CRE.advanceQuestions();		// Advance to next question for review
        }
    }
}

// ------------------------------------------------------------
// --- show form elements - markers, responses, feedback... ---
function show(what, how, Base64) {
    //self.alert("show: "+what);
	var element = document.getElementById(what);
	if (element != null) {
		if (how == null || how == "") how = "block";
		if(Base64){	// if need to decode content
			decodeBase64(jQuery("#" + what));
		}
		element.style.display = how;
		element.style.visibility = "visible";
    }
}

// --------------------------
// --- hide form elements ---
function hide(what) {
    //self.alert("hide: "+what);
    if (document.getElementById(what) != null) {
	document.getElementById(what).style.display = "none";
	document.getElementById(what).style.visibility = "hidden";
    }
}

// --------------------------
//hide all hints
function hideHint(qid){
	var hints = document.getElementsByClassName("Hint");
	for (var i=1; i <= hints.length; i++) {
		hide(qid + "_hint_"+i); 
	}
}

// -----------------------------
// --- set question disabled ---
function setDisabled(qid) {
	if(document.forms["QuestionForm_"+qid]){
		var elms = document.forms["QuestionForm_"+qid].elements;
		for (var i=0; i < elms.length; i++) {
			if (typeof(elms[i].form) == 'undefined' || elms[i].form.name.indexOf(qid) == -1) {
				continue;
			}
			if(elms[i].className != 'AVButton' && elms[i].tagName.toLowerCase() != 'fieldset')  {
				elms[i].disabled = "disabled";
			}
		}
	}
}

// ----------------------------------
// --- fill image to option label ---
function fillImage(id, what) {
    //self.alert("fill/what " + id + "/" + what); //debug
    var elm = document.getElementById(id + "_img_label")
	
    if (elm != null){
	    switch (what){
		case "correct" : 
		elm.setAttribute("src",img_path + "img_102.png");
		break;
		case "incorrect" : 
		elm.setAttribute("src",img_path + "img_101.png");
		break;
		case "also_correct" : 
		elm.setAttribute("src",img_path + "img_103.png");
		break;
		case "also_correct_backward" : 
		elm.setAttribute("src",img_path + "img_104.png");
		break;
		case "transparent" : 
		elm.setAttribute("src",img_path + "img_transp.png");
		break;
	    }
    }
}

// ----------------------------------
// --- decode correct responce ------
function decodeText(what) {
    var magic_no = what.length % 26 + 1;
    var res = new String;
    var a = 'a'.charCodeAt(0);
    var z = 'z'.charCodeAt(0);
    var A = 'A'.charCodeAt(0);
    var Z = 'Z'.charCodeAt(0);
    var str = new String;

    for (var i=0; i < what.length; i++) {
	  var ch = what.substr(i,1).charCodeAt(0);
	  //alert("ch,a,z,magic_no: "+ch+","+a+","+z+","+magic_no); //debug
	  if(ch >= a && ch <= z) {
	    if (ch < (z - magic_no + 1)) 
	      str = String.fromCharCode(ch + magic_no);
	    else
	      str = String.fromCharCode(ch - (z - a) + magic_no - 1);
	  } else if(ch >= A && ch <= Z) {
	    if (ch < (Z - magic_no + 1)) 
	      str = String.fromCharCode(ch + magic_no);
	    else
	      str = String.fromCharCode(ch - (Z - A) + magic_no - 1);
	  } else
	    str = String.fromCharCode(ch);
	  res = res + str;
    }
    //alert("what/res: "+what+"/"+res); //debug
    return res;
}



function getRequestParameter(paramName) {
    var searchStr = window.location.search;
    var paramStr = "&"+paramName+"=";
    var pos = searchStr.indexOf(paramStr);
    if (pos == -1)
    {
        paramStr ="?"+paramName+"=";
        pos = searchStr.indexOf(paramStr);
    }
    if (pos == -1) return null;
    if (searchStr.indexOf("&", pos+1) != -1) 
        return searchStr.substring(pos+paramStr.length, searchStr.indexOf("&", pos+1));
    else 
        return searchStr.substr(pos+paramStr.length); 
}

// API functions

function getAnswer(guid) {
	if (mode == "review") {
		var interactionId = getInteractionIdFromGuid(guid);
	return CRE.getAnswer(interactionId);
	}
	result = APIgetValue("cmi.interactions.#n#.learner_response", guid);
	if(result == -1) return;
	var newResult = createUserAnswerFromInteractionId(guid, result);
	
	return newResult;
}

function setAnswer(guid, userAnswer) {        // cmi.interactions.0.learner_response
	if (mode == "review")
		return;
	
	var newUserAnswer = createUserAnswerFromGuid(guid, userAnswer);
	
	APIsetValue("cmi.interactions.#n#.type", "other", guid, true);
	APIsetValue("cmi.interactions.#n#.learner_response", newUserAnswer, guid);
}

function getResult(guid) {                    // cmi.interactions.0.result
	if (mode == "review"){
		var interactionId = getInteractionIdFromGuid(guid);
		return CRE.getResult(interactionId);
	}
	result = APIgetValue("cmi.interactions.#n#.result", guid);
	if(result == -1) return;  
	return result;
}

function setResult(guid, result) {            // cmi.interactions.0.result
	if (mode == "review")
		return;    
	APIsetValue("cmi.interactions.#n#.result", result, guid);
}

function setQuestionWeight(guid, weight)            // cmi.interactions.0.weighting
{
    if (mode == "review")
		return;
    APIsetValue("cmi.interactions.#n#.weighting", weight, guid);
}

function setArrangement(guid, data) {          // cmi.interactions.0.description - we use "description" 
                                               // to persist individual question attempts
	if (mode == "review")
		return;
	var arrangement = data[0] + "|" + data[1];
	setValueToDesc(guid, DescKeys.arrangement, arrangement, true);
}

function getArrangement (guid){                // cmi.interactions.0.description - we use "description"
                                               // to persist individual question attempts
	if (mode == "review")
		return null;
	
	var res = getValueFromDesc(guid, DescKeys.arrangement);
	if (res === "") return;
	var ar = new Array();
		ar.push(res.substring(0, res.indexOf("|")).split(","));
		ar.push(res.substring(res.indexOf("|") + 1, res.length).split(","));
	return ar;
}

function getAttemptCount(guid) {               // cmi.interactions.0.description - we use "description" 
                                               // to persist individual question attempts
    if (mode == "review")
        return CRE.getAttemptCount(guid);
    var count = getValueFromDesc(guid, DescKeys.count);
    if(count === "") return;
    return parseInt(count);
}

function setAttemptCount(guid, attempts) {     // cmi.interactions.0.description - we use "description"
                                               // to persist individual question attempts
    setValueToDesc(guid, DescKeys.count, attempts);
}

function getFlagStatus(guid) {               // cmi.interactions.0.description - we use "description" 
                                               // to persist flag status
    if (mode == "review")
        return;
    return getValueFromDesc(guid, DescKeys.flagged);
}

function setFlagStatus(guid, status) {     // cmi.interactions.0.description - we use "description"
                                               // to persist flag status
    setValueToDesc(guid, DescKeys.flagged, status);
}

function getTotalScore(guid) {                     // cmi.score.scaled
	result = APIgetValue("cmi.score.scaled", guid);
	if(result == -1) return;
	handleGetError(result);
	return parseFloat(result);
}

	// This method sets the overall normalized score for the page
function setTotalScore(weightedScore) {
	result = APIsetValue("cmi.score.scaled", weightedScore);
	handleError(result);

	// We must update the navigation after the score is changed
	if (isRealCRE()) CRE.updateNavigation();
}

function APIinitialize() {
	var result = API.Initialize("");
	handleError(result);
	initialized = result=="true" ? true : false;
	return result;
}

function APIterminate() {
	var result = API.Terminate("");
	handleError(result);
	if (result == "true" || result == true) initialized = false;
}

function APIsetValue(param, value, guid, createNew) {
  if(/#n#/.test(param)){
    var n = getInteractionIndex(guid, createNew);
    if (n == -1) return;
    param = param.replace('#n#', String(n));
  }

  return API.SetValue(param, value, guid);
}

function APIgetValue(param, guid, createNew) {
    var result;
    if(!serverSide()){
      if(/#n#/.test(param)){
        var n = getInteractionIndex(guid, createNew);
        if (n == -1) return -1;
        param = param.replace('#n#', String(n));
      }
      result = String(API.GetValue(param, guid));
      handleGetError(result);
    }else{  // if serverSide, get data from local storage 
      var interaction = getInteractionIdFromGuid(guid);
      if (!interaction) return -1;
      param = param.substring(param.lastIndexOf(".")+1);
      result = CRE.CONNECTOR.APIData.getValue(param, interaction);
    }
  return result;
}

function getValueFromDesc(guid, key) {
    var description = APIgetValue("cmi.interactions.#n#.description", guid),
        values = {};
    if(description === -1) return "";
    values = jQuery.parseJSON(description);
    return values[key];
}

function setValueToDesc(guid, key, value, createNew) {
    if (mode == "review")
        return;
    var description = APIgetValue("cmi.interactions.#n#.description", guid),
        values = {};
    if(description === -1 || description === " "){
    	// when "description === -1" interaction was not initialized yet
    	if(description === -1) createNew = true;
        for(var prop in DescKeys){
            values[DescKeys[prop]] = "";
        } 
    } else {       
        values = jQuery.parseJSON(description);       
    }    

    values[key] = value;

    description = jQuery.stringifyJSON(values);
    
    APIsetValue("cmi.interactions.#n#.description", description, guid, createNew);
}

function getInteractionIndex(guid, createNew) {
	// TODO: fix interaction count for Pastiche package
	if (isPastiche) {
		return 0;
	}
  var interaction = getInteractionIdFromGuid(guid); 
  if(!serverSide()){
         
      var numbOfInter = APIgetValue("cmi.interactions._count", guid);
      for (var i = 0; i < numbOfInter; i++) {
          if (APIgetValue("cmi.interactions."+i+".id", guid) == interaction) {
              return i;
        }
      }
    if (arguments.length > 1 && createNew) {
      APIsetValue("cmi.interactions."+numbOfInter+".id", interaction, guid);       // cmi.interactions.0.id
      APIsetValue("cmi.interactions."+numbOfInter+".description", " ", guid);       // initialize description
      return numbOfInter;
    }
    return -1;
  }else{  // serverSide
	
    var numbOfInter = CRE.CONNECTOR.APIData.getValue("index", interaction);
    if (numbOfInter == -1 && arguments.length > 1 && createNew)
    {
        numbOfInter = CRE.CONNECTOR.APIData.getInteractionsCount();
        APIsetValue("cmi.interactions."+numbOfInter+".id", interaction);       // cmi.interactions.0.id
		APIsetValue("cmi.interactions."+numbOfInter+".description", " ", guid);       // initialize description
    }

    return numbOfInter;
  }
}

function getVariables(guid, varName) {
    if (guid == "" || typeof(guid) == 'undefined')
        return "";
    var variables = APIgetValue("cmi.comments_from_learner.0.comment", guid);
    if(variables == -1 || typeof(variables) == "undefined") return;
    var temp = variables.split("|");
    for (var i = 0; i < temp.length; i++) {
        var varFullName = guid + "_" + varName;
        var varIndex = temp[i].indexOf(varFullName);
        if (varIndex != -1) {
            var varValue = temp[i].substring(varFullName.length + 1, temp[i].length);
            return varValue;
        }
    }
    return "";
}

function setVariables(varName, varValue, guid) {
    
    if (!isVariablesInited) {
      setTimeout(function(){setVariables(varName, varValue, guid);}, 100);
      return;
    }
    var variables = APIgetValue("cmi.comments_from_learner.0.comment", guid);
    if (variables == -1 || typeof(variables) == "undefined") {
      variables = "";
    }
    var fullVariable = varName + "=" + varValue;
    if (variables == "") {
        APIsetValue("cmi.comments_from_learner.0.comment", "*Variables*|" + fullVariable, guid);
    } else if (variables.indexOf(varName) == -1) {
        APIsetValue("cmi.comments_from_learner.0.comment", variables + "|" + fullVariable, guid);
    }
}

function handleAdvice(qid, showAdvice, at_limit, isCorrect, iOS){
	if (iOS){
		if (showAdvice + "" == "true" && (at_limit == 1 || isCorrect + "" == "true")) {
			show(qid + "_advice", "inline"); // show Advice if: the user has no more attempts to answer the question left or it has correctly answered the question
		}
	}else{
		if (showAdvice + "" == "true" && (at_limit == 1 || isCorrect + "" == "true")) {
			show(qid + "_advice"); // show Advice if: the user has no more attempts to answer the question left or it has correctly answered the question
		}
	}	
}

function handleHint(qid,currentQuestion, at_limit, isCorrect, iOS) {
	hideHint(qid);
	if (isCorrect + "" != "true" && at_limit > 1) {
		var h = currentQuestion.getParamValue("hintActive");
		var shint = currentQuestion.getParamValue("showHint");
		if ((shint && shint == "true") && (h && h.match(/1/))) {  //hints allowed and at least one unused exists
			var hint_id = getHint(qid,h);  // get id of randomly selected hint
			if(iOS){
				show(hint_id, "inline");
			} else {
				show(hint_id); // show this current hint
			}
		}
	}
}

function getFeedbackMode(currentQuestion) {
    var sfeedback = currentQuestion.getParamValue("showFeedback");
    if (getRequestParameter("mode") == "review" && sfeedback !== ShowFeedback.general){
        sfeedback = ShowFeedback.all;
    }
    return sfeedback;
}

function handleFeedback(qid, sfeedback, at_limit, isCorrect ){
	if (isCorrect + "" == "true" ){ 
		hide(qid + "_feedback_q_ir"); 	// hide possible question incorrect label (+ ir_try)
		if (sfeedback + "" === ShowFeedback.all || sfeedback + "" === ShowFeedback.general) {	 // check Show Feedback value
			if (jQuery("#" + qid + "_feedback_pos").length > 0){ 	
				show(qid + "_feedback_pos"); 	// show authored positive feedback
			} else {
				show(qid + "_feedback_q_cr"); 	// show default positive feedback
			}
		}
	} else {
		hide(qid + "_feedback_q_ir"); // hide question incorrect label (+ ir_try)
		if (at_limit > 1) {
			show(qid + "_feedback_q_ir");  // show incorrect question label 
			show(qid + "_feedback_q_ir_try","inline"); 					
		} else {
			hide(qid + '_feedback_q_ir_try'); // hide default label "Try again"
			if (sfeedback + "" === ShowFeedback.all || sfeedback + "" === ShowFeedback.general) {     // check Show Feedback value
				if (jQuery("#" + qid + "_feedback_neg").length > 0){ 	
					show(qid + "_feedback_neg"); // show authored negative feedback
				} else {
					show(qid + "_feedback_q_ir"); // show default negative feedback 
				}
			}
		}
	}
}


var nFindAPITries = 0;
var API = null;
var maxTries = 500;
var APIVersion = "";

function ScanForAPI(win) {	
    while ((win.API_1484_11 == null) && (win.parent != null) && (win.parent != win)) 
    {
        nFindAPITries++;
        if (nFindAPITries > maxTries) 
        {
            notify("Error in finding API instance -- too deeply nested.", "ERROR");
            return null;
        }
        win = win.parent;
    }
    return win.API_1484_11;
}

// ---------------------------------------------------------------------------  
// 'virtual' API interface for Performance Support Tool
// ---------------------------------------------------------------------------
function performanceAPI (){}

performanceAPI.Initialize = function(value){};
performanceAPI.Terminate = function(value){};
performanceAPI.GetValue = function(value){return value;};
performanceAPI.SetValue = function(param, value){param = value;};
performanceAPI.GetLastError = function(value){return "";};
performanceAPI.GetErrorString = function(value){return value;};
performanceAPI.GetDiagnostic = function(value){return value;};
performanceAPI.Commit = function(value){return value;};
performanceAPI.version = 0;
// ---------------------------------------------------------------------------

function GetAPI(win) {
	if (isPastiche) {
		API = iPadAPI.getInstance();
		return;
	}
	if ((getRequestParameter("ownapi") != null && getRequestParameter("ownapi") == 1)){   // Check if performance output without api
		API = performanceAPI;
		return;
	}
    nFindAPITries = 0;
    if ((win.parent != null) && (win.parent != win))
    {
        API = ScanForAPI(win.parent);
    } 
    if ((API == null) && (win.opener != null))
    {
        API = ScanForAPI(win.opener);
        if (API != null)
        {
            APIVersion = API.version;
        }
    }
    // if API's not found
    if (API == null)
        API = performanceAPI;
}

function ScanForCRE(win) {   
	while ((win.CRE == null) && (win.parent != null) && (win.parent != win))
	{
        nFindAPITries++;
        if (nFindAPITries > maxTries) 
        {
            notify("Error in finding Europa-CRE instance -- too deeply nested.", "ERROR");
            break;
        }
		win = win.parent;
    }
    CRE_frame = win; 
    return win.CRE;
}

function GetCRE(win) {
    nFindAPITries = 0;
    if ((win.parent != null) && (win.parent != win))
    {
        CRE = ScanForCRE(win.parent);
    } 
    if ((CRE == null) && (win.opener != null))
    {
        CRE = ScanForCRE(win.opener);
    }
}

function handleError(result) {
    if(!serverSide()){
      if (result == "false" && mode != "review") {
          var errorCode = API.GetLastError();
      var errorString = API.GetErrorString(errorCode);
      var errorDiag = API.GetDiagnostic(errorCode);
          notify(errorString+"\n- "+errorDiag, "ERROR");
      }
    }else{
      // for serverSide errors handled in communicationCommon.js when parsing responce from server
    }
}

function handleGetError(result) {
  if(!serverSide()){
    if (result == "" && API.GetLastError() != 0) {
        var errorCode = API.GetLastError();
		var errorString = API.GetErrorString(errorCode);
		var errorDiag = API.GetDiagnostic(errorCode);
        notify(errorString+"\n- "+errorDiag, "ERROR");
    }
  }else{
    // for serverSide errors handled in communicationCommon.js when parsing responce from server
  }  
}

function remindToGo() {
    var what = 'popup_next';
    if (document.getElementById(what)) {
	var elms = document.getElementsByName(what);
		for (var i=0; i<elms.length; i++) {
	    elms[i].style.visibility = "visible";
	}
    }
}

function notify(msg, level) {
    if (isRealCRE()) {
        CRE.notify("QuestionPage: "+msg,level);
    } else {
        if (level == "ERROR") {
            alert(msg);
        }
    }
}

function createUserAnswerFromGuid(guid, userAnswer) {
    
    var pos = userAnswer.indexOf(guid);
    var interaction = getInteractionIdFromGuid(guid);
    var newUserAnswer = userAnswer;
    if (pos >= 0 && pos < guid.length && interaction != null) {
        //newUserAnswer = userAnswer.replace(guid, interaction);
        newUserAnswer = userAnswer.split(guid).join(interaction);
    }
    
    return newUserAnswer;
}

function createUserAnswerFromInteractionId(guid, userAnswer) {
    
    var interaction = getInteractionIdFromGuid(guid);
    if (interaction == null)
        return userAnswer;
    
    var pos = userAnswer.indexOf(interaction);
    var newUserAnswer = userAnswer;
    if (pos >= 0 && pos < guid.length) {
        //newUserAnswer = userAnswer.replace(interaction, guid);
        newUserAnswer = userAnswer.split(interaction).join(guid);
    }
    return newUserAnswer;
}

function getResourcePageID() {
    var docLocation = document.URL;
            
    var lastSlash = docLocation.lastIndexOf("/");
    var lastBackSlash = docLocation.lastIndexOf("\\");    
    var slash = (lastSlash <= lastBackSlash) ? lastBackSlash : lastSlash;
    
    var lastDot = docLocation.lastIndexOf(".") > slash ? docLocation.lastIndexOf(".") : docLocation.lastIndexOf("?");
    var pageName = docLocation.substring(slash + 1, lastDot);
    
    pageName = pageName.replace(/[.,\/\\:;'"?@=&]/gim , "-");            
    resourceId = pageName;
    
}

// private method for UTF-8 decoding
 function  utf8Decode (utftext) {
 	var string = "";
 	var i = 0;
 	var c = c1 = c2 = 0;

	while ( i < utftext.length ) {
  		c = utftext.charCodeAt(i);
		if (c < 128) {
    		string += String.fromCharCode(c);
    		i++;
  		} else if((c > 191) && (c < 224)) {
 			c2 = utftext.charCodeAt(i+1);
    		string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
    		i += 2;
  		} else {
 			c2 = utftext.charCodeAt(i+1);
			c3 = utftext.charCodeAt(i+2);
    		string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
   			i += 3;
 		}
	}
	
	return string;
}

function initAdviceRendering(){
	jQuery("div[id $= '_advice_content']:not('.IOS')").each(function(index, adviceContent) {
		// Advice Popup
		jQuery(adviceContent).dialog({
			autoOpen: false,
			maxWidth: 640,
			maxHeight: 480,
			modal: true,
			show: "drop",
			hide: "drop",
			title: jQuery(adviceContent).attr('data-advicetitle'),
			closeOnEscape: false,
			open: function(event, ui) {
				jQuery(document).bind('keyup.advice-modal-content', function (e) {
					if (e.keyCode == 27) { // ESC
						e.preventDefault();
						if( jQuery('div.advice-modal-content input.AVButton').val() == 'Hide Transcript'){ //if AVScript present and opened
							e.stopPropagation();
							jQuery('div.advice-modal-content input.AVButton').val('Show Transcript');
							jQuery('div.advice-modal-content .narration').css('display','none')
						}else{
							e.stopPropagation();
							jQuery(adviceContent).dialog('close')
						}
					}
				})
			},
			beforeClose: function(event, ui){
				jQuery(document).unbind('keyup.advice-modal-content')
			}
		})
		
		var adviceLinkId = jQuery(adviceContent).attr('id').replace('_content', '_link');
		// Popup Link
		jQuery('#' + adviceLinkId).click(function(){
			var adviceHeight = jQuery('#content',parent.document).height() || jQuery(parent.document).height();
				adviceHeight = (adviceHeight > 576) ? 480 : (adviceHeight - adviceHeight/5);
			var adviceWidth = jQuery('#content',parent.document).width() || jQuery(parent.document).width();
				adviceWidth = (adviceWidth > 704) ? 640 : ( adviceWidth -= adviceWidth/10);
			jQuery(adviceContent).dialog( "option", "width", adviceWidth );	
			jQuery(adviceContent).dialog( "option", "height", adviceHeight );
			jQuery(adviceContent).dialog('open');
			return false;
		});
	});
}

function initFlagging() {

    function changeFlagStatus(event) {
        var guid = event.data.guid,
            value = getFlagStatus(guid),
            revertedValue = value === 'true' ? 'false' : 'true';

        // store flag status to interaction description
        setFlagStatus(guid, revertedValue);
        // toggle flag icon
        jQuery(event.currentTarget).toggleClass('flagged');
    }

    jQuery('.flag').each(function() {
        jQuery(this).on("click", {guid : jQuery(this).data("guid")}, changeFlagStatus)
                    .on("mouseover", function(){Tip(document.langFlagging, SHADOW, true, PADDING, 3);})
                    .on("mouseleave", function(){UnTip();})                                
    })
}

function disableFlagging() {
    jQuery('.flag').each(function() {
        jQuery(this).off("click mouseover mouseleave");
    })
}

function unload(){
    // JLP: IE fires unload on skin button click
    if (CRE.TREE.hasPendingNavigationRequest && !CRE.TREE.hasPendingNavigationRequest() ) return;

    if (initialized) {
        APIsetValue("cmi.exit", "suspend");
        APIsetValue("cmi.completion_status", "completed");
            
        APIterminate();
    }
}

// This was added for SCORM 2004 skinless packages and removed because it broke question skip.
// Add this to a CP overlay if anyone will need a SCORM 2004 skinless package.
// -------------------------------
window.onbeforeunload = unload;
window.onunload = unload; // old browsers don't support onBeforeUnload
// -------------------------------

jQuery(document).ready(function(){ 
	//To avoid re-initialization. As function getQuestion() supports it as well.
	if (!isPastiche && questions.length == 0 && !isQuestionsPageInited) {
		initFlagging();
		initQuestionPage();
		initAdviceRendering();
	}
});

//********************** Base64 encoding/decoding functions start ********************************//
/**
* Encode all element text nodes with Base64 algorithm
* @param jQuery Object {elem} - element which content text need to be encoded
*/
function encodeBase64(elem){
	// encode all children text nodes
	elem.contents().filter(function() {
		if(this.nodeType == 3){
			var textNode = jQuery(this);
			textNode.replaceWith(Base64.encode(textNode.text()));
		}
	});
	// encode all other children nodes recursively
	elem.children().each(function(i, selected){
		encodeBase64(jQuery(selected));
	});
};

/**
* Decode all element text nodes with Base64 algorithm
* @param jQuery Object {elem} - element which content text need to be decoded
*/
function decodeBase64(elem){
	// encode all children text nodes
	elem.contents().filter(function() {
		if(this.nodeType == 3){
			var textNode = jQuery(this);
			textNode.replaceWith(Base64.decode(textNode.text()));
		}
	});
	// encode all other children nodes recursively
	elem.children().each(function(i, selected){
		decodeBase64(jQuery(selected));
	});
};

/**
* Encode attribute value with Base64 algorithm
* @param String {id} - element id 
* @param String {attrName} - attribute name for encoding its value
*/
function encodeAttrValue(id, attrName){
	var elem = jQuery("#" + id);
	attrName = wab.attr(attrName) !== undefined ? attrName : 'data-' + attrName;        // add data- prefix if need (for WAB) 
	elem.attr(attrName, function(i, val){
		return Base64.encode(val);         // encode attribute value with Base64
	});
}

/**
* Decode attribute value with Base64 algorithm
* @param String {id} - element id 
* @param String {attrName} - attribute name for decoding its value
*/
function decodeAttrValue(id, attrName){
	var elem = jQuery("#" + id);
	var attrValue = wab.attr(attrName) !== undefined ? attrName : 'data-' + attrName;    // add data- prefix if need (for WAB)
	elem.attr(attrName, function(i, val){
		return Base64.decode(val);          // decode attribute value with Base64
	});
}
//********************** Base64 encoding/decoding functions end **********************************//
// keyboard accessebility for fill in blank and Lefger! drop downs
jQuery(document).ready(function() {
                function touchHandler(event) {
                    var touches = event.changedTouches,
                        first = touches[0],
                        type = "";
                        switch(event.type)
                    {
                        case "touchstart": type = "mousedown"; break;
                        case "touchmove":  type = "mousemove"; break;        
                        case "touchend":   type = "mouseup"; break;
                        default: return;
                    }

                    //initMouseEvent(type, canBubble, cancelable, view, clickCount, 
                    //           screenX, screenY, clientX, clientY, ctrlKey, 
                    //           altKey, shiftKey, metaKey, button, relatedTarget);

                    var simulatedEvent = document.createEvent("MouseEvent");
                    simulatedEvent.initMouseEvent(type, true, true, window, 1, 
                                            first.screenX, first.screenY, 
                                            first.clientX, first.clientY, false, 
                                            false, false, false, 0/*left*/, null);

                    first.target.dispatchEvent(simulatedEvent);
                    if (event.type == 'touchmove' && touches.length == 1 && /draggable/i.test(event.target.className)) {
                        event.preventDefault();
                    }
                }
                if (/iPhone|iPod|iPad/.test(navigator.userAgent)) {
                    document.addEventListener("touchstart", touchHandler, true);
                    document.addEventListener("touchmove", touchHandler, true);
                    document.addEventListener("touchend", touchHandler, true);
                    document.addEventListener("touchcancel", touchHandler, true);  
                }
		var zIndexNumber = 1000; 

		//to resolve IE troubles with zIndex
		if (isIE7) {
			jQuery(".WebFillInBlank *").each(function() {
					jQuery(this).css("zIndex", zIndexNumber);
					zIndexNumber -= 1;
				});
		}
			
		jQuery("select.DropDownList").each(function() {
				var currentSelect = jQuery(this);
				var dropDownToAppear = jQuery("#"+currentSelect.attr("id")+"_to_appear");
				
				currentSelect.css("height","18px");
				
				currentSelect.keydown(function(event) {
						if(event.keyCode == 13) {
							if (dropDownToAppear.css("display") == "block") {
								dropDownToAppear.css("display", "none");
							} else {
								dropDownToAppear.css("display", "block");
								var selectedOption = currentSelect.find("option:selected");
								// set focus on selected item
								if (selectedOption.attr("value") == "") {
									dropDownToAppear.find("a:first").focus();
								} else {
									dropDownToAppear.find("a").filter(function() {
										   return jQuery(this).text() == selectedOption.attr("value");
										}).focus();
								}
							}
							event.stopPropagation();
							return false;					
						}
		
					})
	
					.click(function(event) {					
							dropDownToAppear.css("display", "none");
							return true;
						});
					
				// functionality and styling for dropDownToAppear element
				// drop down simulator on key down event
				var dropDownLinks = dropDownToAppear.find("a");
				
				dropDownLinks.keydown(function(event) {
						if(event.keyCode == 13) {
							currentSelect.find("option[value='"+this.innerHTML+"']").attr("selected","selected");
							dropDownToAppear.css("display", "none");
							this.parentNode.style.backgroundColor = currentSelect.css("backgroundColor");//"#E4E2DE";
							currentSelect.focus();
							
							return false;
						}
						//up arrow 
						if(event.keyCode == 38) {
							if (dropDownLinks.index(this) != 0) {
								// blur explicitly
								jQuery(this).blur();
								dropDownLinks.eq(dropDownLinks.index(this)-1).focus();
							}
							
							return false;
						}
						//down arrow
						if(event.keyCode == 40) {
							if (dropDownLinks.length - 1  != dropDownLinks.index(this)) {
								// blur explicitly
								jQuery(this).blur();
								dropDownLinks.eq(dropDownLinks.index(this)+1).focus();
							}
							
							return false;
						}
					})
					// bubbling in IE
				.click(function(event) {
						currentSelect.find("option[value='"+this.innerHTML+"']").attr("selected","selected");
						this.parentNode.style.backgroundColor = currentSelect.css("backgroundColor");//"#E4E2DE";
						this.style.color = "black";
						currentSelect.focus();
						dropDownToAppear.css("display", "none");
						
						return false;
					})
				.focus(function() {
						dropDownToAppear.find("a").css("color","black");
						dropDownToAppear.find("a").parent().css("backgroundColor",currentSelect.css("backgroundColor"));//"#E4E2DE");
						this.style.color = "white";
						this.parentNode.style.backgroundColor = "#0A246A";
						
						dropDownToAppear.css("display","block");
					})
				.blur(function() {
						this.parentNode.style.backgroundColor = currentSelect.css("backgroundColor");//"#E4E2DE";
						this.style.color = "black";

						if (jQuery("*:focus").attr("name") != "DropDownLink") {
								dropDownToAppear.css("display","none");
						}
					})
				 .hover(
					  function() {
						jQuery(this).focus();
					  },
					  function() {
						jQuery(this).blur();
					  }
					)
				.css("width", currentSelect.width() + "px");

				
				dropDownToAppear.css({
						"background-color" : currentSelect.css("backgroundColor"),//"#E4E2DE",
						"width" : currentSelect.width() + "px",
						"left" : currentSelect.position().left - 3 + "px",
						"top" : currentSelect.position().top +  currentSelect.height() + 1 + "px"
					});
					
				//fix select width under IE7 and IE8
				if((isIE7 || isIE8) && currentSelect.attr("ledger")!="true") {
					if (currentSelect.width() <= 156) { 
						currentSelect.width("156px");
						dropDownToAppear.css("width","156px");
					} else { 
						if(currentSelect.attr("isUserWidth") != "true") {
							currentSelect.width("auto");
						}
					}
				}
			});
	});