/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/


var isIE  = (navigator.appVersion.indexOf("MSIE") != -1) ? true : false;
var isIE6  = ((navigator.appVersion.indexOf("MSIE") != -1) && (parseFloat(navigator.appVersion.split("MSIE")[1]) < 7)) ? true : false;
var isIE7  = ((navigator.appVersion.indexOf("MSIE") != -1) && (parseFloat(navigator.appVersion.split("MSIE")[1]) == 7)) ? true : false;
var isIE8  = ((navigator.appVersion.indexOf("MSIE") != -1) && (parseFloat(navigator.appVersion.split("MSIE")[1]) > 7)) ? true : false;
var isPastiche  = typeof(Environment) != "undefined" ? Environment.getInstance().isPastiche() : false;
var lastOpen = null;

var tabsCompletionValues = new Array();
var isTabsBeCompleted = false;

// Used by MediaObjectlib > MO-AdaptiveAudio
window.XyMediaObject = window.XyMediaObject || {};
window.XyMediaObject.useAdaptiveJsPlayer = true;


jQuery(document).ready(function() {
    jQuery("#Acontent", parent.document).focus();


        //load htmlPage if is present
        if (jQuery("#htmlPageContent").length > 0) {
            //get page by content's url(cu)

            jQuery("#htmlPageContent").load(getURLParam("cu"), function(){
                if (window.parent.$.skinAPI){
                    window.parent.$.skinAPI.methods.updateAccessibilityPageSettings(jQuery("#htmlPageContent *"));
                }
                editRelativeLinks();
                applyCachedPageStyles();
            });
        } else {
            applyCachedPageStyles();
        }
    //reset script window content/// DEPRECATED use SKIN_API functionality instead
    if (window.parent.getNarration) {
        window.parent.getNarration();
    }

	// Extend and generate mediaelement js media players
    extendMediaElementJs();
	generateMediaPlayerObjects();
    // Equation rendering
    renderEquations(0);
    initBase64();
    initXrefPopup();
    modifyStage();
    initInLineHotText();
    initInLineTerm();
    initGlossaryPopUp();
    initFootnotePopUp();
    initMarginNotePopUp();
    initMarginGlossaryTermPopUp();
    updateInLineBlock();
    //initListAnimation_buttons();
    initListAnimation_click();

});

jQuery(window.parent).ready(function(){
	//in ie event in inner frame have to be attached in global way
	//so function testKeyCode could match it
	if (window.parent.testKeyCode) {
		if (isIE){
			document.attachEvent("onkeydown", window.parent.testKeyCode);
		} else {
			document.onkeydown = window.parent.testKeyCode
		}
	}
	// fix tooltip display in iPad
	jQuery(function(){
		if (/iPhone|iPod|iPad/.test(navigator.userAgent)) {
			//Remove tooltip event listeners so that double clicks are not neccessary on iPad
			jQuery('*[onmouseover]').removeAttr('onmouseover').removeAttr('onmouseout');
		}
	});
});


/**
*  Returns true if navigation allowed at current moment
*  Returns false if navigation is restricted (e.g. interactive activity is not complete)
*/
function checkNavigationRestriction() {
    if(jQuery(".ImageMap").length !=0 && typeof(checkHotSpotVisit) != "undefined" && typeof(checkHotSpotVisit) == "function") {
        var mapResult = checkHotSpotVisit();
        if (mapResult == 0) {
            return false;
        }
    }
    if(jQuery(".FlashCards").length !=0 && typeof(checkCardVisit) != "undefined" && typeof(checkCardVisit) == "function") {
        var cardsResult = checkCardVisit();
        if (cardsResult == 0) {
            return false;
        }
    }
    if(jQuery("[id^='Tabs']").length !=0 && typeof(checkTabsVisit) != "undefined" && typeof(checkTabsVisit) == "function") {
        var tabsResult = checkTabsVisit();
        if (tabsResult == 0) {
            return false;
        }
    }
    return true;   // navigation allowed
}

/**
* to apply previously saved contrast and scale on the page  //DEPRECATED use SKIN_API functionality instead
*/
function applyCachedPageStyles() {
    //changeStyleProperty have to be removed as SKIN_API will be used
    var cachedContrast = jQuery("#contrast", parent.document);
    if (cachedContrast && cachedContrast.val() && cachedContrast.val() != "" && window.parent.changeStyleProperty) {
        var contrast = cachedContrast.val();
        window.parent.changeStyleProperty("body", contrast, "contrast");
    }

    var cachedScale = jQuery("#scale", parent.document);
    if (cachedScale && cachedScale.val() && cachedScale.val() != "" && window.parent.changeStyleProperty) {
        var scale = cachedScale.val()
        window.parent.changeStyleProperty("body", scale, "scale");
    }
}

function editRelativeLinks() {
    var path = getURLParam("cu").substring(0, getURLParam("cu").lastIndexOf("/")+1);
    jQuery("#htmlPageContent").find("link, a").each(function (i) {
        var relPath = jQuery(this).attr("href");
        if (relPath.indexOf("http://") != 0 && relPath.indexOf("https://") != 0)
        jQuery(this).attr("href", path + relPath);
    });
    jQuery("#htmlPageContent").find("script, img").each(function (i) {
        var relPath = jQuery(this).attr("src");
        if (relPath.indexOf("http://") != 0 && relPath.indexOf("https://") != 0)
        jQuery(this).attr("src", path + relPath);
    });
}

document.getElementsByClassName = function(cl) {
    var retnode = [];
    var myclass = new RegExp('\\b'+cl+'\\b');
    var elem = this.getElementsByTagName('*');

    for (var i = 0; i < elem.length; i++) {
        if (myclass.test(elem[i].className)) {
            retnode.push(elem[i]);
        }
    }
    return retnode;
};

function showPopup(e){
    var availHeight;
    var availWidth;

    /*if(typeof(window.innerWidth) == 'number'){
        availHeight = window.innerHeight;
        availWidth = window.innerWidth;
    }else if(document.documentElement && (document.documentElement.clientWidth || document.documentElement.clientHeight)){
        availHeight = document.documentElement.clientHeight;
        availWidth = document.documentElement.clientWidth;
    }else if(document.body && (document.body.clientWidth || document.body.clientHeight)){
        availHeight = document.body.clientHeight;
        availWidth = document.body.clientWidth;
    }*/
    var id = e.target.id;

    if(lastOpen != null)
        jQuery('#'+lastOpen + 'pop').css('display','none');
    lastOpen = id;

    var popupWidth = 200;
    var popupHeight = 200;
    var left = (availWidth/2) - (popupWidth/2);
    var top = (availHeight/2) - (popupHeight/2);
    var popup = document.getElementById(id + 'pop');
    var span = document.getElementById(id);
    popup.style.zIndex="999";
    if(span != null) {
        // disable absolute positioning  in case of  <divLinkSpot>
        if(popup.parentNode.parentNode.id.indexOf("divLinkSpot") == -1)
            popup.style.position = 'absolute';
        else
            popup.style.position = '';
        if(typeof e.pageX === "undefined") {
              var xx = jQuery(e.target);
            popup.style.left = jQuery(e.target).offset().left + 3/4*jQuery(e.target).width() + "px";
            popup.style.top = jQuery(e.target).offset().top + 3/4*jQuery(e.target).height() + "px";
        } else {
            popup.style.left = e.pageX + 5 + "px";
            popup.style.top = e.pageY + 5 + "px";
        }
    } else {
        popup.style.position="fixed";
        popup.style.top="43%";
        popup.style.left="43%";
    }
    popup.style.display="block";

    if(popup.offsetWidth < popup.offsetHeight) {
        var sizeDiff;
        sizeDiff = popup.offsetHeight - popup.offsetWidth;
        if(sizeDiff < popup.offsetLeft - 5)
            popup.style.left = (popup.offsetLeft - sizeDiff) + "px";
        else
            popup.style.left = "5px";
    }

    if((popup.offsetLeft + popup.offsetWidth) > document.body.offsetWidth) {
        var sizeDiff;
        sizeDiff = popup.offsetLeft + popup.offsetWidth - document.body.offsetWidth;
        if(sizeDiff < popup.offsetLeft - 5)
            popup.style.left = (popup.offsetLeft - sizeDiff) + "px";
        else
            popup.style.left = "5px";
    }
}

function Point()
{
    this.x = 0;
    this.y = 0;
}

function getAngle(x1, y1, x2, y2) {
    return Math.atan((y2-y1)/(x2-x1));
}

function rotate(angle, x, y) {
    var result = new Point();
    result.x = Math.cos(angle)*x - Math.sin(angle)*y;
    result.y = Math.sin(angle)*x + Math.cos(angle)*y;
    return result;
}

function drawArrows(x1, y1, x2, y2, jg, arrows) {
    var offset = 4; //set offset for arrows, without this arrow head looks like cut off
    if(x1 != x2) {
        var x20 = x2, y20 = y2;
        var flip = false;
        if(x1 > x2) {
            x2 = x1;
            y2 = y1;
            x1 = x20;
            y1 = y20;
            x20 = x2;
            y20 = y2;
            flip = true;
        }
        var angle = getAngle(x1, y1, x2, y2);
        if((arrows == "1" && !flip) || arrows=="3" || (arrows == "2" && flip)) {

            var ptXY = rotate(-angle, x2-x1, y2-y1);
            var x22 = ptXY.x-offset;
            var y22 = ptXY.y;
            ptXY = rotate(angle, x22, y22);


            var pt = rotate(-angle, x2-x1, y2-y1);
            x2 = pt.x-15-offset;
            y2 = pt.y-5;
            pt = rotate(angle, x2, y2);
            jg.drawLine(x1+ptXY.x, y1+ptXY.y, x1+pt.x, y1+pt.y);
            y2 += 10;
            pt = rotate(angle, x2, y2);
            jg.drawLine(x1+ptXY.x, y1+ptXY.y, x1+pt.x, y1+pt.y);
        }
        if((arrows == "2" && !flip) || arrows=="3" || (arrows == "1" && flip)) {

            var ptXY = rotate(-angle, x1-x2, y1-y2);
            var x11 = ptXY.x+offset;
            var y11 = ptXY.y;
            ptXY = rotate(angle, x11, y11);

            x20 = x1;
            y20 = y1;
            var pt = rotate(-angle, x1-x2, y1-y2);
            x1 = pt.x+15+offset;
            y1 = pt.y+5;
            pt = rotate(angle, x1, y1);
            jg.drawLine(x2+ptXY.x, y2+ptXY.y, x2+pt.x, y2+pt.y);
            y1 -= 10;
            pt = rotate(angle, x1, y1);
            jg.drawLine(x2+ptXY.x, y2+ptXY.y, x2+pt.x, y2+pt.y);
        }
        if(arrows == "4" && !flip) {//Maching Activity arrow
            offset = 1
            var ptXY = rotate(-angle, x2-x1, y2-y1);
            var x22 = ptXY.x-offset;
            var y22 = ptXY.y;
            ptXY = rotate(angle, x22, y22);

            var pt = rotate(-angle, x2-x1, y2-y1);
            x2 = pt.x-10-offset;
            y2 = pt.y-3;
            pt = rotate(angle, x2, y2);
            jg.drawLine(x1+ptXY.x, y1+ptXY.y, x1+pt.x, y1+pt.y);
            y2 += 6;
            pt = rotate(angle, x2, y2);
            jg.drawLine(x1+ptXY.x, y1+ptXY.y, x1+pt.x, y1+pt.y);
        }
        if(arrows == "4" && flip) {

            var ptXY = rotate(-angle, x1-x2, y1-y2);
            var x11 = ptXY.x+offset;
            var y11 = ptXY.y;
            ptXY = rotate(angle, x11, y11);

            x20 = x1;
            y20 = y1;
            var pt = rotate(-angle, x1-x2, y1-y2);
            x1 = pt.x+10+offset;
            y1 = pt.y+3;
            pt = rotate(angle, x1, y1);
            jg.drawLine(x2+ptXY.x, y2+ptXY.y, x2+pt.x, y2+pt.y);
            y1 -= 6;
            pt = rotate(angle, x1, y1);
            jg.drawLine(x2+ptXY.x, y2+ptXY.y, x2+pt.x, y2+pt.y);
        }
    } else {
        //Vertical line
        var flip = false;
        if(y1 > y2) {
            var y = y2;
            y2 = y1;
            y1 = y;
            flip = true;
        }
        if((arrows == "1" && !flip) || arrows=="3" || (arrows == "2" && flip)) {
            jg.drawLine(x2, y2-offset, x2-5, y2-15-offset);
            jg.drawLine(x2, y2-offset, x2+5, y2-15-offset);
        }
        if((arrows == "2" && !flip) || arrows=="3" || (arrows == "1" && flip)) {
            jg.drawLine(x1, y1+offset, x1-5, y1+15+offset);
            jg.drawLine(x1, y1+offset, x1+5, y1+15+offset);
        }
        if(arrows == "4" && !flip) { //Maching Activity arrow
            offset = 1
            jg.drawLine(x1, y1+offset, x1-3, y1+10+offset);
            jg.drawLine(x1, y1+offset, x1+3, y1+10+offset);
        }
        if(arrows == "4" && flip){
            jg.drawLine(x1, y1+offset, x1-3, y1-10+offset);
            jg.drawLine(x1, y1+offset, x1+3, y1-10+offset);
        }
    }
}

function getLeft(element, wrap)
{
    //  HACKS for IE6, IE8 and Safafi
    var ieOffset7 = 10;
    var ieOffset6 = 25;
    if(element.children) {
        for(var i=0; i<element.children.length; i++)
        {
            if(element.children[i].tagName == "IMG")
            {
                if(isIE7) return element.children[i].offsetLeft - ieOffset7;
                if(isIE6) return element.children[i].offsetLeft - ieOffset6;
                return element.children[i].offsetLeft;
            }
        }
    } else {
        var children = element.childNodes;
        for(var i=0; i<element.childNodes.length; i++)
        {
            if(element.childNodes[i].tagName == "IMG")
            {
                return element.childNodes[i].offsetLeft;
            }
        }
    }
    return 0;
}

function alignMarginNote(id) {
    var currentNote = document.getElementById(id);
    if(currentNote.parentNode.className != "Glossary")
        var inc = 0;
        do {
            var moved = false;
            if(isIE) {
                var figures = document.getElementsByClassName("WrapLeft");
                for(var i=0; i<figures.length; i++) {
                    if(currentNote != figures[i] && currentNote.offsetTop <= figures[i].offsetTop + figures[i].offsetHeight &&
                            currentNote.offsetTop >= figures[i].offsetTop) {
                        currentNote.style.left = figures[i].offsetParent.offsetLeft + "px";
                    }
                }
            }
            moved = moved || alingMarginNoteByClass(currentNote, "GlossaryItem");
            moved = moved || alingMarginNoteByClass(currentNote, "MarginNote");
            moved = moved || alingMarginNoteByClass(currentNote, "ObjectiveNote");
            inc ++;
        } while(moved && inc < 1000)
}

function alingMarginNoteByClass(currentNote, className) {
    var marginNotes = document.getElementsByClassName(className);
    var moved = false;
    for(var i=0; i<marginNotes.length; i++) {
        if(currentNote != marginNotes[i] && currentNote.offsetTop <= marginNotes[i].offsetTop + marginNotes[i].offsetHeight &&
                currentNote.offsetTop >= marginNotes[i].offsetTop) {
            currentNote.style.top = marginNotes[i].offsetTop + marginNotes[i].offsetHeight + 5 + "px";
            moved = true;
        }
    }
    return moved;
}

function getWindowHeight() {
    if (isIE)
        return document.documentElement.offsetHeight;
    else
        return document.documentElement.scrollHeight;
}

// --------------common functions begin-----------------
// --- adds event handler to a page ---
function addEvent(obj, evType, fn) {
    if (obj.addEventListener) {
        obj.addEventListener(evType, fn, false);
        return true;
    } else if (obj.attachEvent) {
        var r = obj.attachEvent("on"+evType, fn);
        return r;
    } else {
        return false;
    }
}

// --- removes event handler to a page ---
function removeEvent(obj, evType, fn) {
    if (obj.removeEventListener) {
        obj.removeEventListener(evType, fn, false);
        return true;
    } else if (obj.detachEvent) {
        var r = obj.detachEvent("on"+evType, fn);
        return r;
    } else {
        return false;
    }
}

if (navigator.appName == "Netscape") {
    getElementsByName = function(tag, name) {
        arr = document.getElementsByName(name);
        return arr;
    }
} else {
    getElementsByName = function(tag, name) {
        var elem = document.getElementsByTagName(tag);
        var arr = new Array();
        for(i = 0,iarr = 0; i < elem.length; i++) {
            var att = elem[i].getAttribute("name");
            if(att == name) {
               arr[iarr] = elem[i];
               iarr++;
            }
        }
        return arr;
    }
}

function ExtractNumber(value) {
    var n = parseInt(value);
    return n == null || isNaN(n) ? 0 : n;
}

// -------------------------------
// --- finds coordinates of object obj ---
function findPos(obj) {
    var oobj = obj;
    var curleft = curtop = 0;
    if (obj.offsetParent) {
        curleft = obj.offsetLeft;
        curtop = obj.offsetTop;
        while (obj = obj.offsetParent) {
        curleft += obj.offsetLeft;
        curtop += obj.offsetTop;
        }
    }
    var curright = curleft + oobj.offsetWidth;
    var curbottom = curtop + oobj.offsetHeight;
    return [curleft,curright,curtop,curbottom];
}

/*retrieves element from document by id*/
function byId(id) {
    return document.getElementById(id);
}

/*defines weather @decendant element is decendant of @ancestor*/
function isDecendant(decendant, ancestor) {
    return ((decendant.parentNode==ancestor)  ||
        (decendant.parentNode!=document) &&
            isDecendant(decendant.parentNode,ancestor));
}

function getFlashMovieObject(movieName) {
  if (window.document[movieName])
  {
    return window.document[movieName];
  }
  if (navigator.appName.indexOf("Microsoft Internet")==-1)
  {
    if (document.embeds && document.embeds[movieName])
      return document.embeds[movieName];
  }
  else // if (navigator.appName.indexOf("Microsoft Internet")!=-1)
  {
    return document.getElementById(movieName);
  }
}
// --------------common functions end-----------------
/**
* to prevent overriding functions on onload event
* use addloadEvent
*
* @param  func   function to be added to onload event
* @param  params   parameters to be passed on function
*/
function addLoadEvent(func, params) {
    var oldonload = window.onload;

    if (typeof(window.onload) != 'function') {
        window.onload = function() {
            func(params);
        }
    } else {
        window.onload = function() {
            if (oldonload) {
                oldonload();
            }
            func(params);
        }
    }
}

/**
* to prevent overriding functions on onunload event
* use addUnLoadEvent
*
* @param  func   function to be added to onunload event
* @param  params   parameters to be passed on function
*/
function addUnLoadEvent(func, params) {
    var oldonunload = window.onunload;

    if (typeof(window.onunload) != 'function') {
        window.onunload = function() {
            func(params);
        }
    } else {
        window.onunload = function() {
            if (oldonunload) {
                oldonunload();
            }
            func(params);
        }
    }
}

/**
 * decode text
 *
 * @param  s   text
 */
function decodeTxt(s) {
    var s1 = unescape(s.substr(0, s.length - 1));
    var t = '';
    for (i = 0; i < s1.length; i++)t += String.fromCharCode(s1.charCodeAt(i) - s.substr(s.length - 1, 1));
    return unescape(t);
}

/**
 * encode text
 *
 * @param  s   text
 */
function encodeTxt(s) {
    s = escape(s);
    var ta = new Array();
    for (i = 0; i < s.length; i++)ta[i] = s.charCodeAt(i) + 1;
    return "" + escape(eval("String.fromCharCode(" + ta + ")")) + 1;
}

function parseNumber(number) {
    var stringMas = number.match(/[0-9().-]/g);
    if (stringMas == null) return number;
    var string = "";
    for (var l = 0; l < stringMas.length; l++) {
        string += stringMas[l];
    }
    if (string.charAt(0) == "-" || string.charAt(0) == "(") {
        return parseFloat(string.replace(/[-()]/g, "")) * (-1);
    }
    return  parseFloat(string);
}
//limit number of characters
function limitSymbols(blankObj, limitNumber) {
    if (blankObj.value.length > limitNumber) {
        blankObj.value = blankObj.value.substring(0, limitNumber);
    }
}
// get random value
function getRandomValue(min, max, decimalDigits) {
    var value = Math.random() * (max - min) + min;
    return value.toFixed(decimalDigits);
}

function getRandomArrayValue(array, decimalDigits) {
    var value = array[Math.floor(Math.random() * array.length)];
    return value.toFixed(decimalDigits);
}

//==========Expression evaluation for Formula================
function Formula() {

    this.replaceString = function(tempstack, char) {
        for (i = 0; i < tempstack.length; i++) {
            if (tempstack[i] == char) {
                tempstack.splice(i - 1, 3, this.evaluate(tempstack[i - 1], char, tempstack[i + 1]));
                i--;
            }
        }
    }

    this.evaluateString = function(tempstack) {
        for (i = 0; i < tempstack.length; i++) {
            this.replaceString(tempstack, "^");
            this.replaceString(tempstack, "/");
            this.replaceString(tempstack, "*");
            this.replaceString(tempstack, "+");
            this.replaceString(tempstack, "-");
        }
        return tempstack;
    }

    this.evaluate = function(num1, op, num2) {
        if (op == "+") return "(" + num1 + "+" + num2 + ")";
        else if (op == "-") return "(" + num1 + "-" + num2 + ")";
        else if (op == "*") return "(" + num1 + "*" + num2 + ")";
        else if (op == "/") return "(" + num1 + "/" + num2 + ")";
        else if (op == "^") return "Math.pow((" + num1 + "),(" + num2 + "))";
    }

    this.expressionEvaluate = function(expression) {
        var stack = new Array();
        var stringmid = expression.replace(/[ ,]/g, "");
        var stringstart = "(";
        var stringend = ")";
        var string = stringstart.concat(stringmid).concat(stringend);
        var stringstack = new Array();
        var isPushedNumber = false;
        for (var l = 0; l < string.length; l++) {
            if (isNaN(string.charAt(l))) {
                stringstack.push(string.charAt(l));
                isPushedNumber = false;

            } else {
                if (isPushedNumber == true) {
                    var temp = stringstack.pop();
                    stringstack.push(parseFloat(temp) * 10 + parseFloat(string.charAt(l)));
                    isPushedNumber = true;
                }
                if (isPushedNumber == false) {
                    stringstack.push(parseFloat(string.charAt(l)));
                    isPushedNumber = true;
                }
            }
        }

        for (var m = 0; m < stringstack.length; m++) {
            if (stringstack[m] == ".") {
                var temporary;
                if (!isNaN(stringstack[m + 1]) && !isNaN(stringstack[m - 1])) {
                    var firstterm = parseFloat(stringstack[m - 1]);
                    var secondterm = parseFloat(stringstack[m + 1]);
                    var secondtermlength = parseFloat(Math.floor(Math.LOG10E * Math.log(secondterm)));
                    var secondadd = secondterm / Math.pow(10, secondtermlength + 1);
                    temporary = firstterm + secondadd;
                    stringstack.splice(m - 1, 3, temporary);
                    m--;
                }
                else if (isNaN(stringstack[m + 1]) && !isNaN(stringstack[m - 1])) {
                    temporary = stringstack[m - 1];
                    stringstack.splice(m - 1, 2, temporary);
                }
                else if (!isNaN(stringstack[m + 1]) && isNaN(stringstack[m - 1])) {
                    temporary = parseFloat(stringstack[m + 1]) / Math.pow(10, stringstack[m + 1].length);
                    stringstack.splice(m, 2, temporary);
                }
            }
        }

        for (var k = 0; k < stringstack.length; k++) {
            stack.push(stringstack[k]);
            if (stringstack[k] == ")") {
                stack.pop();
                var whileloop = true;
                var tempstack = new Array();
                while (whileloop == true) {
                    if (stack.length < 1) whileloop = false;
                    var temptopush = stack.pop();
                    tempstack.push(temptopush);
                    if (temptopush == "(") {
                        tempstack.pop();
                        whileloop = false;
                    }
                }
                if (isNaN(tempstack[tempstack.length - 1])) {
                    var sign = tempstack.pop();
                    tempstack.push(sign);
                    if (sign == "+") tempstack.pop();
                    if (sign == "-") {
                        tempstack.pop();
                        var num = tempstack.pop();
                        num = -1 * num;
                        tempstack.push(num);
                    }
                }
                var answer = this.evaluateString(tempstack.reverse());
                stack.push(answer[0]);
            }
        }
        var result = eval(stack[0]);
        return result.toFixed(2);
    }
}
//==========End Expression evaluation for Formula===========

function formulaExpression(expression, questionId, isLedger,arr) {
    var expressionTrimed = jQuery.trim(expression);
    for (var i = 0; i < expressionTrimed.length; i++) {
        if (expressionTrimed.charAt(i) == '$') {
            for (var k = i + 1; k < expressionTrimed.length; k++) {
                if (expressionTrimed.charAt(k) == '$') {
                    var variable = expressionTrimed.substring(i + 1, k);
                    var varValue = 0;
                    if (isLedger && typeof(ledgerMap) != 'undefined') {
                            varValue = ledgerMap[questionId.substring(0, questionId.lastIndexOf("_row_")) + "_" + variable];
                    } else {
                    if(arr){
                           varValue = arr[variable]
                        }else{
                            varValue = getVariables(questionId, variable);
                        }
                    }
                    expressionTrimed = expressionTrimed.replace("$" + variable + "$", varValue.toString());
                    i += varValue.toString().length-1;
                    break;
                }
            }
        }
    }
    return expressionTrimed;
}

function renderFormula(expression, questionId, isLedger, arr, formulaID){
  if (!isVariablesInited) {
      setTimeout(function(){renderFormula(expression, questionId, isLedger, arr, formulaID);}, 100);
      return;
  }
  var formula = new Formula();
  var expression = formulaExpression(expression, questionId, isLedger, arr);
  var result = formula.expressionEvaluate(expression);
  jQuery("#" + formulaID).html(result);
};

function numbersOnly(myfield, e, dec) {
    var key;
    var keychar;

    if (window.event)
        key = window.event.keyCode;
    else if (e)
        key = e.which;
    else
        return true;
    keychar = String.fromCharCode(key);

    // control keys
    /* Allow 0123456789,.-() and the same on numpad */

    if (key == null || key == 0 || key == 8 ||
        key == 9 || key == 13 || key == 27 ||
        (key >= 35 && key <= 40) || key == 46 || key == 144 ||
        key == 48 || key == 57 || (key >= 96  && key <= 105)) {  // also add 9(, 0) keys
        return true;
    }

    if (((key >= 48 && key <= 57) ||
         key == 109 ||  key == 110 ||
         (key >= 188 && key <= 190))
        && !e.shiftKey) {
        return true;
    }

    // decimal point jump
    if (dec && (keychar == "."))
    {
        myfield.form.elements[dec].focus();
        return false;
    }
    else
        return false;
}

//updated getURLParam
function getURLParam(strParamName) {
    strParamName = strParamName.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
    var regexS = "[\\?&]"+strParamName+"=([^&#]*)";
    var regex = new RegExp(regexS);
    var strReturn = regex.exec(window.location.href);
    if(strReturn == null)
        return "";
    else
        return strReturn[1];
}


// this is a small helper extension
jQuery.fn.reverse = function() {
    return this.pushStack(this.get().reverse(), arguments);
};

// create two new functions: prevALL and nextALL.
jQuery.each( ["prev", "next"], function(index, name) {
    jQuery.fn[ name + "ALL" ] = function(matchExpr) {
        // get all the elements in the body, including the body.
        var all = jQuery("#Acontent", parent.document);
        all = all.add(jQuery("*", document));

        // slice the all object accordingly
        all = (name == "prev")
             ? all.slice(0, all.index(this)).reverse()
             : all.slice(all.index(this) + 1);

        // filter the matches if specified
        if (matchExpr) {
            all = all.filter(matchExpr);
        }
        return all;
    };
});

/**
* find middle value of array
* used in ImageMap and ImageMapQuiz
*/
function findCenterPoly(arr,wh){
    var i = wh; // 0 - width, 1 - height

    if(arr.length == 3) return parseInt(arr[i]); // circle

    var min = max = parseInt(arr[i]);
    i=i+2;

    while(arr[i] !== undefined){   // polygon, rect
     if(parseInt(arr[i])<min) min = parseInt(arr[i]);
     if(parseInt(arr[i])>max) max = parseInt(arr[i]);
    i=i+2;
    }
    return (min + (max-min)/2);
}

/**
*  scale Image inside Slide
*
*/
function scaleImgInSlide(id){
    var img = jQuery('#'+id+'img')
    var imgDiv = jQuery('#'+id)
    var imgH = img.height();
    var imgW = img.width();
    var slide = img.parents('div.SlideHeightTopic');
    var slideW = slide.width() - 75;
    var slideH = slide.height() - slide.children('div.SlideTitleTopic').outerHeight(true) - 40;

    if((imgH > slideH) && (imgW > slideW)){
        if((slideW * imgH)/imgW > slideH){
            img.attr('height',slideH);
            img.attr('width',(slideH * imgW)/imgH);
        }else{
            img.attr('width',slideW);
            img.attr('height',(slideW * imgH)/imgW);
        }
    }else{
        if(imgH > slideH){
            img.attr('height',slideH);
            img.attr('width',(imgW * slideH)/imgH);
        }else{
            if(imgW > slideW){
                img.attr('width',slideW);
                img.attr('height',(imgH * slideW)/imgW);
            }
        }
    }
    imgDiv.css('textAlign','left')
}

// Equation rendering
var Equations = new Array();
var EquationsPos = new Array();

function renderEquations(numb) {
    var i = 0;
    if (typeof(numb) != 'undefined' && parseInt(numb) > 0) {
        i = numb;
    }
    var obj = jQuery("#" + EquationsPos[i]);
    if (obj){
        obj.html("<img alt='Loading equation...' src='" + Equations[i] + "' border='0'/>");
    }
    if (i < Equations.length - 1) {
        setTimeout("renderEquations(" + (i + 1) + ")", 300);
    }
}

jQuery.fn.getBackgroundColor = function(){
	var e = jQuery(this);
	var v = e.css("background-color");
	while (!v || v == 'transparent' || v == '#000000' || v == 'rgba(0, 0, 0, 0)'){
    	if(e[0].nodeName == "BODY") { 
			v = '#fff'; 
			break;
		}	
		else {
    		e = e.parent();
			v = e.css("background-color");
    	}
	}
	return v;
}

function rgbToHex(colorval) {
    var parts = colorval.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
	delete(parts[0]);
    for (var i = 1; i <= 3; ++i) {
        parts[i] = parseInt(parts[i]).toString(16);
        if (parts[i].length == 1) parts[i] = '0' + parts[i];
    }
    return color = '#' + parts.join('');
}


function openCrossRefEPUB(num){
    jQuery('[aria-labelledby=ui-dialog-title-Xref_content_' + num + "]").css('display','block').css('top', '0px').css('left','0px').css('width','95%');
}

function initXrefPopup(){
    jQuery('a[id^="Xref_link_"], div[id^="Xref_link_"]').each(function (popupNumber) {
        initializeDialog('#Xref_content_' + popupNumber, 'Xref-modal-content');
        // Xref Link
        jQuery("#Xref_link_" + popupNumber).live('click', function(e){
            showDialog('#Xref_content_' + popupNumber);
        });
    });
}

function initializeDialog(contentId, contentClass){
    jQuery(contentId).dialog({
        autoOpen: false,
        modal: true,
        closeOnEscape: false,
        minWidth: 400,
        minHeight: 300,
    open: function(event, ui) {
        var proper_IE8  = (((navigator.appVersion.indexOf("MSIE") != -1) && (parseFloat(navigator.appVersion.split("MSIE")[1]) == 8))) || (document.documentMode == 8) ? true : false,
        IE_QuirksMode = (document.compatMode == 'BackCompat' || document.documentMode == 5) ? true : false;

        if ( proper_IE8 || IE_QuirksMode) {
            jQuery(this).width('auto').height('auto');
        }
        if(jQuery(this).attr('src') == ""){
             // only for xref
            jQuery(this).attr('src', jQuery(this).attr('data-xrefuri'));
        }
        jQuery(document).bind('keyup.' + contentClass, function (e) {
            if (e.keyCode == 27) { // ESC
                e.stopPropagation();
                jQuery(contentId).dialog('close')
            }
        })
    },
    create: function () {
        if (!isIE7) {
            jQuery(this)
            .dialog('option', "show", "drop")
            .dialog('option', "hide", "drop");
        }
    },
    beforeClose: function(event, ui){
        jQuery(document).unbind('keyup.' + contentClass);
    }
    });

}

function showDialog(contentId){
    var xheight = 0, xwidth = 0;
    try{ // only for xref
        xheight = ExtractNumber(jQuery(".XrefDialog").css("height"));   // check for custom width and height
        xwidth = ExtractNumber(jQuery(".XrefDialog").css("width"));
    }catch(e){}
    if (xwidth == 0 ){  // if 0 than set default width
        xwidth = 800;
    }
    var cWidth = parent.content ? parent.document.getElementById("content").offsetWidth : jQuery('html').width();
    cWidth = cWidth > 400 ? cWidth : 400;
    xwidth = (cWidth > (xwidth + xwidth/10)) ? xwidth : (cWidth - cWidth/10);
    if (xheight == 0){  // if 0 than set default height
        xheight = 600;
    }
    var cHeight = parent.content ? parent.document.getElementById("content").offsetHeight : jQuery('html').height();
    cHeight = cHeight > 300 ? cHeight : 300;
    xheight = (cHeight > (xheight + xheight/5)) ? xheight : (cHeight - cHeight/5);
    jQuery(contentId).dialog( "option", "width", xwidth );
    jQuery(contentId).dialog( "option", "height", xheight );
    jQuery(".ui-dialog-content:visible").dialog("close");
    jQuery(contentId).dialog('open');
} 

function initInLineHotText(){

    jQuery.each(jQuery('div[id$="_hottext"]'), function () {
        var elem      = jQuery(this),
            content   = jQuery('#' + elem.attr('id') + '_message'),
            width     = elem.attr('data-custom-width'),
            height    = elem.attr('data-custom-height'),
            popupElem = elem.find('.WysiwygInLineHotTextMessage'),
            oldParent = popupElem.parent(),
            newDialog;

        width = ('' == width) ? 0: width;
        height = ('' == height) ? 0: height;

        if (popupElem.length > 0){
            elem.addClass("XylemeLink");

            if (elem.attr('data-trigger') == "click"){// onClick
                newDialog = popupElem.dialog({
                    autoOpen: false,
                    show: "fade",
                    hide: "fade",
                    title: "",
                    minHeight: 26
                });

		/* Here, we will insert the dialog outside of the original containing
	         * element, because the original containing element will have the
	         * "click" event below to open/close the dialog.
	         */
                newDialog.dialog('widget').insertAfter(oldParent);

                elem.bind('click', function(e) {
                    jQuery(".ui-dialog-content:visible").dialog("close");
                    jQuery("#ui-dialog-title-" + popupElem.attr("id")).height(0);

                    if (width != 0){
                        newDialog.dialog( "option", "width", width);
                    }

                    if (height != 0){
                        newDialog.dialog( "option", "height", height);
                    }
                    newDialog.dialog('open');
                    newDialog.dialog("option", { position: [e.pageX+5, (e.pageY+5) - jQuery(document).scrollTop()]});
                });

            } else {// roll-over
                newDialog = elem.find('.WysiwygInLineHotTextMessage').dialog({
                    autoOpen: false,
                    show: "fade",
                    hide: "fade",
                    resizable: false,
                    minHeight: 26,
                    create: function (event, ui) {
                        jQuery("#ui-dialog-title-" + popupElem.attr("id")).parent().hide();
                    }
                });

		/* Here, we will insert the dialog outside of the original containing
	         * element, because the original containing element will have the
	         * "click" event below to open/close the dialog.
	         */
                newDialog.dialog('widget').insertAfter(oldParent);

                elem.hover(function (e) {
                    jQuery(".ui-dialog-content:visible").dialog("close");

                    if (width != 0){
                        newDialog.dialog( "option", "width", width);
                    }

                    if (height != 0){
                        newDialog.dialog( "option", "height", height);
                    }
                    newDialog.dialog("option", { position: [e.pageX+5, (e.pageY+5) - jQuery(document).scrollTop()]});
                    newDialog.dialog('open');
                }, function () {
                    newDialog.dialog('close');
                });
            }
        }
    });
}

function initInLineTerm(){

    jQuery.each(jQuery('div[id$="_inlineterm"]'), function () {
        var elem      = jQuery(this),// This is the term link
            title     = elem.find('#inlinetermTerm').html(),
            oldPop    = elem.find('#inlinedialog'),
            oldParent = oldPop.parent(),
            newDialog = oldPop.dialog({
                title: title,
                autoOpen: false,
                show: "fade",
                hide: "fade",
                minHeight: 36
            });

        /* Here, we will insert the dialog outside of the original containing
         * element, because the original containing element will have the
         * "click" event below to open/close the dialog.
         */
        newDialog.dialog('widget').insertAfter(elem);
        elem.bind('click', function(e) {

            if(!newDialog.dialog('isOpen')) {
                jQuery(".ui-dialog-content:visible").dialog("close");
                newDialog.dialog('open');
                newDialog.dialog("option", { position: [e.pageX+5, (e.pageY+5) - jQuery(document).scrollTop()]});

            } else {
                newDialog.dialog('close');
            }
        });

    });
}

function initGlossaryPopUp() {

    jQuery.each(jQuery('div[id$="_popup"]'), function () {
        var elem      = jQuery(this),
            title     = elem.find('#glossaryTitle').html(),
            oldPopup  = elem.find('#glossaryDialog'),
            oldParent = oldPopup.parent(),
            newDialog = oldPopup.dialog({
                title: title,
                autoOpen: false,
                show: "fade",
                hide: "fade",
                minHeight: 36
            });

        oldParent.append(newDialog.dialog('widget'));
        elem.bind('click', function(e){

            if(!newDialog.dialog('isOpen')) {
                jQuery(".ui-dialog-content:visible").dialog("close");
                newDialog.dialog('open');
                newDialog.dialog("option", { position: [e.pageX+5, (e.pageY+5) - jQuery(document).scrollTop()]});

            } else {
                newDialog.dialog('close');
            }
        });

    });
}

function initFootnotePopUp() {

    jQuery.each(jQuery('.WysiwygFootnote'), function (noteNumber) {
        var elem      = jQuery(this),
            noteId    = elem.attr('id'),
            oldPop    = jQuery('#'+noteId+'pop'),
            content   = oldPop.find('.PopupContent').html(),
            title     = oldPop.find('.PopupTitle').first().html(),
            newDialog = jQuery('<div />').attr('id', oldPop.attr('id')).
                addClass('footnote'+noteNumber+'-popup').dialog({
                    title: title,
                    autoOpen: false,
                    show: "fade",
                    hide: "fade",
                    minHeight: 36
            }).html(content);

        /* Here we need to replace the old popup with the new one in the DOM.
         * This is required for Review Session, as it needs the parent element's
         * GUID for reference, and jQuery UI moves the new dialog outside of the
         * course by default.
         */
        oldPop.replaceWith(newDialog.dialog('widget'));
        elem.unbind('mousedown');// Cancel showPopup()

        elem.bind('click', function(e){

            if(!newDialog.dialog('isOpen')) {
                jQuery(".ui-dialog-content:visible").dialog("close");
                newDialog.dialog('open');
                newDialog.dialog("option", { position: [e.pageX+5, (e.pageY+5) - jQuery(document).scrollTop()]});

            } else {
                newDialog.dialog('close');
            }
        });

    });
}

function initMarginNotePopUp() {

    jQuery.each(jQuery('div[id^="Note"]'), function (noteNumber) {
        var elem        = jQuery(this).find('a').first(),
            noteImg     = elem.find('img'),
            noteId      = noteImg.attr('id'),
            oldPop      = jQuery('#'+noteId+'pop'),
            content     = oldPop.find('.PopupContent').html(),
            title       = oldPop.find('.PopupTitle').first().html(),
            newDialog   = jQuery('<div />').attr('id', oldPop.attr('id')).
                addClass('Note'+noteNumber+'-popup').
                dialog({
                    title: title,
                    autoOpen: false,
                    show: "fade",
                    hide: "fade",
                    minHeight: 36
                }).html(content);
        noteImg.unbind('mousedown');// Cancel showPopup()

        /* Here we need to replace the old popup with the new one in the DOM.
         * This is required for Review Session, as it needs the parent element's
         * GUID for reference, and jQuery UI moves the new dialog outside of the
         * course by default.
         */
        oldPop.replaceWith(newDialog.dialog('widget'));

        elem.bind('click', function(e) {

            if(!newDialog.dialog('isOpen')) {
                jQuery(".ui-dialog-content:visible").dialog("close");
                newDialog.dialog('open');
                newDialog.dialog("option", {
                    position: [e.pageX+5, (e.pageY+5) - jQuery(document).scrollTop()]
                });

            } else {
                newDialog.dialog('close');
            }
        });
    });
}

function initMarginGlossaryTermPopUp() {
    jQuery.each(jQuery('div[id^="GlossaryItem"][id!="GlossaryItems"]'), function (noteNumber) {
        var elem      = jQuery(this).find('a').first(),
            noteId    = elem.find('img').attr('id'),
            oldPop    = jQuery('#'+noteId+'pop'),
            content   = oldPop.find('.GlossaryDef').html(),
            title     = oldPop.find('.PopupTitle').first().html(),
            newDialog = jQuery('<div />').attr('id', oldPop.attr('id')).
                addClass('Note'+noteNumber+'-popup').dialog({
                title: title,
                autoOpen: false,
                show: "fade",
                hide: "fade",
                minHeight: 36
            }).html(content);

        /* Here we need to replace the old popup with the new one in the DOM.
         * This is required for Review Session, as it needs the parent element's
         * GUID for reference, and jQuery UI moves the new dialog outside of the
         * course by default.
         */
        oldPop.replaceWith(newDialog.dialog('widget'));
        elem.children('img').unbind('mousedown');// Cancel showPopup()

        elem.bind('click', function(e){
            if(!newDialog.dialog('isOpen')) {
                jQuery(".ui-dialog-content:visible").dialog("close");
                newDialog.dialog('open');
                newDialog.dialog("option", { position: [e.pageX+5, (e.pageY+5) - jQuery(document).scrollTop()]});
            } else {
                newDialog.dialog('close');
            }
        });

    });
}

function modifyStage(){
    jQuery('div.stage').each(function (stageNumber) {
        var shouldModify = jQuery(this).attr('data-modify');
        if (shouldModify != null && shouldModify == '1'){
            var current = jQuery(this);
            do {
                current = current.parent();
                jQuery(current).css({'height' : '100%', 'min-height' : '100%', 'max-height' : '100%', 'margin' : '0', 'padding' : '0'});
            } while (current[0].tagName.toLowerCase() != 'html');
        }
    });
}

function updateInLineBlock(){
    // CP-6188
    if(jQuery.browser.msie && parseInt(jQuery.browser.version, 10) == 7) {
        jQuery('.inlineblock').each(function () {
            var elem = jQuery(this);
            jQuery(elem).addClass('inlineblockIE7');
        });
    }
}

/**
* Replace object/embed tags with html5 video tag
* @param String {id} - div element id which contains object/embed tags
* @param Object {videoParams} - video params
*/
function addHtml5Video(id, videoParams){

    var videoTag = '<video id="' + id + '" width="'+ videoParams.mediaWidth +'" height="' + videoParams.mediaHeight + '" preload="auto"';
        if(videoParams.autoplay == 'true'){
            videoTag += ' autoplay="autoplay"';
        }
        if(videoParams.controls == 'true'){
            videoTag += ' controls="controls"';
        }
        videoTag += '>';
        videoTag += '<source src="' + videoParams.mediaURI + '" type=\'video/mp4; codecs="avc1.42E01E, mp4a.40.2"\' />'
        videoTag += '</video>';

        jQuery('#' + id).replaceWith(videoTag);

        if(videoParams.altText != ''){
            jQuery('#' + id).bind({
                mouseover : function(e){
                    Tip(videoParams.altText , SHADOW, true,PADDING,3);
                },
                mouseout : function(e){
                    UnTip();
                }
            });
        }
}

/**
*  Base64 encode / decode
*  http://www.webtoolkit.info/
**/

Base64 = new function() {

// private properties
var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    // public method for encoding
    encode = function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = _utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
            _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
            _keyStr.charAt(enc3) + _keyStr.charAt(enc4);

        }

        return output;
    },

    // public method for decoding
    decode = function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = _utf8_decode(output);

        return output;

    },

    // private method for UTF-8 encoding
    _utf8_encode = function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    // private method for UTF-8 decoding
    _utf8_decode = function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    };
    return {
        encode : encode,
        decode : decode
    }

}

function initBase64() {
    var $ = jQuery,
        elems = $('*[data-base64=true]');

        

    elems.each(function(i){
        var $this     = $(this),
            data_attr = $this.attr('data-wab_correct_answer'),
            attr      = $this.attr('wab_correct_answer'),
            pattern   = $this.attr('patterntext')

        if (data_attr != undefined) { // SelectHotText && WebMultipleChoise
            $this.attr('data-wab_correct_answer', Base64.encode(data_attr));
        } else if (attr != undefined) { // WebSequenceActivity
            $this.attr('wab_correct_answer', Base64.encode(attr));
        } else if (pattern != undefined) { // WebFillInBlank
            $this.attr('patterntext', Base64.encode(pattern));
        } else { // other elements + children
            var encoded = false;
            (function encodeChildren($children) {
                $children.each(function(){

                    var $current       = $(this), 
                        $child_nodes   = $current.children().remove(), 
                        text           = $current.text();

                    // prevent double encoding of child elems
                    if ($current.attr('data-base64') == 'true' && encoded == true) { 
                        return;
                    }
                        
                    text = Base64.encode(text);
                    $current.text(text).append($child_nodes);

                    if ($current.children().length != 0) {
                        encoded = true;
                        encodeChildren($current.children());
                    }
                    encoded = false;
                });
            }($this));
        }
    });
}

var initListAnimation_buttons = function() {
    var $ = jQuery;

    jQuery('.List').each(function (timing) {

        var $list = jQuery(this),
            type = $list.attr("data-build"),
            $placeholder = jQuery('<div>Click here to show List</div>').addClass('list-placeholder');

            

            switch (type) {
                case 'AllAtOnce' : // Whole List is shown at one click
                    
                    $list.hide();

                    var AllAtOncePlaceholder = $placeholder;

                    $list.after($placeholder);

                    AllAtOncePlaceholder.bind('click', function() {
                        AllAtOncePlaceholder.slideUp(2000);
                        $list.show(2000);       
                    });// end click
                break;
                case 'OneAtTime' : //show list item on "placeholder" click

                    var OneAtTimePlaceholder = $placeholder;

                    $list
                        .find('table.UnorderedTable:first > tbody > tr')    
                        .each(function(){
                            jQuery(this).hide();
                        })
                        .end()
                        .show()
                        .after(OneAtTimePlaceholder);

                    OneAtTimePlaceholder.bind('click', function() {

                        OneAtTimePlaceholder.text('Click to show next item');
                        $list
                        .find('table.UnorderedTable:first > tbody > tr')
                        .each(function(index) {
                            $this = jQuery(this);
                            if ( $this.css('display') == 'none' ) {

                                $this.show().find('td > ul').first().hide().slideDown(1000);

                                if (index == $list.find('table.UnorderedTable:first > tbody > tr').length - 1) {
                                    OneAtTimePlaceholder.slideUp(1500);
                                }
                                return false;
                            }
                        });// end each          

                    });// end click
                break;
                case 'OneAtTimeEmphasize' : // show list item on "placeholder" click and hide on next click
                    var OneAtTimeEmphasizePlaceholder = $placeholder,
                        currentItemIndex = 0;

                    $list
                        .find('table.UnorderedTable:first > tbody > tr')    
                        .each(function(){
                            jQuery(this).hide();
                        })
                        .end()
                        .show()
                        .after(OneAtTimeEmphasizePlaceholder);

                    OneAtTimeEmphasizePlaceholder.bind('click', function() {
                        
                        $list
                        .find('table.UnorderedTable:first > tbody > tr')
                        .each(function(index) {
                            $this = jQuery(this);
                            if ( $this.css('display') == 'none' ) {

                                $this.show().find('td > ul').first().hide().slideDown(1000);
                                if (!isIE6 || !isIE7 || !isIE8 ){
                                    OneAtTimeEmphasizePlaceholder.text('Click to fade the item');
                                } else {
                                    OneAtTimeEmphasizePlaceholder.text('Click to show next item');
                                }
                                return false;
                            } else {
                                if (!isIE6 || !isIE7 || !isIE8 ){
                                    if (index == currentItemIndex) {
                                        $this.fadeTo(1500, .2 );
                                        currentItemIndex++;
                                        OneAtTimeEmphasizePlaceholder.text('Click to show next item');

                                        if (index == $list.find('table.UnorderedTable:first > tbody > tr').length - 1) {
                                            OneAtTimeEmphasizePlaceholder.slideUp(1000);
                                        }
                                            return false;
                                    }
                                }
                            }

                        });// end each              
                    });// end click
                break;
                default :
                    $list.show();
            }// end switch

    });// end .each()
}// end initListAnimation()

var initListAnimation_click = function() {
    var currentItemIndex = 0,
        // timings for anuimations in ms
        timing = {
            AllAtOnce                   : 2000,
            OneAtTime                   : 1000,
            OneAtTimeEmphasize          : 1000,
            OneAtTimeEmphasize_fading   : 800
        };

    //remove functionality in IE7
    if (isIE7) {
        return;
    }

    // click on blank space
    jQuery(document).bind('click', function(e) {

        // IGNORE SOME CLICK EVENTS

        // ignore click on some specified elements(links, buttons, etc) 
        var target = e.target || e.srcElement,
            tag = target.tagName.toLowerCase();
            ignored_tags = 'a img input span';

        if (ignored_tags.indexOf(tag) != -1) {
            return;
        }

        // ignore click on popup
        var on_popup = false;
        if (jQuery(target).attr('id')){
            on_popup = jQuery(target).attr('id').indexOf('popup') != 1;
        }
            
        if (on_popup) {
            return;
        }

        // DO ANIMATIONS
        var currentItem = jQuery(this).find('.List > table > tbody > tr').eq(currentItemIndex),
            type = currentItem.parents('.List').attr('data-build');

            switch (type) {
                case 'AllAtOnce' :
                    // show whole list
                    currentItem
                    .parents('.List')
                    .hide()
                    .find('table:first > tbody > tr')
                    .show()
                    .end()
                    .slideDown(timing.AllAtOnce);

                    // increase currentItemIndex
                    var len = currentItem.parent().children().length;
                    currentItemIndex += len;

                break;
                case 'OneAtTime' :
                    // show only current list item
                    currentItem
                    .show()
                    .find('td > ul').first()
                    .hide()
                    .slideDown(timing.OneAtTime);
                    currentItemIndex++;
                break;
                case 'OneAtTimeEmphasize' :
                    // if current list item in hidden then show it, else fade down
                    if (currentItem.is(':hidden')) {
                        currentItem
                        .show()
                        .find('td > ul').first()
                        .hide()
                        .slideDown(timing.OneAtTimeEmphasize);
                    } else {
                        currentItem.children('td').eq(1).fadeTo(timing.OneAtTimeEmphasize_fading, .2);
                        currentItemIndex++;
                    }

                break;
                default :
                    // do nothing
            }

    });

}//end initListAnimation_click()


function showConfirmationDialog( langActivityIsNotComplete, langOk, langCancel, callback ){
	if(!jQuery("#activityIsNotComplete").length){ // do not show more than one confirmation dialog at the moment
		jQuery('<div id="activityIsNotComplete">' + langActivityIsNotComplete + '</div>').dialog({
			show: 'fade',
			hide: 'fade',
			close: function() {
				jQuery(this).dialog('destroy');
				jQuery("#activityIsNotComplete" ).remove();
			},
			resizable: true,
			height: 250,
			modal: true,
			buttons: [   
						{
							text : langOk,
							click : function() {
								jQuery( this ).dialog( "close" );
								CRE.busy = false;
								CRE.updateNavigation();
							}
						},
						{
							text: langCancel,
							click : function() {
								jQuery( this ).dialog( "close" );
								CRE.navigationRequestedFlag = true;
								if (CRE.ContentFrame.unload)
									CRE.ContentFrame.unload();
								CRE.navigationRequestedFlag = false;
								if(jQuery.isFunction(callback))
									callback();
							}
						}	
			]
		});
	}
}

function generateMediaPlayerObjects() {
    var mediaObjects = jQuery("embed, object", document).
          add(jQuery("iframe", document).contents().find("embed, object")),
        newPlayers = jQuery('.mediaObject_player').add(jQuery("iframe", document).
            contents().find(".mediaObject_player")),
        current, controlsJs, id, playerMode, player, ext, that;

        mediaObjects.add(newPlayers);
		var mutedStatus = window.parent.SKIN_API && window.parent.SKIN_API.getValue("muted") ? true : false;		
		
        newPlayers.each(function (k, v) {
            playerMode = 'auto';
            that = jQuery(this);

            // For MP3s in IE10 with autoplay set to true, the file plays before transformation
            if (this.pause) {
                this.pause();
            }

            /*
             * Begin to check playback capabilities. If no HTML5 and no Flash/Silverlight,
             * then we will try for WMP, if no WMP, we will try QuickTime,
             * if no QuickTime, we will let MediaElement JS take care of trying
             * to download the file.
             */

             ext = this.src.match(/\w+$/)[0].toLowerCase();

             this.alt = this.alt || '';

            if (!mejs.PluginDetector.determineBaseCapabilities(ext)) {
                mejs.PluginDetector.determineExtraFallback({
                mediaURI: this.src,
                ext: ext,
                mediaWidth: this.width,
                mediaHeight: this.height,
                autoplay: this.autoplay,
                controls: this.controls,
                altText: this.alt,
                replaceID: this.id
              }, ext);
            }

            controlsJs = this.controls ? ['playpause','current','progress','duration','tracks','volume','fullscreen'] : [''];

            // Necessary to force IE and Firefox into fallback mode
            if (mejs.MediaFeatures.isIE || mejs.MediaFeatures.isFirefox) {
              playerMode = 'shim';
            }

            if (window.XyMediaObject.useAdaptiveJsPlayer) {
              player = new MediaElementPlayer('#' + this.id, {
                features: controlsJs,
                mode: playerMode,
				muted: mutedStatus,
                pluginPath: 'ContentPackages/Core/Transforms/media/mediaPlayer_core/'
                // Disabled in case of API version mismatch
                // success: function (mediaElement, domObject) {
                //   mediaElement.addEventListener('ended', function () {
                //     Navigation.enable();
                //   });
                // }
              });
							  
              this.mediaApi = player;
            }
     });
}
/*
 * MediaElement JS media player extensions
 */
function extendMediaElementJs () {

    /*
     * Stub object used in the case that HtmlShared.xsl or Deployment configs 
     * are overridden in a client's overlay. This stub will help avoid exceptions
     * but the new media player will still not work.
     */
    var mejs = window.mejs || {

        PluginDetector: {
            plugins: []
        },

        HtmlMediaElementShim: {}
    };

    // Add a quick an easy method to check for native/flash/silverlight capabilities
    mejs.PluginDetector.determineBaseCapabilities = function (ext) {
        // We always want to delegate MOV files to quicktime, so return false.
        var capable = (ext === 'mov') ? false : true;

        if (!mejs.MediaFeatures.supportsMediaTag || mejs.MediaFeatures.isIE || mejs.MediaFeatures.isFirefox) {

            if (!mejs.PluginDetector.plugins['flash'] &&
                !mejs.PluginDetector.plugins['silverlight'])
            {
                capable = false;

            /*
             * MediaElement JS returns a version number of [0,0,0] instead 
             * of nothing when plugin is determined by Active X, so we need
             * to provide for that possibility in IE
            */
            } else if ((mejs.PluginDetector.plugins['flash'][0] === 0) &&
                      (mejs.PluginDetector.plugins['silverlight'][0] === 0)
            ) {
                capable = false;
            }

        /*
         * Otherwise, if we have a WMV file, but silverlight is not available,
         * we need to fallback to WMP, so we report that the browser is NOT capable
         */
        } else if (
            ext === 'wmv' &&
            (!mejs.PluginDetector.plugins['silverlight'] ||
            mejs.PluginDetector.plugins['silverlight'][0] === 0)
            ) {
            capable = false;
        }

        return capable;

    };

    mejs.HtmlMediaElementShim.generateWmp = function (options) {
        var embedCode = '';

        options.uiMode = (options.controls) ? 'all' : 'none';
        options.mediaHeight = (+options.mediaHeight)+15;
        embedCode = '<object id="'+ options.replaceID + '" name="'+ options.replaceID + '"' +
              'classid="clsid:22d6f312-b0f6-11d0-94ab-0080c74c7e95"' +
              'type="application/x-oleobject" width="' + options.mediaWidth + '" height="' + options.mediaHeight + '"' +
              'codebase="//activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#version=5,1,52,701"' +
              'standby="Loading Microsoft Windows Media Player components..." >' +
              '<param name="filename" value="' + options.mediaURI + '" />' +
              '<param name="url" value="' + options.mediaURI + '" />' +
              '<param name="AutoStart" value="' + options.autoplay + '" />' +
              '<param name="AnimationAtStart" value="true" />' +
              '<param name="TransparentAtStart" value="true" />' +
              '<param name="enabled" value="true" />' +
              '<param name="ShowControls" value="' + options.controls + '" />' +
              '<param name="uiMode" value="' + options.uiMode + '" />' +
              '<param name="wmode" value="transparent" />' +
              //'<param name="windowlessVideo" value="-1" > </param>' +

              '<!-- For other browsers * Windows Media Player -->' +
              '<object id="'+ options.replaceID + '" name="'+ options.replaceID + '"' +
                'src="' + options.mediaURI + '"' +
                'width="' + options.mediaWidth + '" height="' + options.mediaHeight + '"  type="application/x-ms-wmp" wmode="transparent">' +
                '<param name="AutoStart" value="' + options.autoplay + '"> </param>' +
                '<param name="AnimationAtStart" value="true"> </param>' +
                '<param name="TransparentAtStart" value="true"> </param>' +
                '<param name="ShowControls" value="' + options.controls + '"> </param>' +
                '<param name="uiMode" value="' + options.uiMode + '" />' +
                '<param name="wmode" value="transparent"> </param>' +
                '<p>Please install <a href="//port25.technet.com/pages/windows-media-player-firefox-plugin-download.aspx">Windows Media Player Plugin</a></p>' +
              '</object>' +
            '</object>';

            jQuery('#' + options.replaceID).replaceWith(embedCode);

            /*
             * This is arbitrary setup JS pulled from the MO-MediaPlayer template
             * in MediaObjectLib.xsl.
             * I feel like it should be burned and put out of its misery.
             * Running in a closure to keep things safe.
             */
            (function () {
                var player=false
                function setup() {

                  if (!player) {
                      var p1=document.getElementsByName(options.replaceID);

                      for (var x=0; x<p1.length; x++) {

                        if (p1[x].controls) {
                            player=p1[x];
                            break;
                          }
                      }
                  }
                };

                window.muteSound = function() {
                setup();
                player.settings.mute = true;
                };

                window.unmuteSound = function() {
                setup();
                player.settings.mute = false;
                };

                function init() {
                var player = document.getElementsByName(options.replaceID)[0];

                if (player.attachEvent)
                    player.attachEvent("playStateChange",OnDSPlayStateChangeEvt);
                };

                function OnDSPlayStateChangeEvt(NewState) {

                if (parent.muted) {
                  setup();

                  if (player.settings)
                    player.settings.mute = true;
                  }
                };

                init();
            }());

            return jQuery('#' + options.replaceID);
    };

    mejs.HtmlMediaElementShim.generateWmpVideo = function () {};

    mejs.HtmlMediaElementShim.generateQuicktime = function (options) {
        var embedCode = '';

        embedCode = '<object id="' + options.replaceID + '_source" classid="clsid:CB927D12-4FF7-4a9e-A169-56E4B8A75598" codebase="//www.apple.com/qtactivex/qtplugin.cab#version=7,2,1,0" style="display:none; position: absolute; left: -500px; top: -500px; visibility: hidden; width: 1px; height: 1px;"></object>' +
            '<object id="' + options.replaceID + '" classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B" ' +
            'codebase="//www.apple.com/qtactivex/qtplugin.cab" width="' + options.mediaWidth + '" height="' + options.mediaHeight + '" ' +
            'style="behavior:url(#' + options.replaceID + '_source);">' +
              '<param name="src" value="' + options.mediaURI + '"> </param>' +
              '<param name="autoplay" value="' + options.autoplay + '"> </param>' +
              '<param name="scale" value="aspect"> </param>' +
              '<param name="cache" value="TRUE"> </param>' +
              '<param name="type" value="video/quicktime"> </param>' +
              '<param name="controller" value="' + options.controls + '"> </param>' +
              '<param name="enablejavascript" value="TRUE"> </param>' +
              '<param name="postdomevents" value="TRUE"> </param>' +
              '<param name="flashvars"  value="startOnLoad=' + options.autoStart + '"/>' +
              '<embed src="' + options.mediaURI + '" flashvars="startOnLoad=' + options.autoStart + '" width="' + options.mediaWidth + '" height="' + options.mediaHeight + '" id="player_emb" name="player" type="video/quicktime" pluginspage="http://www.apple.com/quicktime/download" autoplay="' + options.autoplay + '" scale="aspect" cache="TRUE" controller="' + options.controls + '" enablejavascript="TRUE" postdomevents="true"> </embed>' +
            '</object>';

        return jQuery('#' + options.replaceID).replaceWith(embedCode);
    };

    mejs.HtmlMediaElementShim.generateQuicktimeVideo = function () {};

    // Extend the default MediaElementJS detect/add Plugin methods. Adds fuzzy search.
    mejs.PluginDetector.addPluginExtend = function (p, pluginName, mimeType, activeX, axDetect) {
        var versionRet = mejs.PluginDetector.detectPluginExtend(pluginName, mimeType, activeX, axDetect);
        
        if (versionRet) {
             mejs.PluginDetector.plugins[p] = [versionRet];
        }
    };

    mejs.PluginDetector.detectPluginExtend = function (pluginName, mimeType, activeX, axDetect) {

        var version = null,
        description,
        i,
        ax;

        // Firefox, Webkit, Opera
        if (typeof(window.navigator.plugins) != 'undefined' && typeof window.navigator.plugins[pluginName] == 'object') {
            description = window.navigator.plugins[pluginName].description;

            if (description && !(typeof window.navigator.mimeTypes != 'undefined' && window.navigator.mimeTypes[mimeType] && !window.navigator.mimeTypes[mimeType].enabledPlugin)) {
                version = description.replace(pluginName, '').replace(/^\s+/,'').replace(/\sr/gi,'.').split('.');

                for (i=0; i<version.length; i++) {
                    version[i] = parseInt(version[i].match(/\d+/), 10);
                }
            }

        // Internet Explorer / ActiveX
        } else if (typeof(window.ActiveXObject) != 'undefined') {
            try {
              ax = new ActiveXObject(activeX);
              if (ax) {
                version = axDetect(ax);
                }
            } catch (e) { }

        } else {

        // Added by Dale, uses indexOf for fuzzy plugin name searching (needed for WMP and QuickTime as their names sometimes include version numbers)
            if (typeof(window.navigator.plugins) != 'undefined') {

                for (var x = 0, amount = window.navigator.plugins.length; x < amount; x++) {

                    if (window.navigator.plugins[x].name.toLowerCase().indexOf(pluginName.toLowerCase()) != -1) {
                        description = window.navigator.plugins[x].description;
                        
                        if (description && !(typeof window.navigator.mimeTypes != 'undefined' && window.navigator.mimeTypes[mimeType] && !window.navigator.mimeTypes[mimeType].enabledPlugin)) {
                            version = pluginName;
                            break;
                        }
                    }
                }
            }
        }
        return version;
    };

    // Add WMP detection to the MediaElement JS plugin definitions
    if (!mejs.PluginDetector.plugins['wmp']) {
        mejs.PluginDetector.addPluginExtend('wmp','Windows Media Player','application/x-ms-wmp','wmplayer.ocx', function(ax) {

            return [ax.versionInfo];
        });
    }

    // Add QuickTime detection to the MediaElement JS plugin definitions
    if (!mejs.PluginDetector.plugins['quicktime']) {
        mejs.PluginDetector.addPluginExtend('quicktime','QuickTime','video/quicktime','QuickTime.QuickTime', function(ax) {

            return [ax.GetQuickTimeVersion()];
        });
    }

    mejs.PluginDetector.determineExtraFallback = function (options, ext) {

        // MediaElement JS can't handle this
        window.XyMediaObject.useAdaptiveJsPlayer = false;

        // Check player-specific extensions first
        if (ext === 'wmv' || ext === 'wav') {
            // Only windows media player should handle these files for now
            mejs.HtmlMediaElementShim.generateWmp(options);

        } else if (ext === 'mov') {
            // For now, we only want QuickTime to play MOV files
            mejs.HtmlMediaElementShim.generateQuicktime(options);

        } else if (ext === 'flv' || ext === 'swf') {
            /*
             * If a flash file has gotten this far, no other plugin can play it.
             * for now, we will send it back to MediaElement js
             */
            window.XyMediaObject.useAdaptiveJsPlayer = true;

        // We have a general file extension
        } else {

            if (mejs.PluginDetector.plugins['wmp']) {

                // The user has Windows Media Player, so we'll use that
                mejs.HtmlMediaElementShim.generateWmp(options);

            } else if (mejs.PluginDetector.plugins['quicktime']) {

                // No WMP, but Quicktime is there, so we'll use that
                mejs.HtmlMediaElementShim.generateQuicktime(options);

            } else {
                /*
                 * The user apparently has no compatible plugins, so we give it
                 * back to MediaElement JS to try and download.
                 */
                window.XyMediaObject.useAdaptiveJsPlayer = true;
            }
        }
    };
};

/*mhanacek, ELMINT-68, ELMINT-69*/
jQuery(document).ready(function() {
	if (jQuery("div.Topic_Title").length > 0 && jQuery("div.TitledBlockType_Title").length > 0) {
		jQuery("div.Topic_Title").css({"display":"none"});
	}
});