/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/
	scorableContent = true;   //Used by CRE to determine if the page is scorable  
	BDQ = true;               // defined in questions.js
	var bdquestions = new Array();     	

// call-back function for re-arrange grag'n'drop items e.g. set correct left and top offset
// should be called after the page is loaded	
function arrangeBDObjects(qid, parentId) {
	var baseImageElem = byId(parentId);
	var questionData = getQuestionData(qid);
	var bdMatches = questionData.getParamValue("dragMatches");
	try {
	
		/*Need when DnD is in GameShow for get offsets normaly*/
		var GSisParent = jQuery('#WebBinDrop_'+qid).parents('.gsHiddenContent')
		if(GSisParent.hasClass('gsHiddenContent')){
				GSisParent.css({'display' : 'block',
								 'visibility' : 'visible'})
						  .removeClass('gsHiddenContent')
						  .addClass('gsShownContent')
			}
		/*----------------------------------------------------*/
	    		
		//var offs = findPos(byId(parentId));
		var offs = jQuery('#'+parentId).offset();
		var questionData = getQuestionData(qid);
		var bdOffsets = jQuery("#"+parentId).find("img").position().left;
		questionData.setParam("offsets", bdOffsets);		
		//var bdtopOffsets = byId(parentId).offsetTop; 
		questionData.setParam("topOffsets", offs.top);
		//var leftbdOffsets = byId(parentId).offsetLeft; 
		questionData.setParam("leftOffsets", offs.left);
		
		paintBDOutlines(qid);
		
		if (typeof(baseImageElem)!="undefined") {
			var baseLeft = baseImageElem.offsetLeft;
			questionData.setParam("baseLeft", baseLeft);
			// temporary hack to avoid shifting dragable elementsin IE < 8 HUTH skin
			if (isIE && navigator.appVersion.substr(navigator.appVersion.indexOf("MSIE") + 5, 1) < 8) {
				var baseTop = baseImageElem.offsetTop;//-15
			} else {
				var baseTop = baseImageElem.offsetTop;
			}
			baseImageElem.style.position = "static";
			questionData.setParam("baseTop", baseTop);
			var sources = getAllSources(qid);
			var dests = getAllDestinations(qid);
			
			for (var i=0; i < sources.length; i++) {
				var elem = byId(sources[i]);
				if (elem != null && typeof(elem) != "undefined"){
					//set native coordinates before arrange
					if (elem.tag != ""){
						elem.style.top = elem.getAttribute("nativeTop") + "px";
						elem.style.left = elem.getAttribute("nativeLeft") + "px";
					} else {
						var answs = getQuestion(qid).getParamValue("userAnswer").split("|")
						var bdStartPositions = questionData.getParamValue("startPositions");
						for(var i=0; i<answs.length; i++) {
							var ans = answs[i].split(":");
							var dest = byId(elem.tag);
							
							if (dest != null) {	
								switch(dest.shape.toLowerCase()) {
									case "rect": placeBDNextRect(qid, dest, elem); break;
									case "circle": placeBDNextCircle(qid, dest, elem); break;
									case "poly": 
										//hack for polygon. rearrange elements without initial placing 
										elem.tag = dest.id;
										rearrangeBDPoly(qid, dest);
																
										var newPositions = questionData.getParamValue("newPositions");
										bdStartPositions[i] = new BDPoint();
										bdStartPositions[i].X = elem.style.left = newPositions[i].X;
										bdStartPositions[i].Y = elem.style.top = newPositions[i].Y;
									break;
								}
							}
			
							if (!dest || dest.shape.toLowerCase() != "poly") {
								bdStartPositions[i] = new BDPoint();
								bdStartPositions[i].X = elem.style.left;
								bdStartPositions[i].Y = elem.style.top;
								questionData.setParam("startPositions", bdStartPositions);
							}
								
						}
					}
					
					//set grag objects relative position
					updateBDCoordinates(elem, baseLeft, baseTop);
					//set no target
					if (dests[i] == "") {
						elem.tag = "";
					}
				}
			}
			
			// arrange marks for made answers
			var i = 0;
			while (i < bdMatches.length - 2) {  //do not include last dummy elem
				
				updateBDCoordinates(byId("right_" + bdMatches[i]), baseLeft, baseTop);
				updateBDCoordinates(byId("wrong_" + bdMatches[i]), baseLeft, baseTop);
				i = i + 2;
			}
		}
		
		/*Need when DnD is in GameShow for get offsets normaly*/
		if(GSisParent.hasClass('gsShownContent')){
				GSisParent.css({'display' : 'none',
								 'visibility' : 'hidden'})
						  .removeClass('gsShownContent')
						  .addClass('gsHiddenContent')
			}
		/*----------------------------------------------------*/
		
		var bdTargetsCount = questionData.getParamValue("targetsCount");
		if(!bdTargetsCount){
			bdTargetsCount = bdMatches.length / 2 - 1;
			questionData.setParam("targetsCount", bdTargetsCount);
		}
	
		redirectBDTargets(qid);
		
		var bdDragDropMode = questionData.getParamValue("dragDropMode");
		if(bdDragDropMode == 'Practice'){
			// don't shot attempts count in Practice mode
			hide(qid + '_at_limit');
		}
		
	} catch (e) {
		setTimeout ("arrangeBDObjects('"+qid+"','"+parentId+"')", 100);
		return;
	}
	var cover = byId("ContentCover_" + qid);
	if (typeof(cover)!="undefined" && cover!=null) {
		cover.style.visibility = "hidden";
	}
	
	//arrange took place
	questionData.setParam("arranged", true);
	
	InitBDDragDrop(qid);
}

function redirectBDTargets(qid) {
    var allTargets = getBDUniqueDestinations(qid);
	for (var i=0; i<allTargets.length; i++) {           
        var sources = getAllBDSourcesOf(qid, allTargets[i]);
        var nextTarget = byId(allTargets[i]);
        if(typeof(nextTarget) == 'undefined' || nextTarget == null) continue;
        switch(nextTarget.shape.toLowerCase()) {
            case "rect": directBDRect(nextTarget, sources); break;
            case "circle": directBDCircle(nextTarget, sources); break;
            case "poly": directBDPoly(nextTarget, sources); break;
        }
    }
}

function directBDRect(nextTarget, sources) {
    var xsum = 5;
    var ysum = 5;
    for(var i=0; i<sources.length; i++) {
        xsum += byId(sources[i]).offsetWidth + 5;
        ysum += byId(sources[i]).offsetHeight + 5;
    }
    var coords = nextTarget.coords.split(',');
    nextTarget.horizontal = (ExtractNumber(coords[3]) - ExtractNumber(coords[1]) - ysum) < (ExtractNumber(coords[2]) - ExtractNumber(coords[0]) - xsum);
    // offset for the next object
    nextTarget.currentOffset = 5;
    // offset for the current row
    nextTarget.currentShift = 5;
    // offset for the next row
    nextTarget.maxDropWidth = 0;
}

function directBDCircle(nextTarget, sources) {
    var xsum = 4;
    var ysum = 4;
    for(var i=0; i<sources.length; i++) {
        xsum += byId(sources[i]).offsetWidth + 4;
        ysum += byId(sources[i]).offsetHeight + 4;
    }
    var coords = nextTarget.coords.split(',');
    nextTarget.horizontal = ysum > xsum;
    nextTarget.offsetUp = 2;
    nextTarget.offsetDown = 2;
}

function directBDPoly(nextTarget, sources) {
}

function updateBDCoordinates(element, baseLeft, baseTop) {
	if (element!= null && typeof(element) != 'undefined') {
		element.style.left = baseLeft + ExtractNumber(element.style.left) + "px";
		element.style.top = baseTop + ExtractNumber(element.style.top) + "px";
	}
}
	
function BDPoint() {
	this.X = 0;
	this.Y = 0;
}
	
function InitBDDragDrop(qid) {
	var questionData = getQuestionData(qid);
	var currentQuestion = getQuestionWithoutInit(qid);
	
	if (currentQuestion != null && (currentQuestion.getParamValue("attempts") == 0 || currentQuestion.getParamValue("result") == "correct")){
		return;
	}
	addEvent(byId("WebBinDrop_" + qid), 'mousedown', BDDragMouseDown);
	addEvent(byId("WebBinDrop_" + qid), 'mouseup', BDOnMouseUp);

	// prevent text selection in IE
	addEvent(byId("WebBinDrop_" + qid), 'selectstart', function () { return false; });
	addEvent(byId("WebBinDrop_" + qid), 'dragstart', function(e) {return false;});
	var BD_DEBUG_MODE = getQuestionData(qid).getParamValue("debugMode");

	if (BD_DEBUG_MODE) {
		document.write('<div id="debug"></div>');
		questionData.setParam("debug",byId('debug'));
	}
}

function BDDragMouseDown(e) {
	// IE is retarded and doesn't pass the event object
    if (e == null) 
        e = window.event; 
    // IE uses srcElement, others use target
    var target = e.target != null ? e.target : e.srcElement;
	var qid = getQidFromNode(target, "WebBinDrop_");
	
	if (qid != null){
		var questionData = getQuestionData(qid);
		var _bd_dragElement = questionData.getParamValue("dragElement");
		var _bd_debug = questionData.getParamValue("debug");
		//check if there was no drag element left or bdDragDropMode not defined
		if(_bd_dragElement != null)
			return;
		var bdDragDropMode = questionData.getParamValue("dragDropMode");
		var bdStartPositions = questionData.getParamValue("startPositions");
		var bdHighlightDropArea = questionData.getParamValue("highlightDropArea");
		
		if (typeof(bdDragDropMode) == 'undefined') {
			removeEvent(byId("WebBinDrop_" + qid), 'mousedown', BDDragMouseDown);
			removeEvent(byId("WebBinDrop_" + qid), 'mouseup', BDOnMouseUp);
			return false;
		}
		
		//Save start positions
		if (bdStartPositions.length == 0) {
			var sources = getAllSources(qid);
			for (var i = 0; i < sources.length; i++) {
				bdStartPositions[i] = new BDPoint();
				var sourceObj = byId(sources[i]);
				bdStartPositions[i].X = sourceObj.style.left;
				bdStartPositions[i].Y = sourceObj.style.top;
			}
		}

		questionData.setParam("startPositions", bdStartPositions);
		
	    var BD_DEBUG_MODE = questionData.getParamValue("debugMode");
		if (BD_DEBUG_MODE) {
			_bd_debug.innerHTML = target.className == 'bddraggable' 
				? 'draggable element clicked' 
				: 'NON-draggable element clicked';
				questionData.setParam("debug",_bd_debug);
		}
		// for IE, left click == 1
		// for Firefox, left click == 0
		if ((e.button == 1 && window.event != null || 
			e.button == 0) && 
			target.className == 'bddraggable') {        		
			// grab the mouse position
			var posx = 0;
			var posy = 0;
			if (!e) var e = window.event;
			if (e.pageX || e.pageY) {
				posx = e.pageX;
				posy = e.pageY;
			}
			else if (e.clientX || e.clientY) {
				posx = e.clientX + document.body.scrollLeft
					+ document.documentElement.scrollLeft;;
				posy = e.clientY + document.body.scrollTop
					+ document.documentElement.scrollTop;
			}
			// posx and posy contain the mouse position relative to the document		
			questionData.setParam("startX", posx);	
			questionData.setParam("startY", posy);	
			// grab the clicked element's position
			questionData.setParam("offsetX", target.offsetLeft);// ExtractNumber(target.style.left);
			questionData.setParam("offsetY", target.offsetTop);// ExtractNumber(target.style.top);
			
			// bring the clicked element to the front while it is being dragged
			questionData.setParam("oldZIndex", target.style.zIndex);
			target.style.zIndex = 10000;
			if (isIE) {		   
				target.style['filter'] = "alpha(opacity=50)";
			} else {		
				target.style.opacity = '0.5';   // make half-transparent when move
			}
			
			// we need to access the element in BDOnMouseMove
			_bd_dragElement = target;
			questionData.setParam("dragElement",_bd_dragElement);	
		
			if (typeof(bdHighlightDropArea) != 'undefined' && bdHighlightDropArea == true) {
			
				var outline = document.getElementById("BinMap_" + qid);
				if (outline != null) {
					outline = outline.lastChild;
					while(outline.nodeName.toLowerCase() != 'div'){
						outline = outline.previousSibling;
					}
					outline.style.visibility = "visible";
				}
			}
			// tell our code to start moving the element with the mouse
			addEvent(byId("WebBinDrop_" + qid), 'mousemove', BDOnMouseMove);
			addEvent(byId("WebBinDrop_" + qid), 'drag', BDOnMouseMove);
			
			// cancel out any text selections
			document.body.focus();

			if (e.stopPropagation) {
				e.stopPropagation();
				e.preventDefault();
			} else if (window.event) {
				window.event.cancelBubble = true;
				window.event.returnValue = false;
			}
				
				// prevent text selection (except IE)
				return false;
		}
	}
}

function BDOnMouseMove(e) {
    if (e == null) 
        var e = window.event; 
	var target = e.target != null ? e.target : e.srcElement;
	var qid = getQidFromNode(target, "WebBinDrop_");
	if (qid != null) {
		var questionData = getQuestionData(qid);
		var BD_DEBUG_MODE = questionData.getParamValue("debugMode");
		var _bd_dragElement = questionData.getParamValue("dragElement");
		
		var _bd_startX = questionData.getParamValue("startX");	
		var _bd_startY = questionData.getParamValue("startY");	
		var _bd_offsetX = questionData.getParamValue("offsetX");	
		var _bd_offsetY = questionData.getParamValue("offsetY");	
		var _bd_debug = questionData.getParamValue("debug");	
		
		//  "drag code"	
		if (_bd_dragElement != null) {			
			var iebody=(document.compatMode && document.compatMode != "BackCompat")? document.documentElement : document.body;

			var scrollleft=document.all? iebody.scrollLeft : pageXOffset;
			var scrolltop=document.all? iebody.scrollTop : pageYOffset;

			_bd_dragElement.style.left = (_bd_offsetX + e.clientX - _bd_startX + scrollleft) + 'px';
			_bd_dragElement.style.top = (_bd_offsetY + e.clientY - _bd_startY + scrolltop) + 'px';
			questionData.setParam("dragElement",_bd_dragElement);	
		}

		if (BD_DEBUG_MODE) {
			_bd_debug.innerHTML = '(' + _bd_dragElement.style.left + ', ' + 
				_bd_dragElement.style.top + ')' + ' Button: ' + e.button + ' which: ' + e.which;
				questionData.setParam("debug",_bd_debug);
		}
		if (e.stopPropagation) {
			e.stopPropagation();
			e.preventDefault();
		}
		else {
			if (window.event) {
				window.event.cancelBubble = true;
				window.event.returnValue = false;
			}
		}
	}
}
	function BDOnMouseUp(e) {
		// IE is retarded and doesn't pass the event object
		if (e == null)
			var e = window.event;
		var target = e.target != null ? e.target : e.srcElement;
		var qid = getQidFromNode(target, "WebBinDrop_");
		if (qid != null) {
			var questionData = getQuestionData(qid);
			var _bd_dragElement = questionData.getParamValue("dragElement");
			var _bd_offsetX = questionData.getParamValue("offsetX");	
			var _bd_offsetY = questionData.getParamValue("offsetY");
			var bdMatches = getQuestionData(qid).getParamValue("dragMatches");
			var currentQuestion = getQuestion(qid);
			
			if (_bd_dragElement != null){
				
				var BD_DEBUG_MODE = questionData.getParamValue("debugMode");
				_bd_dragElement.style.zIndex = questionData.getParamValue("oldZIndex");
				if (isIE) {
					_bd_dragElement.style['filter'] = "";
				} else {
					_bd_dragElement.style.opacity = '1.0';
					// restore previous transparent state
				}

				// we're done with these events until the next OnMouseDown
				removeEvent(byId("WebBinDrop_" + qid), 'mousemove', BDOnMouseMove);
				removeEvent(byId("WebBinDrop_" + qid), 'drag', BDOnMouseMove);

				var left = _bd_dragElement.offsetLeft;
				var top = _bd_dragElement.offsetTop;
				var elemId = _bd_dragElement.id;
				
				var bdDragDropMode = questionData.getParamValue("dragDropMode");
				var bdHighlightDropArea = questionData.getParamValue("highlightDropArea");
				
				var destinationElem;
				
				// Unhighlight destination drop area
				if (typeof(bdHighlightDropArea) != 'undefined' && bdHighlightDropArea == true) {
					var outline = document.getElementById("BinMap_" + qid);
					if (outline != null) {
						outline = outline.lastChild;
						while(outline.nodeName.toLowerCase() != 'div'){
							outline = outline.previousSibling;
						}
						outline.style.visibility = "hidden";
					}
				}
			
				var posx = 0;
				var posy = 0;
				if (!e) var e = window.event;
				if (e.pageX || e.pageY) {
					posx = e.pageX;
					posy = e.pageY;
				} else if (e.clientX || e.clientY) 	{
					posx = e.clientX + document.body.scrollLeft
						+ document.documentElement.scrollLeft;;
					posy = e.clientY + document.body.scrollTop
						+ document.documentElement.scrollTop;
				}
				
				destinationElem = checkBDHit(qid, _bd_dragElement, posx, posy);
		
				if (destinationElem != null && typeof(destinationElem) != 'undefined' 
					&& (destinationElem.getAttribute("spotAreasCount") > getSpotsOnTarget(qid, destinationElem.id) 
						|| destinationElem.getAttribute("spotAreasCount") == 0)) {
						
					// moove back drag element in case of wrong answer in practice mode
					if (bdDragDropMode == "Practice") {
						var i = 0;
						while (i < bdMatches.length - 2) {  
							var dragElement = byId(bdMatches[i]);
							
							if (dragElement == _bd_dragElement && destinationElem.id != bdMatches[i+1]) {
								restorePosition(qid, _bd_offsetX, _bd_offsetY, e);
								return false;
							}
							i = i + 2;
						}
					}
					
					// snap the drop item to its target coordinates
					
					switch(destinationElem.shape.toLowerCase()) {
						case "rect": placeBDNextRect(qid, destinationElem, _bd_dragElement); break;
						case "circle": placeBDNextCircle(qid, destinationElem, _bd_dragElement); break;
						case "poly": placeBDNextPoly(qid, destinationElem, _bd_dragElement); break;
					}
								
					if(_bd_dragElement.tag && _bd_dragElement.tag != "") {
						var previousBin = document.getElementById(_bd_dragElement.tag);
						_bd_dragElement.tag = destinationElem.id;
						switch(previousBin.shape.toLowerCase()) {
							case "rect": rearrangeBDRect(qid, previousBin); break;
							case "circle": rearrangeBDCircle(qid, previousBin); break;
							case "poly": rearrangeBDPoly(qid, previousBin); break;
						}
						//decrease one element is out target
						changeSpotsOnTarget(qid, previousBin.id, -1);
						questionData.setParam("snapCurrent", 0);
						clearInterval(questionData.getParamValue("snapTimer"));
						var snapTimer = setInterval("snapBackAll('" +qid + "','newPositions','userPositions',15)", 10);
						questionData.setParam("snapTimer", snapTimer);
					}
					//increase if one more element is on target
					changeSpotsOnTarget(qid, destinationElem.id, 1);
					
					_bd_dragElement.tag = destinationElem.id;
					_bd_dragElement.value = destinationElem.id;
					_bd_dragElement = null;
					questionData.setParam("dragElement",_bd_dragElement);	
											
					var sources = getAllSources(qid);
					var allOnTargets = true;
					for(var i=0; i<sources.length; i++) {
						var source = byId(sources[i]);
					
						if((source &&  !source.tag  || source.tag == "") && source.id.indexOf('distractor_item') == -1) {
							allOnTargets = false;
							break;
						}						
					
						
					}
					
					//if max spots of all targets are placed -> show submit
					var spotsOnTarget = questionData.getParamValue("spotsOnTarget");
					var destinations = getAllDestinations(qid);
					var allSpotsOnAreas = true;
					for(var i=0; i<destinations.length;i++){
						if (byId(destinations[i])){
							var spotAreasCount = byId(destinations[i]).getAttribute("spotAreasCount");
							if (typeof(spotAreasCount) == "undefined" || spotAreasCount == "" || spotAreasCount == 0 || spotAreasCount > spotsOnTarget[i]) {
								allSpotsOnAreas = false;
							}	
						}
					}
					
					if (allSpotsOnAreas) {
						show(qid + "_SubmitBox");
					} else {
						hide(qid + "_SubmitBox");
					}
					
					if (allOnTargets) {
						show(qid + "_SubmitBox");
						//removeEvent(byId("WebBinDrop_" + qid), 'mousedown', BDDragMouseDown);
						//removeEvent(byId("WebBinDrop_" + qid), 'mouseup', BDOnMouseUp);
					}
				} else {
					restorePosition(qid, _bd_offsetX, _bd_offsetY, e);
				}
	
				if (e.stopPropagation) {
					e.stopPropagation();
					e.preventDefault();
				} else if (window.event) {
					window.event.cancelBubble = true;
					window.event.returnValue = false;
				}

				if (BD_DEBUG_MODE) {
					var _bd_debug = questionData.getParamValue("debug");
					_bd_debug.innerHTML = 'mouse up';
					questionData.setParam("debug",_bd_debug);
				}
			}
		}
	}
	
	function doMatchedBD(qid) {		
		show(qid + "_CorrectResp");		
		setTimeout ("hide(qid + '_CorrectResp')", 2000);	
	}
	
	function doNotMatchedBD(qid) {
		show(qid + "_IncorrectResp");		
		setTimeout ("hide(qid + '_IncorrectResp')", 2000);		
	}
	
    
    function getBDUniqueDestinations(qid) {
		// check the match only for non distractor elements
		var destinations = new Array();
		var bdMatches = getQuestionData(qid).getParamValue("dragMatches");
		var i = 0;
		//destinations are each even element in array
		while (i < bdMatches.length - 2) {
			var isNew = true;
            for(var j=0; j<destinations.length; j++)
                if (destinations[j] == bdMatches[i+1]) {
                    isNew = false;
                    break;
                }
            if (isNew && bdMatches[i+1] != "") {
                destinations.push(bdMatches[i+1]);
			}
			i = i + 2;
		}
		
		return destinations;
	}
	

    
    function getAllBDSourcesOf(qid,targetId) {
		// check the match only for non distractor elements
		var destinations = new Array();
		var bdMatches = getQuestionData(qid).getParamValue("dragMatches");
		var i = 0;
		//destinations are each even element in array
		while (i < bdMatches.length - 2) {
			if(bdMatches[i+1] == targetId) {
                destinations.push(bdMatches[i]);
			}
			i = i + 2;
		}
		return destinations;
	}

	
	function checkBDSubmit(qid, msg) {
		var user_answer = "";
        removeEvent(byId("WebBinDrop_" + qid), 'mousedown', BDDragMouseDown);
		var destinationElems = getAllDestinations(qid);
		var sourceElems = getAllSources(qid);
		for (var i = 0; i < sourceElems.length; i++) {
			var dragElement = byId(sourceElems[i])
			var tag = dragElement.tag ? dragElement.tag : "";
			user_answer += dragElement.id + ":" + tag + "|";
		}
		getQuestion(qid).setParam("userAnswer", user_answer);
		return user_answer;
		
	}
	
	function checkBDMatch(qid, redraw) {
		// ---imagemapquiz variables---
		var submitBtn = document.getElementById(qid + "_submitBtn");
		var doneBtn = document.getElementById(qid + "_doneBtn");
		// ---imagemapquiz variables---
		var questionData = getQuestionData(qid);
		var bdMatches = questionData.getParamValue("dragMatches");
		var bdShowSolution = questionData.getParamValue("showSolution");
		
		var bdIaMode = questionData.getParamValue("iaMode");
		var userBDPositions = questionData.getParamValue("userPositions");
		var newBDPositions = questionData.getParamValue("newPositions");
		
		var bdDragDropMode = questionData.getParamValue("dragDropMode");
		var currentQuestion = getQuestion(qid);
		
		//check the match
		var matched = true;
		var i = 0;
		
		checkBDSubmit(qid, "");
		var at_limit = currentQuestion.getParamValue("attempts");
		if (bdIaMode) {
			//bdShowFeedback = false;
			bdShowSolution = false;
		}

		// CP-4119
		// if (redraw) {
		// 	//bdShowFeedback = true;
		// 	bdShowSolution = true;
		// }
		
		var sfeedback = getFeedbackMode(questionData);
		
		var showAdvice = questionData.getParamValue("showAdvice");
		
		//Save user positions
		if (at_limit <= 1 && bdDragDropMode != "Practice") {
			var sources = getAllSources(qid);
			for (var i = 0; i < sources.length; i++) {
				userBDPositions[i] = new BDPoint();
				var sourceObj = byId(sources[i]);
				userBDPositions[i].X = sourceObj.style.left;
				userBDPositions[i].Y = sourceObj.style.top;
			}
			questionData.setParam("userPositions", userBDPositions);
		}
		
		i = 0;
		while (i < bdMatches.length - 2) {  //do not include last dummy elem
			var dragElement = byId(bdMatches[i]);

			//var destinationElem = getDestinationElement(bdMatches[i]);
			if (dragElement != null && typeof(dragElement) != 'undefined' && typeof(dragElement.tag) != 'undefined') {
				if (dragElement.tag != bdMatches[i+1]) {
					matched = false;
					if(at_limit <= 1 && bdDragDropMode != "Practice") {
						var img = byId("wrong_" + bdMatches[i]);
						if(sfeedback === ShowFeedback.all && img != null && typeof(img) != 'undefined') {							
							img.style.left = dragElement.offsetWidth + dragElement.offsetLeft + "px";
                            img.style.top =  dragElement.offsetTop + "px";
							show("wrong_" + bdMatches[i]);
						}
					} 
				} else {
					if(at_limit <= 1 && bdDragDropMode != "Practice") {
						var img = byId("right_" + bdMatches[i]);
						if(sfeedback === ShowFeedback.all && img != null && typeof(img) != 'undefined') {							
							img.style.left = dragElement.offsetWidth + dragElement.offsetLeft + "px";
                            img.style.top =  dragElement.offsetTop + "px";
							show("right_" + bdMatches[i]);
						}
					}
				}
			} else {
				matched = false;
			}
			i = i + 2;
		}
		if (matched) {
			// All MATCHED
			currentQuestion.setParam("result", "correct"); // set question result
			setDisabled(qid); // mark question options disabled
			if (doneBtn != null) {
				submitBtn.style.visibility = "hidden";
				doneBtn.style.visibility = "visible";
				doneBtn.disabled = false;

				// prevent text selection in IE
				addEvent(byId("WebBinDrop_" + qid), 'selectstart', function () { return false; });
				addEvent(byId("WebBinDrop_" + qid), 'dragstart', function(e) {return false;});
			}
			
			if (sfeedback) {			
				i = 0;
				while (i < bdMatches.length - 2) {  //do not include last dummy elem
					var dragElement = byId(bdMatches[i]);
					var img = byId("right_" + bdMatches[i]);
					
					if(at_limit > 1 && bdDragDropMode != "Practice" && img) {
						img.style.left = dragElement.offsetWidth + dragElement.offsetLeft + "px";
						img.style.top = dragElement.offsetTop + "px";
						show("right_" + bdMatches[i]);
					}
						
					i = i + 2;
				}
			}
		} else {
			// Any DOES NOT MATCHED
			currentQuestion.setParam("result", "incorrect"); // set question result
			if ((at_limit > 1 || bdDragDropMode == "Practice")) {
				questionData.setParam("buttonState", "Reset");
				setButtonTitle(qid, langReset);
			} else {
				if (bdShowSolution) {
					questionData.setParam("buttonState", "ShowCorrect");
					setButtonTitle(qid, langShowSolution);
				} else {
					setDisabled(qid);
					hide(qid + "_SubmitBox");
					if (doneBtn != null) {
						submitBtn.style.visibility = "hidden";
						doneBtn.style.visibility = "visible";
						doneBtn.disabled = false;
					}
				}
				
			}
		}
		
		handleAdvice(qid, showAdvice, at_limit, matched); // show Advice		
		handleFeedback(qid, sfeedback, at_limit, matched); // show Feedback

		if (bdDragDropMode != "Practice") {
			setAttemptLimit(qid,at_limit);  // decrease attempts + update tailed text
		}
		if (!redraw && bdDragDropMode != "Practice") {
            currentQuestion.setUserResult();//send result to CRE here!
            setUserResults();
        }
		return matched;
	}

	function checkBDHit(qid, dragElement, posx, posy) {
		if (qid != null) {
			var destinationElems = getAllDestinations(qid);
			var matched = false;
			var destinationElem;
			for (var i = 0; i < destinationElems.length; i++) {
				destinationElem = byId(destinationElems[i]);
				if (typeof(destinationElem) != 'undefined' && destinationElem != null) {
					switch(destinationElem.shape.toLowerCase()) {
						case "rect": matched = matchBDRect(destinationElem, posx, posy); break;
						case "circle": matched = matchBDCircle(destinationElem, posx, posy); break;
						case "poly": matched = matchBDPoly(destinationElem, posx, posy); break;
					}
					if(matched){
						return destinationElem;
					}
				}
			}
		}
		return null;
	}
    
    function matchBDRect(destinationElem, posx, posy) {
        var coords = destinationElem.coords.split(',');
		var questionData = getQuestionData(qid);
		var leftbdOffsets = questionData.getParamValue("leftOffsets");
		var bdtopOffsets = questionData.getParamValue("topOffsets");		
        if (ExtractNumber(coords[2]) + leftbdOffsets  > posx 
			&& ExtractNumber(coords[0]) + leftbdOffsets  < posx 
			&& ExtractNumber(coords[3]) + bdtopOffsets  > posy 
			&& ExtractNumber(coords[1]) + bdtopOffsets  < posy) {
			return true;
		} else
            return false;
    }
    
    function matchBDCircle(destinationElem, posx, posy) {
        var coords = destinationElem.coords.split(',');
		var questionData = getQuestionData(qid);
		var leftbdOffsets = questionData.getParamValue("leftOffsets");
		var bdtopOffsets = questionData.getParamValue("topOffsets");
        if (Math.sqrt((posx - ExtractNumber(coords[0]) - leftbdOffsets)*
			(posx - ExtractNumber(coords[0]) - leftbdOffsets) + 
            (posy - ExtractNumber(coords[1]) - bdtopOffsets)*
			(posy - ExtractNumber(coords[1]) - bdtopOffsets)) < ExtractNumber(coords[2])) {
			return true;
		} else
            return false;
    }
    
    function matchBDPoly(destinationElem, px, py) {
		var questionData = getQuestionData(qid);
		var leftbdOffsets = questionData.getParamValue("leftOffsets");
		var bdtopOffsets = questionData.getParamValue("topOffsets");
        px = px - leftbdOffsets;
        py = py - bdtopOffsets;
        var poly = destinationElem.coords.split(',');
        var npoints = poly.length; // number of points in polygon
        var xnew,ynew,xold,yold,x1,y1,x2,y2,i;
        var inside=false;
     
        if (npoints/2 < 3) { // points don't describe a polygon
             return false;
        }
        xold=poly[npoints-2];
        yold=poly[npoints-1];
        
        for (i=0 ; i < npoints ; i=i+2) {
             xnew=poly[i];
             ynew=poly[i+1];
             if (xnew > xold) {
                  x1=xold;
                  x2=xnew;
                  y1=yold;
                  y2=ynew;
             }
             else {
                  x1=xnew;
                  x2=xold;
                  y1=ynew;
                  y2=yold;
             }
             if ((xnew < px) == (px <= xold) && ((py-y1)*(x2-x1) < (y2-y1)*(px-x1))) {
                  inside=!inside;
             }
             xold=xnew;
             yold=ynew;
        }
        return inside;
    }


    
    function placeBDNextRect(qid, target, source) {
        var coords = target.coords.split(',');
		var questionData = getQuestionData(qid);
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
		//resize drag text objects
		var targetWidth = coords[2] - coords[0];
		source.style.width = "auto";

		if (source.tagName.toLowerCase() != "img"){
			source.style.maxWidth = targetWidth + "px";
		}
		
        if(!target.horizontal) {
            if(target.currentOffset + source.offsetHeight > ExtractNumber(coords[3]) - ExtractNumber(coords[1])) {
                target.currentShift += target.maxDropWidth + 5;
                target.currentOffset = 5;
                target.maxDropWidth = 0;
            }
            source.style.left = (baseLeft + ExtractNumber(coords[0]) + target.currentShift) + "px";
            source.style.top = (baseTop + ExtractNumber(coords[1]) + target.currentOffset) + "px";
            target.currentOffset += source.offsetHeight + 5;
            if(source.offsetWidth > target.maxDropWidth)
                target.maxDropWidth = source.offsetWidth;
        } else {
            if(target.currentOffset + source.offsetWidth > ExtractNumber(coords[2]) - ExtractNumber(coords[0])) {
                target.currentShift += target.maxDropWidth + 5;
                target.currentOffset = 5;
                target.maxDropWidth = 0;
            }
            source.style.left = (baseLeft + ExtractNumber(coords[0]) + target.currentOffset) + "px";
            source.style.top = (baseTop + ExtractNumber(coords[1]) + target.currentShift) + "px";
            target.currentOffset += source.offsetWidth + 5;
            if(source.offsetHeight > target.maxDropWidth)
                target.maxDropWidth = source.offsetHeight;
        }
    }
    
    function placeBDNextCircle(qid, target, source) {
        var coords = target.coords.split(',');
        //resize drag text objects
		var targetWidth = coords[2];
		source.style.width = "auto";
    
		if (source.tagName.toLowerCase() != "img"){
			source.style.maxWidth = targetWidth + "px";
		} 
        
        var allSources = getAllSources(qid);
        var currentCount = 0;
		var questionData = getQuestionData(qid);
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<allSources.length; i++) {
            var src = document.getElementById(allSources[i]);
            if(src.tag == target.id) 
                currentCount++;
        }
        if(!target.horizontal) {
            if(currentCount % 2 == 1) {
                source.style.left = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth/2) + "px";
                source.style.top = (baseTop + ExtractNumber(coords[1]) - source.offsetHeight - target.offsetUp) + "px";
            target.offsetUp += source.offsetHeight + 4;
            } else {
                source.style.left = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth/2) + "px";
                source.style.top = (baseTop + ExtractNumber(coords[1]) + target.offsetDown) + "px";
                target.offsetDown += source.offsetHeight + 4;
            }
        } else {
            if(currentCount % 2 == 1) {
                source.style.left = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth - target.offsetUp) + "px";
                source.style.top = (baseTop + ExtractNumber(coords[1]) - source.offsetHeight/2) + "px";
            target.offsetUp += source.offsetWidth + 4;
            } else {
                source.style.left = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth + target.offsetDown) + "px";
                source.style.top = (baseTop + ExtractNumber(coords[1]) + source.offsetHeight/2) + "px";
                target.offsetDown += source.offsetWidth + 4;
            }
        }
    }
    
    function placeBDNextPoly(qid, target, source) {        
    }
	
    function choosePosition(qid) {
		var questionData = getQuestionData(qid);
		var bdStartPositions;
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        var allSources = getAllSources(qid);
        var allTargets = getBDUniqueDestinations(qid);
		
		for (var i=0; i<allTargets.length; i++) {           
            var sources = getAllBDSourcesOf(qid, allTargets[i]);
            var nextTarget = byId(allTargets[i]);
            if(typeof(nextTarget) == 'undefined' || nextTarget == null) continue;
            switch(nextTarget.shape.toLowerCase()) {
                case "rect": chooseBDRect(qid, nextTarget, sources, allSources); break;
                case "circle": chooseBDCircle(qid, nextTarget, sources, allSources); break;
                case "poly": chooseBDPoly(qid, nextTarget, sources, allSources); break;
            }
        }
		
		
		//retrieve array, saved in chooseBD.. functions and add distractors 
		bdStartPositions = questionData.getParamValue("startPositions");
		for(var i=0; i<allSources.length; i++) {
			if(allSources[i].indexOf('distractor_item') >= 0) {
			    bdStartPositions[i].X = (baseLeft + ExtractNumber(byId(allSources[i]).getAttribute("nativeLeft"))) + "px";
                bdStartPositions[i].Y = (baseTop + ExtractNumber(byId(allSources[i]).getAttribute("nativeTop"))) + "px";
			}
		}
		questionData.setParam("startPositions", bdStartPositions);
    }
    
    function rearrangeBDRect(qid, nextTarget) {
        var top = 5;
        var left = 5;
        var nextLeft = 0;
        var index = 0;
        var coords = nextTarget.coords.split(',');
        var allSources = getAllSources(qid);
		var questionData = getQuestionData(qid);
		var userBDPositions = questionData.getParamValue("userPositions");
		var newBDPositions = questionData.getParamValue("newPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<allSources.length; i++) {
            var src = document.getElementById(allSources[i]);
            userBDPositions[i] = new BDPoint();
            userBDPositions[i].X = src.offsetLeft + "px";
            userBDPositions[i].Y = src.offsetTop + "px";
            if(src.tag == nextTarget.id) {
                newBDPositions[i] = new BDPoint();
                if(!nextTarget.horizontal) {
                    if(top + src.offsetHeight > ExtractNumber(coords[3]) - ExtractNumber(coords[1])) {
                        left += nextLeft + 5;
                        top = 5;
                        nextLeft = 0;
                    }
                    newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) + left) + "px";
                    newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + top) + "px";
                    top += src.offsetHeight + 5;
                    if(src.offsetWidth > nextLeft)
                        nextLeft = src.offsetWidth;
                } else {
                    if(top + src.offsetWidth > ExtractNumber(coords[2]) - ExtractNumber(coords[0])) {
                        left += nextLeft + 5;
                        top = 5;
                        nextLeft = 0;
                    }
                    newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) + top) + "px";
                    newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + left) + "px";
                    top += src.offsetWidth + 5;
                    if(src.offsetHeight > nextLeft)
                        nextLeft = src.offsetHeight;
                }
            } else {
                newBDPositions[i] = userBDPositions[i];
            }
        }
		questionData.setParam("userPositions", userBDPositions);
		questionData.setParam("newPositions", newBDPositions);
        nextTarget.currentOffset = top;
        nextTarget.currentShift = left;
        nextTarget.maxDropWidth = nextLeft;
    }
    
    function rearrangeBDCircle(qid, nextTarget) {
        var offsetUp = 2;
        var index = 0;
        var coords = nextTarget.coords.split(',');
        //sources.sort(function (a,b) {return document.getElementById(b).offsetWidth - document.getElementById(a).offsetWidth;});
        var allSources = getAllSources(qid);
        var offsetDown = 2;
        var currentCount = 0;
		var questionData = getQuestionData(qid);
		var userBDPositions = questionData.getParamValue("userPositions");
		var newBDPositions = questionData.getParamValue("newPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<allSources.length; i++) {
            var source = byId(allSources[i]);
            userBDPositions[i] = new BDPoint();
            userBDPositions[i].X = source.offsetLeft + "px";
            userBDPositions[i].Y = source.offsetTop + "px";
            if(source.tag == nextTarget.id) {
                newBDPositions[i] = new BDPoint();
                if(!nextTarget.horizontal) {
                    if(currentCount % 2 == 1) {
                        newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth/2) + "px";
                        newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) - source.offsetHeight - offsetUp) + "px";
                        offsetUp += source.offsetHeight + 4;
                    } else {
                        newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth/2) + "px";
                        newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + offsetDown) + "px";
                        offsetDown += source.offsetHeight + 4;
                    }
                } else {
                    if(currentCount % 2 == 1) {
                        newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth - offsetUp) + "px";
                        newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) - source.offsetHeight/2) + "px";
                        offsetUp += source.offsetWidth + 4;
                    } else {
                        newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth + offsetDown) + "px";
                        newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + source.offsetHeight/2) + "px";
                        offsetDown += source.offsetWidth + 4;
                    }
                }
                currentCount++;
            } else {
                newBDPositions[i] = userBDPositions[i];
            }
        }
		questionData.setParam("userPositions", userBDPositions);
		questionData.setParam("newPositions", newBDPositions);
        nextTarget.offsetUp =offsetUp;
        nextTarget.offsetDown = offsetDown;
    }
    
    function rearrangeBDPoly(qid, nextTarget) {
        var top = 5;
        var index = 0;
        var coords = nextTarget.coords.split(',');
        var allSources = getAllSources(qid);
		var questionData = getQuestionData(qid);
		var userBDPositions = questionData.getParamValue("userPositions");
		var newBDPositions = questionData.getParamValue("newPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<allSources.length; i++) {
            var src = document.getElementById(allSources[i]);
            userBDPositions[i] = new BDPoint();
            userBDPositions[i].X = src.offsetLeft + "px";
            userBDPositions[i].Y = src.offsetTop + "px";
            if(src.tag == nextTarget.id) {
                newBDPositions[i] = new BDPoint();
                if(!nextTarget.horizontal) {
                    newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) + 5) + "px";
                    newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + top) + "px";
                    top += src.offsetHeight + 5;
                } else {
                    newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) + top) + "px";
                    newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + 5) + "px";
                    top += src.offsetWidth + 5;
                }
            } else {
                newBDPositions[i] = userBDPositions[i];
            }
        }
		questionData.setParam("userPositions", userBDPositions);
		questionData.setParam("newPositions", newBDPositions);
        nextTarget.currentOffset = top;
    }
    
    function rearrangeAllBD(qid) {
		var questionData = getQuestionData(qid);
        var targets = getBDUniqueDestinations(qid);
        for(var i=0; i<targets.length; i++) {
            var target = byId(targets[i]);
            switch(target.shape.toLowerCase()) {
                case "rect": resetBDRect(qid, target); break;
                case "circle": resetBDCircle(qid, target); break;
                case "poly": resetBDPoly(qid, target); break;
            }
        }
        var sources = getAllSources(qid);
		var bdStartPositions = questionData.getParamValue("startPositions");
		var newBDPositions = questionData.getParamValue("newPositions");
        for(var i=0; i<sources.length; i++) {
            var source = byId(sources[i]);
            if(source.tag == null || source.tag == "" || source.tag == "undefined") {
                newBDPositions[i] = bdStartPositions[i];
            }
        }
		questionData.setParam("newPositions", newBDPositions);
		questionData.setParam("snapCurrent", 0);
		clearInterval(questionData.getParamValue("snapTimer"));
        var snapTimer = setInterval("snapBackAll('" +qid + "','newPositions','userPositions',15)", 10);
		questionData.setParam("snapTimer", snapTimer);
    }
    
    function resetBDRect(qid, nextTarget) {
        var top = 5;
        var left = 5;
        var nextLeft = 0;
        var index = 0;
        var coords = nextTarget.coords.split(',');
        var allSources = getAllSources(qid);
		var questionData = getQuestionData(qid);
		var newBDPositions = questionData.getParamValue("newPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<allSources.length; i++) {
            var src = document.getElementById(allSources[i]);
            if(src.tag == nextTarget.id) {
                newBDPositions[i] = new BDPoint();
                if(!nextTarget.horizontal) {
                    if(top + src.offsetHeight > ExtractNumber(coords[3]) - ExtractNumber(coords[1])) {
                        left += nextLeft + 5;
                        top = 5;
                        nextLeft = 0;
                    }
                    newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) + left) + "px";
                    newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + top) + "px";
                    top += src.offsetHeight + 5;
                    if(src.offsetWidth > nextLeft)
                        nextLeft = src.offsetWidth;
                } else {
                    if(top + src.offsetWidth > ExtractNumber(coords[2]) - ExtractNumber(coords[0])) {
                        left += nextLeft + 5;
                        top = 5;
                        nextLeft = 0;
                    }
                    newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) + top) + "px";
                    newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + left) + "px";
                    top += src.offsetWidth + 5;
                    if(src.offsetHeight > nextLeft)
                        nextLeft = src.offsetHeight;
                }
            }
        }
		questionData.setParam("newPositions", newBDPositions);
        nextTarget.currentOffset = top;
        nextTarget.currentShift = left;
        nextTarget.maxDropWidth = nextLeft;
    }
    
    function resetBDCircle(qid, nextTarget) {
        var offsetUp = 2;
        var index = 0;
        var coords = nextTarget.coords.split(',');
        //sources.sort(function (a,b) {return document.getElementById(b).offsetWidth - document.getElementById(a).offsetWidth;});
        var allSources = getAllSources(qid);
		var questionData = getQuestionData(qid);
		var newBDPositions = questionData.getParamValue("newPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        var offsetDown = 2;
        var currentCount = 0;
        for(var i=0; i<allSources.length; i++) {
            var source = byId(allSources[i]);
            if(source.tag == nextTarget.id) {
                newBDPositions[i] = new BDPoint();
                if(!nextTarget.horizontal) {
                    if(currentCount % 2 == 1) {
                        newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth/2) + "px";
                        newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) - source.offsetHeight - offsetUp) + "px";
                        offsetUp += source.offsetHeight + 4;
                    } else {
                        newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth/2) + "px";
                        newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + offsetDown) + "px";
                        offsetDown += source.offsetHeight + 4;
                    }
                } else {
                    if(currentCount % 2 == 1) {
                        newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth - offsetUp) + "px";
                        newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) - source.offsetHeight/2) + "px";
                        offsetUp += source.offsetWidth + 4;
                    } else {
                        newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) - source.offsetWidth + offsetDown) + "px";
                        newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + source.offsetHeight/2) + "px";
                        offsetDown += source.offsetWidth + 4;
                    }
                }
                currentCount++;
            }
        }
		questionData.setParam("newPositions", newBDPositions);
        nextTarget.offsetUp =offsetUp;
        nextTarget.offsetDown = offsetDown;
    }
    
    function resetBDPoly(qid, nextTarget) {
        var top = 5;
        var index = 0;
        var coords = nextTarget.coords.split(',');
        var allSources = getAllSources(qid);
		var questionData = getQuestionData(qid);
		var newBDPositions = questionData.getParamValue("newPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<allSources.length; i++) {
            var src = document.getElementById(allSources[i]);
            if(src.tag == nextTarget.id) {
                newBDPositions[i] = new BDPoint();
                if(!nextTarget.horizontal) {
                    newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) + 5) + "px";
                    newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + top) + "px";
                    top += src.offsetHeight + 5;
                } else {
                    newBDPositions[i].X = (baseLeft + ExtractNumber(coords[0]) + top) + "px";
                    newBDPositions[i].Y = (baseTop + ExtractNumber(coords[1]) + 5) + "px";
                    top += src.offsetWidth + 5;
                }
            }
        }
		questionData.setParam("newPositions", newBDPositions);
        nextTarget.currentOffset = top;
    }
    
    function chooseBDRect(qid, nextTarget, sources, allSources) {
        var top = 5;
        var left = 5;
        var nextLeft = 0;
        var index = 0;
        var coords = nextTarget.coords.split(',');
		var questionData = getQuestionData(qid);
		var bdStartPositions = questionData.getParamValue("startPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<sources.length; i++) {
            for(var j=0; j<allSources.length; j++)
                if(sources[i] == allSources[j])
                    index = j; //determine index in sources list
            var source = byId(sources[i]);
            bdStartPositions[index] = new BDPoint();
            if(!nextTarget.horizontal) {
                if(top + source.offsetHeight > ExtractNumber(coords[3]) - ExtractNumber(coords[1])) {
                    left += nextLeft + 5;
                    top = 5;
                    nextLeft = 0;
                }
                bdStartPositions[index].X = (baseLeft + ExtractNumber(coords[0]) + left) + "px";
                bdStartPositions[index].Y = (baseTop + ExtractNumber(coords[1]) + top) + "px";
                top += source.offsetHeight + 5;
                if(source.offsetWidth > nextLeft)
                    nextLeft = source.offsetWidth;
            } else {
                if(top + source.offsetWidth > ExtractNumber(coords[2]) - ExtractNumber(coords[0])) {
                    left += nextLeft + 5;
                    top = 5;
                    nextLeft = 0;
                }
                bdStartPositions[index].X = (baseLeft + ExtractNumber(coords[0]) + top) + "px";
                bdStartPositions[index].Y = (baseTop + ExtractNumber(coords[1]) + left) + "px";
                top += source.offsetWidth + 5;
                if(source.offsetHeight > nextLeft)
                    nextLeft = source.offsetHeight;
            }
        }
		questionData.setParam("startPositions", bdStartPositions);
    }
    
    function chooseBDCircle(qid, nextTarget, sources, allSources) {
        var offsetUp = 2;
        var index = 0;
        var coords = nextTarget.coords.split(',');
        sources.sort(function (a,b) {return document.getElementById(b).offsetWidth - document.getElementById(a).offsetWidth;});
        var offsetDown = 2 - byId(sources[0]).offsetHeight;
		var questionData = getQuestionData(qid);
		var bdStartPositions = questionData.getParamValue("startPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<sources.length; i+=2) {
            for(var j=0; j<allSources.length; j++)
                if(sources[i] == allSources[j])
                    index = j; //determine index in sources list
            var source1 = byId(sources[i]);
            bdStartPositions[index] = new BDPoint();
            bdStartPositions[index].X = (baseLeft + ExtractNumber(coords[0]) - source1.offsetWidth/2) + "px";
            bdStartPositions[index].Y = (baseTop + ExtractNumber(coords[1]) - source1.offsetHeight - offsetUp) + "px";
            offsetUp += source1.offsetHeight + 4;
            if(i+1 < sources.length) {
                for(var j=0; j<allSources.length; j++)
                    if(sources[i+1] == allSources[j])
                        index = j; //determine index in sources list
                var source2 = byId(sources[i+1]);
                bdStartPositions[index] = new BDPoint();
                bdStartPositions[index].X = (baseLeft + ExtractNumber(coords[0]) - source2.offsetWidth/2) + "px";
                bdStartPositions[index].Y = (baseTop + ExtractNumber(coords[1]) + source2.offsetHeight + offsetDown) + "px";
                offsetDown += source2.offsetHeight + 4;
            }
        }
		questionData.setParam("startPositions", bdStartPositions);
    }
    
    function chooseBDPoly(qid, nextTarget, sources, allSources) {
        var top = 5;
        var index = 0;
        var coords = nextTarget.coords.split(',');
		var questionData = getQuestionData(qid);
		var bdStartPositions = questionData.getParamValue("startPositions");
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
        for(var i=0; i<sources.length; i++) {
            for(var j=0; j<allSources.length; j++)
                if(sources[i] == allSources[j])
                    index = j; //determine index in sources list
            var source = byId(sources[i]);
            bdStartPositions[index] = new BDPoint();
            bdStartPositions[index].X = (baseLeft + ExtractNumber(coords[0]) + 5) + "px";
            bdStartPositions[index].Y = (baseTop + ExtractNumber(coords[1]) + top) + "px";
            top += source.offsetHeight + 5;
        }
		questionData.setParam("startPositions", bdStartPositions);
    }

	function handleWebBDActivity(qid, msg, redraw) {
		var submitBtn = document.getElementById(qid + "_submitBtn");
		var doneBtn = document.getElementById(qid + "_doneBtn");
		var questionData = getQuestionData(qid);
		var bdMatches = questionData.getParamValue("dragMatches");
		var userBDPositions = questionData.getParamValue("userPositions");
		var currentQuestion = getQuestion(qid);
		
		if (questionData.getParamValue("buttonState") == "Submit") {
            removeEvent(byId("WebBinDrop_" + qid), 'mousedown', BDDragMouseDown);
			removeEvent(byId("WebBinDrop_" + qid), 'mouseup', BDOnMouseUp);
			checkBDMatch(qid, redraw);
		} else if (questionData.getParamValue("buttonState") == "Reset") {
			var sources = getAllSources(qid);
			questionData.setParam("snapCurrent", 0);
			//userBDPositions = positions set by user
			for (var i = 0; i < sources.length; i++) {
				userBDPositions[i] = new BDPoint();
				var sourceObj = byId(sources[i]);
				userBDPositions[i].X = sourceObj.style.left;
				userBDPositions[i].Y = sourceObj.style.top;
			}
			questionData.setParam("userPositions", userBDPositions);

			var alreadyOnTarget = 0;
			var targetsCount = questionData.getParamValue("targetsCount");
			//clean array with spots on target counter
			clearSpotsOnTarget(qid);
			
			if (getQuestion(qid).getParamValue("leaveCorrectBetweenAttempts") == "true") {
				var i = 0;
				
				while ( i < bdMatches.length - 2) {  //do not include last dummy elem
					var dragElement = byId(bdMatches[i]);
					if (dragElement != null && typeof(dragElement) != 'undefined' && typeof(dragElement.tag) != 'undefined') {
						if (dragElement.tag == bdMatches[i+1] && bdMatches[i].indexOf('distractor_item') == -1) {
							alreadyOnTarget++;
							changeSpotsOnTarget(qid, bdMatches[i+1], 1);
						} else {
                            dragElement.tag = "";
							//resize drag text objects
                            dragElement.style.width = "auto";
						}
					}
					i = i + 2;
				}
				
				questionData.setParam("alreadyOnTarget", alreadyOnTarget);
                rearrangeAllBD(qid);
			} else {
				restoreAllPositions(qid);
                redirectBDTargets(qid);
                var sources = getAllSources(qid);
                for(var i=0; i<sources.length; i++) {
                    var dragElement = document.getElementById(sources[i]);
                    dragElement.tag = "";
                    //resize drag text objects
                    dragElement.style.width = "auto";
                }
			}  
			//if after leave correct all right answers are placed show submit button
			if (alreadyOnTarget != targetsCount) {
				hide(qid + "_SubmitBox");
			}
			hide(qid + "_IncorrectResp");
			hide(qid + "_IncorrectRespDef");	
			// 'try again' with 'attempts' are not for instant submit
			jQuery("#"+qid+"_feedback_q_ir,"+"#"+qid+"_feedback_q_ir_try").css({
					"display" : "block",
					"visibility" : "hidden"
				});
					
			questionData.setParam("buttonState", "Submit");
			setButtonTitle(qid, langSubmit);
			InitBDDragDrop(qid);
		} else if (questionData.getParamValue("buttonState") == "ShowUser") {
			questionData.setParam("snapCurrent", 0);
			showUserAnswer(qid);
			questionData.setParam("buttonState", "ShowCorrect");
			setButtonTitle(qid, langShowSolution);
			if (doneBtn != null) {
				doneBtn.style.marginLeft = "0px";
				submitBtn.style.visibility = "visible";
				doneBtn.style.visibility = "visible";
				submitBtn.style.display = "block";
				doneBtn.style.display = "block";
				doneBtn.disabled = false;
			}
		} else if (questionData.getParamValue("buttonState") == "ShowCorrect") {
			questionData.setParam("snapCurrent", 0);
			var sources = getAllDestinations(qid);
			//bdStartPositions = correct answers
			choosePosition(qid);
			
			restoreAllPositions(qid);
			hideBDFeedbacks(qid);
			questionData.setParam("buttonState", "ShowUser");
			setButtonTitle(qid, langUserAnswer);
			if (doneBtn != null) {
				doneBtn.style.marginLeft = "0px";
				submitBtn.style.visibility = "visible";
				doneBtn.style.visibility = "visible";
				submitBtn.style.display = "block";
				doneBtn.style.display = "block";
				doneBtn.disabled = false;
			}
		}
	}
    
    function hideBDFeedbacks(qid) {
        var sources = getAllSources(qid);
        for(var i=0; i<sources.length; i++) {
            hide("right_" + sources[i]);
            hide("wrong_" + sources[i]);
        }
    }
	

function BDQuestion() {
    this.redraw = function () {
			var questionData = getQuestionData(this.guid);
			if (!questionData.getParamValue("arranged")) {
				setTimeout ("getQuestion('"+this.guid+"').redraw()", 500);
				return;
			}
						
			var bdDragDropMode = questionData.getParamValue("dragDropMode");
			var bdStartPositions = questionData.getParamValue("startPositions");
			
			if (bdDragDropMode == "Practice")
				return;
			//redraw the attempts left (as it goes from XSLT so the number is incorrect)
			var at = document.getElementById(this.guid + "_at_limit"); // change text node informing of remaining attempts
			if (this.attempts == 1) at.firstChild.nodeValue = " " + this.attempts + " " + langAttemptRemaining + ". ";
			else  at.firstChild.nodeValue = " " + this.attempts + " " + langAttemptsRemaining + ". ";
			
			if (this.attempts <= 0 || this.result == "correct") {
				//evaluate question
				var answs = this.userAnswer.split("|");
				
				for(var i=0; i<answs.length; i++) {
					var ans = answs[i].split(":");
					var source = byId(ans[0]);
					var dest = byId(ans[1]);
					if (source != null) {
						source.tag = ans[1];
						
						if (dest != null) {	
							switch(dest.shape.toLowerCase()) {
								case "rect": placeBDNextRect(this.guid, dest, source); break;
								case "circle": placeBDNextCircle(this.guid, dest, source); break;
								case "poly": 
									//hack for polygon. rearrange elements without initial placing 
									source.tag = dest.id;
									rearrangeBDPoly(this.guid, dest);
															
									var newPositions = questionData.getParamValue("newPositions");
									bdStartPositions[i] = new BDPoint();
									bdStartPositions[i].X = source.style.left = newPositions[i].X;
									bdStartPositions[i].Y = source.style.top = newPositions[i].Y;
								break;
							}
						}
		
						if (!dest || dest.shape.toLowerCase() != "poly") {
							bdStartPositions[i] = new BDPoint();
							bdStartPositions[i].X = source.style.left;
							bdStartPositions[i].Y = source.style.top;
							questionData.setParam("startPositions", bdStartPositions);
						}
						
					}
				}
            
				//if question is done, add +1 attempt and call handleWebBDActivity 
				//  to render the question result. Attempts are decreased in this function by 1   
                this.attempts = this.attempts + 1; //increase attempts as handleWebBDActivity 
				show(this.guid + "_SubmitBox");
				handleWebBDActivity(this.guid,"",true);
            }
        }
}
	
BDQuestion.prototype = new Question;
	
	function addBDQuestion(question) {
		bdquestions[bdquestions.length] = question;
		addQuestion(question);
	}

	
function setBDQuestions() {
    var isAssessment = true;
    for (l=0; l<document.forms.length; l++) {
        var fname = document.forms[l].name;     
        if (fname.toLowerCase().indexOf("questionform") == -1) continue;
        var fid = document.forms[l].id;
        if (fid.toLowerCase().indexOf("webbindrop") == -1) continue;

        var wab_id = fname.substr(13);
        
        var wab_obj = document.getElementById("wab_"+wab_id);
        var newBDQuestion = new BDQuestion();
        newBDQuestion.setParam("guid", wab_id);

        newBDQuestion.setParam("mode", 
                wab_obj.getAttribute("wab_Mode"));
        newBDQuestion.setParam("attempts", 
                wab_obj.getAttribute("wab_AttemptLimit"));      
        newBDQuestion.setParam("showHint", 
                wab_obj.getAttribute("wab_ShowHint"));  
        newBDQuestion.setParam("overlayFeedback", 
                wab_obj.getAttribute("wab_OverlayFeedback"));      
        newBDQuestion.setParam("hintActive", 
                wab_obj.getAttribute("wab_hint_active"));       
        newBDQuestion.setParam("showSolution", 
                wab_obj.getAttribute("wab_ShowSolution"));
        newBDQuestion.setParam("rollupWeight", 
                wab_obj.getAttribute("wab_RollupWeight"));
		newBDQuestion.setParam("leaveCorrectBetweenAttempts", 
			wab_obj.getAttribute("wab_LeaveCorrectBetweenAttempts"));	

        addBDQuestion(newBDQuestion);
		if(wab_obj.getAttribute("wab_Mode") == "Practice"){
			isAssessment = false;
		}
    }
}
	
function initBDPage() {
    setBDQuestions();
    getUserResults(bdquestions);
}	

// keyboard accessebility for bin drop activity
jQuery(document).ready(function(){
	var binDropObjectsLinks = jQuery("a[name='BinDropObject']");
	var binDropTargetsAreas = jQuery("map > area[name='BinDropTarget']");
	var selectedBinDropObject;

	binDropObjectsLinks.each(function() {
			var currentLinkElem = jQuery(this);
			var binDropObject = currentLinkElem.next();
			var qid = this.id.substr(0, this.id.indexOf("_object"));
			var currentQuestion = getQuestion(qid);
			var questionData = getQuestionData(qid);
			var currentTabIndex = currentLinkElem.attr("tabindex");	
			var bdStartPositions = questionData.getParamValue("startPositions");
			
			currentLinkElem.focus(function() {		
					binDropObject.css({
						"border" : questionData.getParamValue("highlightDropAreaBorder"),
						"border-width" : "2px",
						"border-style" : "solid"
					});
				})
			.blur(function() {
					binDropObject.css("border", "none");				
				})
			.keydown(function(event) {
		
				//space or enter was pressed
				if (event.keyCode == 32 || event.keyCode == 13) {
					selectedBinDropObject = binDropObject;
					
					binDropTargetsAreas.attr("tabindex", "0");
					binDropObjectsLinks.attr("tabindex", "-1");
					
					//Save start positions
					if (bdStartPositions.length == 0) {
						var sources = getAllSources(qid);
						for (var i = 0; i < sources.length; i++) {
							bdStartPositions[i] = new BDPoint();
							var sourceObj = byId(sources[i]);
							bdStartPositions[i].X = sourceObj.style.left;
							bdStartPositions[i].Y = sourceObj.style.top;
						}
					}

					questionData.setParam("startPositions", bdStartPositions);
				
					//set focus to first drop area
					jQuery("area[id*='"+qid+"'][name='BinDropTarget']").eq(0).focus();
		
					return false;
				}
			});		
		});
		
		
		// variable to keep focused element 
		// for handling keydown event in IE !
		var binDropTargetArea;
		
		binDropTargetsAreas.each(function() {
			
			var qid = this.id.substr(this.id.indexOf("_") + 1, this.id.length);
			var currentQuestion = getQuestion(qid);
			var questionData = getQuestionData(qid);
			
			jQuery(this).attr("tabindex", "-1");
		
			jQuery(this).focus(function() {						
					binDropTargetArea = jQuery(this);
					paintBDArea(this, qid);
				})
			.blur(function() {
					paintBDOutlines(qid);
				})
			.keydown(function(event) {
				//space or enter was pressed
				if ((event.keyCode == 32 || event.keyCode == 13) && binDropTargetArea) {	
				
					var source = selectedBinDropObject.get(0);
					var destination = binDropTargetArea.get(0);
					var _bd_offsetX = questionData.getParamValue("offsetX");	
					var _bd_offsetY = questionData.getParamValue("offsetY");						
					
					if (destination	&& (destination.getAttribute("spotAreasCount") > getSpotsOnTarget(qid, destination.id) 
							|| destination.getAttribute("spotAreasCount") == 0)) {
						// snap the drop item to its target coordinates
					
						switch (destination.shape.toLowerCase()) {
							case "rect": placeBDNextRect(qid, destination, source); break;
							case "circle": placeBDNextCircle(qid, destination, source); break;
							case "poly": 
								source.tag = destination.id;
							break;
						}
									
						if (source.tag && source.tag != "") {
							var previousBin = document.getElementById(source.tag);
							source.tag = destination.id;
							switch (previousBin.shape.toLowerCase()) {
								case "rect": rearrangeBDRect(qid, previousBin); break;
								case "circle": rearrangeBDCircle(qid, previousBin); break;
								case "poly": rearrangeBDPoly(qid, previousBin); break;
							}
							//decrease one element is out target
							changeSpotsOnTarget(qid, previousBin.id, -1);
							questionData.setParam("snapCurrent", 0);
							clearInterval(questionData.getParamValue("snapTimer"));
							var snapTimer = setInterval("snapBackAll('" +qid + "','newPositions','userPositions',15)", 10);
							questionData.setParam("snapTimer", snapTimer);
						}
						//increase if one more element is on target
						changeSpotsOnTarget(qid, destination.id, 1);
						
						source.tag = destination.id;
						source.value = destination.id;
						questionData.setParam("dragElement", null);	
												
						var sources = getAllSources(qid);
						var allOnTargets = true;
						for (var i = 0; i < sources.length; i++) {
							var source = byId(sources[i]);
								
							if((source &&  !source.tag  || source.tag == "") && source.id.indexOf('distractor_item') == -1) {
								allOnTargets = false;
								break;
							}
						}
						
						//if max spots of all targets are placed -> show submit
						var spotsOnTarget = questionData.getParamValue("spotsOnTarget");
						var destinations = getAllDestinations(qid);
						var allSpotsOnAreas = true;
						for (var i = 0; i < destinations.length;i++){
							if (destinations[i] != "") {
								var spotAreasCount = byId(destinations[i]).getAttribute("spotAreasCount");
								if (typeof(spotAreasCount) == "undefined" || spotAreasCount == "" || spotAreasCount == 0 || spotAreasCount > spotsOnTarget[i]) {
									allSpotsOnAreas = false;
								}	
							}
						}
						
						if (allOnTargets) {
							show(qid + "_SubmitBox");
							//removeEvent(byId("WebBinDrop_" + qid), 'mousedown', BDDragMouseDown);
							//removeEvent(byId("WebBinDrop_" + qid), 'mouseup', BDOnMouseUp);
						}
					} else {
						restorePosition(qid, _bd_offsetX, _bd_offsetY);
					}
					
					binDropObjectsLinks.attr("tabindex", "0");
					binDropTargetsAreas.attr("tabindex", "-1");
					//switch focus
					jQuery(this).blur();
					selectedBinDropObject.prev().blur();
					jQuery("a[id*='"+qid+"'][name='BinDropObject']").eq(0).focus();
					
					return false;
				}
			});
		});
	});
