/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/




InitBDHotSpot();

function InitBDHotSpot() {
   // addEvent(document, 'mousedown', BinsMouseDown);
    addEvent(document, 'mouseup', hideBDAll);
}

function paintBDOutlines(qid) {
    var drawedTargets = new Array();
   
	var questionData = getQuestionData(qid);
	var bdMatches = questionData.getParamValue("dragMatches");
	var bdOffsets = questionData.getParamValue("offsets");
	var bdoutlinemaps = questionData.getParamValue("outlinemaps");
	
	bdoutlinemaps[0].clear();
	for(var index=1; index<bdMatches.length-2; index+=2) {
		if(bdoutlinemaps[0] != null) {	
			if(bdMatches[index] in drawedTargets) continue;
			drawedTargets.push(bdMatches[index]);
			var target = document.getElementById(bdMatches[index]);
			if(typeof(target) == 'undefined' || target == null) continue;
			var coords = target.coords.split(',');
			
			if(target.shape.toLowerCase() == "rect") {
				bdoutlinemaps[0].drawRect(parseInt(coords[0]) + parseInt(bdOffsets), parseInt(coords[1]), coords[2]-coords[0], coords[3]-coords[1]);
			}
			if(target.shape.toLowerCase() == "circle")
				bdoutlinemaps[0].drawEllipse((coords[0]-coords[2]) + parseInt(bdOffsets), coords[1]-coords[2], 2 * parseInt(coords[2]), 2 * parseInt(coords[2]));
			if(target.shape.toLowerCase() == "poly") {
				var xs = new Array();
				for(var i=0; i<coords.length/2; i++)
					xs[i] = parseInt(coords[2*i]) + parseInt(bdOffsets);
				var ys = new Array();
				for(var i=0; i<coords.length/2; i++)
					ys[i] = parseInt(coords[2*i+1]);
				bdoutlinemaps[0].drawPolygon(xs, ys);
			}
		}
	}
	bdoutlinemaps[0].paint();
	hideBDAll(qid);
}

/**
* to draw each area target styled
* @param target specifies area
* @param qid - question id
*
*/
function paintBDArea(target, qid) {   
	var questionData = getQuestionData(qid);
	var bdMatches = questionData.getParamValue("dragMatches");
	var bdOffsets = questionData.getParamValue("offsets");
	var bdoutlinemaps = questionData.getParamValue("outlinemaps");
	var jsGraphicsCanvas = jQuery("#BinMap_"+qid+" > div").eq(0);

	if(bdoutlinemaps[0] && target) {	
		var coords = target.coords.split(',');
		bdoutlinemaps[0].clear();
		
		if(target.shape.toLowerCase() == "rect") {
			bdoutlinemaps[0].drawRect(parseInt(coords[0]) + parseInt(bdOffsets), parseInt(coords[1]), coords[2]-coords[0], coords[3]-coords[1]);
		} else if (target.shape.toLowerCase() == "circle") {
			bdoutlinemaps[0].drawEllipse((coords[0]-coords[2]) + parseInt(bdOffsets), coords[1]-coords[2], 2 * parseInt(coords[2]), 2 * parseInt(coords[2]));
		} else if (target.shape.toLowerCase() == "poly") {
			var xs = new Array();
			for (var i = 0; i < coords.length/2; i++) {
				xs[i] = parseInt(coords[2*i]) + parseInt(bdOffsets);
			}
			var ys = new Array();
			for (var i = 0; i < coords.length/2; i++) {
				ys[i] = parseInt(coords[2*i+1]);
			}
			bdoutlinemaps[0].drawPolygon(xs, ys);
		}
	}

	bdoutlinemaps[0].paint();
	jsGraphicsCanvas.css("visibility", "visible");
}

function hideBDAll(e) {

	if (typeof(e) != "string"){
	  // IE is retarded and doesn't pass the event object
		if (e == null)
			e = window.event; 	
		var target = e.target != null ? e.target : e.srcElement;
		var qid = getQidFromNode(target);
	} else {	
		var qid = e;
	}

	if (qid != null) {
		hideBDHints(qid);
		var binMap = document.getElementById("BinMap_"+qid);
		
		if (binMap) {
			var outline = binMap.lastChild;
			while(outline.nodeName.toLowerCase() != 'div'){
				outline = outline.previousSibling;
			}
			outline.style.visibility = "hidden";
		}
	}
	
}

function hideBDHints(qid) {
    var dests = getBDUniqueDestinations(qid);
    for (var i=0; i < dests.length; i++) {
        var displayArea = document.getElementById("display" + dests[i]);
        if(displayArea != null) displayArea.innerHTML = "";
	}
}

function showBDHint(qid, id, alt) {
    var displayArea = document.getElementById("display" + id);
    if(displayArea != null) {
        displayArea.innerHTML = alt;
    }
}

 //function is not needed mouseDown is already defined
function BinsMouseDown(e) {

    // IE is retarded and doesn't pass the event object
/*
    if (e == null)
        e = window.event; 	
    var target = e.target != null ? e.target : e.srcElement;
    // IE uses srcElement, others use target
    var id = target.id;
    var found = false;
    var pos;
	
	var qid = getQidFromNode(target)
	if (qid != null) {
		hideBDAll(qid);
		var bdMatches = getQuestionData(qid).getParamValue("dragMatches");
		for(pos=0; pos<bdMatches.length; pos++){
			if(id == bdMatches[pos]) {
				found = true;
				break;
			}
		}
		if(!found) return;
		
		var mainDiv = target;
		while(mainDiv.parentNode) {
			if (typeof(mainDiv.id) != "undefined" && mainDiv.id.indexOf("MainBDDiv") != 0){
				break;
			}
			mainDiv = mainDiv.parentNode
		}
		
		if (typeof(mainDiv.id) != "undefined") {
			var outline = document.getElementById("BinMap" + mainDiv.id.substring(9));
			if (outline == null)
				return;
			outline = outline.lastChild;
			while(outline.nodeName.toLowerCase() != 'div')
				outline = outline.previousSibling;
			outline.style.visibility = "visible";
		}
	} */
}


function showContent(elemID) {	
	
	// NOT IMPLEMENTED FOR MOUSE OVER

/*	var element = document.getElementById(elemID);
	if(typeof(element) == 'undefined')	
	    return;
	
	hideAll();
	
	if (DISPLAY_AREA_SPECIFIED != null && DISPLAY_AREA_SPECIFIED) {
			element.className= 'showedContent';
			element.style.display = 'block';
			element.style.visibility = 'visible';
		} else {		
			element.style.display = 'block';
			element.style.visibility = 'visible';
			element.style.left = posx + "px";		
			element.style.top = posy + "px";		
			element.style.width = width + "px";
		}*/
}

function getOffset(element, wrap)
{
	if(element.children) {
		for(var i=0; i<element.children.length; i++)
		{
			if(element.children[i].tagName == "IMG")
			{
				return element.children[i].offsetLeft;
			}
		}
	} else {
		for(var i=0; i<element.childNodes.length; i++)
		{
			if(element.childNodes[i].tagName == "IMG")
			{
				return element.childNodes[i].offsetLeft;
			}
		}
	}
	return 0;
}

function getTopOffset(element)
{
	if(element.children) {
		for(var i=0; i<element.children.length; i++)
		{
			if(element.children[i].tagName == "IMG")
			{
				return element.children[i].offsetTop;
			}
		}
	} else {
		for(var i=0; i<element.childNodes.length; i++)
		{
			if(element.childNodes[i].tagName == "IMG")
			{
				return element.childNodes[i].offsetTop;
			}
		}
	}
	return 0;
}