/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

	scorableContent = true;   //Used by CRE to determine if the page is scorable
	DNDQ = true;               // defined in questions.js
	var dndquestions = new Array();		

// call-back function for re-arrange grag'n'drop items e.g. set correct left and top offset
// should be called after the page is loaded	
function arrangeDNDObjects(qid, id) {
	try{
		var baseImageElem = byId(id);
		var questionData = getQuestionData(qid);
		var dndMatches = questionData.getParamValue("dragMatches");
		
		InitDragDrop(qid);
		
		/*Need when DnD is in GameShow for get offsets normaly*/
		var GSisParent = jQuery('#WebDragDrop_'+qid).parents('.gsHiddenContent')
		if(GSisParent.hasClass('gsHiddenContent')){
				GSisParent.css({'display' : 'block',
								 'visibility' : 'visible'})
						  .removeClass('gsHiddenContent')
						  .addClass('gsShownContent')
			}
		/*----------------------------------------------------*/
		
		if (typeof(baseImageElem)!="undefined") {	
			
			var baseLeft = baseImageElem.offsetLeft;
			var baseTop = baseImageElem.offsetTop;
			questionData.setParam("baseTop", baseTop);
			questionData.setParam("baseLeft", baseLeft);
			baseImageElem.style.position = "static";
			var dests = getAllDestinations(qid)
			// get elements
			for (var i=0; i < dndMatches.length; i++) {
				var elem = byId(dndMatches[i]);
				var corrImg = byId("right_" + dndMatches[i]);
				var incorrImg = byId("wrong_" + dndMatches[i]);
				if(dests[i] == "" && elem!= null && typeof(elem)!='undefined')
					elem.tag = "";
				
				//set grag objects relative position
				updateDNDCoordinates(elem, baseLeft, baseTop);
				updateDNDCoordinates(corrImg, baseLeft, baseTop);
				updateDNDCoordinates(incorrImg, baseLeft, baseTop);
			}
		}
		
		var dndTargetsCount = questionData.getParamValue("targetsCount");
		if(!dndTargetsCount) {
			dndTargetsCount = dndMatches.length / 2 - 1;
			questionData.setParam("targetsCount", dndTargetsCount);
		}
		
		/*Need when DnD is in GameShow for get offsets normaly*/
		if(GSisParent.hasClass('gsShownContent')){
				GSisParent.css({'display' : 'none',
								 'visibility' : 'hidden'})
						  .removeClass('gsShownContent')
						  .addClass('gsHiddenContent')
			}
		/*----------------------------------------------------*/
		
	} catch(e){
		setTimeout ("arrangeDNDObjects('"+qid+"','"+id+"')", 100);
		return;
	}
	
	//Save user positions after arrange had place
	var currentQuestion = getQuestion(qid);
	var userDndPositions = questionData.getParamValue("userPositions");
	var dndDragDropMode = questionData.getParamValue("dragDropMode");
	
	if (dndDragDropMode != "Practice") {
		var sources = getAllSources(qid);
		for (var i = 0; i < sources.length; i++) {
			var sourceObj = byId(sources[i]);
			userDndPositions[i] = new DNDPoint();
			userDndPositions[i].X = sourceObj.style.left;
			userDndPositions[i].Y = sourceObj.style.top;
		}
		questionData.setParam("userPositions", userDndPositions);
	}else{ 
		// don't shot attempts count in Practice mode
		hide(qid + '_at_limit');
	}
	var cover = byId("ContentCover_" + qid);
	if (typeof(cover)!="undefined" && cover!=null) {
		cover.style.visibility = "hidden";
	}
	
	//arrange took place
	questionData.setParam("arranged", true);
}

function updateDNDCoordinates(element, baseLeft, baseTop) {
	if (element!= null && typeof(element) != 'undefined') {
		element.style.left = baseLeft + ExtractNumber(element.style.left) + "px";
		element.style.top = baseTop + ExtractNumber(element.style.top) + "px";
	}
}
	
function DNDPoint() {
	this.X = 0;
	this.Y = 0;
}
	
function InitDragDrop(qid) {
	var questionData = getQuestionData(qid);
	var currentQuestion = getQuestionWithoutInit(qid);
	
	if (currentQuestion && currentQuestion.getParamValue("attempts") == 0){
		return;
	}
	addEvent(byId("WebDragDrop_" + qid), 'mousedown', dndOnMouseDown);
	addEvent(byId("WebDragDrop_" + qid), 'mouseup', dndOnMouseUp);

	// prevent text selection in IE
	addEvent(byId("WebDragDrop_" + qid), 'selectstart', function () { return false; });
	addEvent(byId("WebDragDrop_" + qid), 'dragstart', function(e) {return false;});
	var DND_DEBUG_MODE = getQuestionData(qid).getParamValue("debugMode");

	if (DND_DEBUG_MODE) {
		document.write('<div id="debug"></div>');
		questionData.setParam("debug",byId('debug'));
	}	
}

function dndOnMouseDown(e) {
	// IE is retarded and doesn't pass the event object
    if (e == null) 
        e = window.event; 
    // IE uses srcElement, others use target
    var target = e.target != null ? e.target : e.srcElement;
	var qid = getQidFromNode(target, "WebDragDrop_");

	if (qid != null) {
		var questionData = getQuestionData(qid);
		var _dnd_dragElement = questionData.getParamValue("dragElement");
		var _dnd_debug = questionData.getParamValue("debug");
		//check if there was no drag element left or dndDragDropMode not defined
		if(_dnd_dragElement != null)
			return;
		var dndDragDropMode = questionData.getParamValue("dragDropMode");
		var dndStartPositions = questionData.getParamValue("startPositions");
		var dndHighlightDropArea = questionData.getParamValue("highlightDropArea");
		
		if (typeof(dndDragDropMode) == 'undefined') {
			removeEvent(byId("WebDragDrop_" + qid), 'mousedown', dndOnMouseDown);
			removeEvent(byId("WebDragDrop_" + qid), 'mouseup', dndOnMouseUp);
			return false;
		}

		//Save start positions
		if (dndStartPositions.length == 0) {
			var sources = getAllSources(qid);
			for (var i = 0; i < sources.length; i++) {
				
				var sourceObj = byId(sources[i]);
				if(sourceObj != null) {
					dndStartPositions[i] = new DNDPoint();				
					dndStartPositions[i].X = sourceObj.style.left;
					dndStartPositions[i].Y = sourceObj.style.top;
					questionData.setParam("startPositions", dndStartPositions);	
				}
			}
					
		}	
	
		var DND_DEBUG_MODE = questionData.getParamValue("debugMode");
		if (DND_DEBUG_MODE) {
			_dnd_debug.innerHTML = target.className == 'dnddraggable' 
				? 'draggable element clicked' 
				: 'NON-draggable element clicked';
				questionData.setParam("debug",_dnd_debug);
		}
		// for IE, left click == 1
		// for Firefox, left click == 0
		if ((e.button == 1 && window.event != null || 
			e.button == 0) && 
			target.className == 'dnddraggable') {
			// grab the mouse position
			var posx = 0;
			var posy = 0;
			if (!e) var e = window.event;
			if (e.pageX || e.pageY) 	{
				posx = e.pageX - document.body.scrollLeft
					- document.documentElement.scrollLeft;
				posy = e.pageY - document.body.scrollTop
					- document.documentElement.scrollTop;
			}
			else if (e.clientX || e.clientY) 	{
				posx = e.clientX;
				posy = e.clientY;
			}
			// posx and posy contain the mouse position relative to the document
			questionData.setParam("startX", posx);	
			questionData.setParam("startY", posy);	

							
			// grab the clicked element's position
			questionData.setParam("offsetX", jQuery(target).position().left);// ExtractNumber(target.style.left);
			questionData.setParam("offsetY", target.offsetTop);// ExtractNumber(target.style.top);
			
			// bring the clicked element to the front while it is being dragged
			questionData.setParam("oldZIndex", target.style.zIndex);
			target.style.zIndex = 10000;
			if (isIE) {		   
				target.style['filter'] = "alpha(opacity=50)";
			} else {		
				target.style.opacity = '0.5';   // make half-transparent when move
			}
			
			// we need to access the element in OnMouseMove
			_dnd_dragElement = target;
			questionData.setParam("dragElement",_dnd_dragElement);	

		
			if (checkHitDND(qid, _dnd_dragElement)) {
				questionData.setParam("alreadyOnTarget",questionData.getParamValue("alreadyOnTarget") - 1);
				questionData.setParam("lastOnTarget", true);	

				if (questionData.getParamValue("alreadyOnTarget") < questionData.getParamValue("targetsCount")) {	
					hide(qid + "_SubmitBox");
				}
			}

				// Highlight destination drop area
				if (typeof(dndHighlightDropArea) != 'undefined' && dndHighlightDropArea == true) {
					// get ALL destination
					var destinationElems =  getAllDestinations(qid);			
					for (var i = 0; i < destinationElems.length; i++) {
						var destinationElem = byId(destinationElems[i]);
					
						if (typeof(destinationElem) != 'undefined' && destinationElem != null) {
							destinationElem.style.width = _dnd_dragElement.offsetWidth + "px";
							destinationElem.style.height = _dnd_dragElement.offsetHeight + "px";
							destinationElem.className  = "dndhighlighted";						
							destinationElem.style.border  = questionData.getParamValue("highlightDropAreaBorder");	
						}
					}
				}
			
			// tell our code to start moving the element with the mouse
			addEvent(byId("WebDragDrop_" + qid), 'mousemove', dndOnMouseMove);
			addEvent(byId("WebDragDrop_" + qid), 'drag', dndOnMouseMove);
				
			// cancel out any text selections
			document.body.focus();

			if (e.stopPropagation) {
				e.stopPropagation();
				e.preventDefault();
			} else {
				if (window.event) {
					window.event.cancelBubble = true;
					window.event.returnValue = false;
				}
			}
			
			// prevent text selection (except IE)
			return false;
		}
	}
}


function dndOnMouseMove(e) {
    if (e == null) 
        var e = window.event; 
		var target = e.target != null ? e.target : e.srcElement;
		var qid = getQidFromNode(target, "WebDragDrop_");
		
	if (qid != null) {
		var questionData = getQuestionData(qid);
		var DND_DEBUG_MODE = questionData.getParamValue("debugMode");
		var _dnd_dragElement = questionData.getParamValue("dragElement");
		
		var _dnd_startX = questionData.getParamValue("startX");	
		var _dnd_startY = questionData.getParamValue("startY");	
		var _dnd_offsetX = questionData.getParamValue("offsetX");	
		var _dnd_offsetY = questionData.getParamValue("offsetY");	
		var _dnd_debug = questionData.getParamValue("debug");	
		//  "drag code"	
		if (_dnd_dragElement != null) {
			_dnd_dragElement.style.left = (_dnd_offsetX + e.clientX - _dnd_startX) + 'px';
			_dnd_dragElement.style.top = (_dnd_offsetY + e.clientY - _dnd_startY) + 'px';    
			questionData.setParam("dragElement",_dnd_dragElement);	
		}

		if (DND_DEBUG_MODE) {
			_dnd_debug.innerHTML = '(' + _dnd_dragElement.style.left + ', ' + 
				_dnd_dragElement.style.top + ')' + ' Button: ' + e.button + ' which: ' + e.which;
				questionData.setParam("debug",_dnd_debug);
		}
		if (e.stopPropagation) {
			e.stopPropagation();
			e.preventDefault();
		}
		else {
			if (window.event) {
				window.event.cancelBubble = true;
				window.event.returnValue = false;
			}
		}
	}
}


	function dndOnMouseUp(e) {
		// IE is retarded and doesn't pass the event object
		if (e == null)
			var e = window.event;

		var target = e.target != null ? e.target : e.srcElement;
		var qid = getQidFromNode(target, "WebDragDrop_");
		if (qid != null) {
			var questionData = getQuestionData(qid);
			var _dnd_dragElement = questionData.getParamValue("dragElement");
			var _dnd_offsetX = questionData.getParamValue("offsetX");	
			var _dnd_offsetY = questionData.getParamValue("offsetY");
			var dndMatches = questionData.getParamValue("dragMatches");
			var currentQuestion = getQuestion(qid);

			if (_dnd_dragElement != null) {
				var DND_DEBUG_MODE = questionData.getParamValue("debugMode");
				_dnd_dragElement.style.zIndex = questionData.getParamValue("oldZIndex");
				if (isIE) {
					_dnd_dragElement.style['filter'] = "";
				} else {
					_dnd_dragElement.style.opacity = '1.0';
					// restore previous transparent state
				}
				questionData.setParam("dragElement",_dnd_dragElement);	

				// we're done with these events until the next OnMouseDown
				removeEvent(byId("WebDragDrop_" + qid), 'mousemove', dndOnMouseMove);
				removeEvent(byId("WebDragDrop_" + qid), 'drag', dndOnMouseMove);

				var left = _dnd_dragElement.offsetLeft;
				var top = _dnd_dragElement.offsetTop;
				var elemId = _dnd_dragElement.id;

				var dndDragDropMode = questionData.getParamValue("dragDropMode");
				var dndHighlightDropArea = questionData.getParamValue("highlightDropArea");
				
				// check the match only for non distractor elements
	
					// get matched element 
				var destinationElem;
					//= getDestinationElement(qid, elemId);
		
					// Highlight destination drop area
				if (typeof(dndHighlightDropArea) != 'undefined' && dndHighlightDropArea == true) {
					// get ALL destinations
					var destinations =  getAllDestinations(qid);
					for (var i = 0; i < destinations.length; i++) {
						var destination = byId(destinations[i]);

						if (typeof(destination) != 'undefined' && destination != null)
							destination.className = "dndunhighlighted";
					}
				}
				destinationElem = checkHitFreeDND(qid, _dnd_dragElement);
				
				if (destinationElem != null && typeof(destinationElem) != 'undefined') {
				
					// moove back drag element in case of wrong answer in practice mode
					if (dndDragDropMode == "Practice") {
						var i = 0;
						while (i < dndMatches.length - 2) {  
							var dragElement = byId(dndMatches[i]);
							
							if (dragElement == _dnd_dragElement && destinationElem.id != dndMatches[i+1]) {
								restorePosition(qid,_dnd_offsetX, _dnd_offsetY, e);
								return false;
							}
							i = i + 2;
						}
						
					}
					// snap the drop item to its target coordinates
					_dnd_dragElement.style.top = ExtractNumber(destinationElem.style.top) + "px";
					_dnd_dragElement.style.left = ExtractNumber(destinationElem.style.left) + "px";
					_dnd_dragElement.tag = destinationElem.id;
					_dnd_dragElement = null;
					questionData.setParam("dragElement",_dnd_dragElement);
					questionData.setParam("alreadyOnTarget", questionData.getParamValue("alreadyOnTarget") + 1);
					if (questionData.getParamValue("alreadyOnTarget") == questionData.getParamValue("targetsCount")) {	
						show(qid + "_SubmitBox");
						removeEvent(byId("WebDragDrop_" + qid), 'mousedown', dndOnMouseDown);
						removeEvent(byId("WebDragDrop_" + qid), 'mouseup', dndOnMouseUp);
					}
				} else {
					if (questionData.getParamValue("lastOnTarget")) {
						questionData.setParam("alreadyOnTarget",questionData.getParamValue("alreadyOnTarget") + 1);
						questionData.setParam("lastOnTarget", false);
					}
					restorePosition(qid,_dnd_offsetX, _dnd_offsetY, e);
				}
				
				if (e.stopPropagation) {
					e.stopPropagation();
					e.preventDefault();
				}
				else {
					if (window.event) {
						window.event.cancelBubble = true;
						window.event.returnValue = false;
					}
				}

				if (DND_DEBUG_MODE) {
					var _dnd_debug = questionData.getParamValue("debug");
					_dnd_debug.innerHTML = 'mouse up';
					questionData.setParam("debug",_dnd_debug);
				}
			}
		}
	}
	
	function doMatched(qid) {		
		show(qid + "CorrectResp");		
		setTimeout ("hide(qid + 'CorrectResp')", 2000);	
	}
	
	function doNotMatched(qid) {
		show(qid + "IncorrectResp");		
		setTimeout ("hide(qid + 'IncorrectResp')", 2000);		
	} 
	
	function checkDNDSubmit(qid, msg) {
		var user_answer = "";
		var destinationElems = getAllDestinations(qid);
		var sourceElems = getAllSources(qid);
		for (var i = 0; i < sourceElems.length; i++) {
			var dragElement = byId(sourceElems[i])
			user_answer += dragElement.id + ":" + dragElement.tag + "|";
		}
		getQuestion(qid).setParam("userAnswer", user_answer);
		return user_answer;
	}
	
	function checkDNDMatch(qid, redraw) {
		// ---imagemapquiz variables---
		var submitBtn = document.getElementById(qid + "_submitBtn");
		var doneBtn = document.getElementById(qid + "_doneBtn");
		// ---imagemapquiz variables---
		var questionData = getQuestionData(qid);
		var dndMatches = questionData.getParamValue("dragMatches");
		
		var dndShowSolution = questionData.getParamValue("showSolution");
		
		var dndIaMode = questionData.getParamValue("iaMode");
		var userDndPositions = questionData.getParamValue("userPositions");
		var newDndPositions = questionData.getParamValue("newPositions");
		
		var dndDragDropMode = questionData.getParamValue("dragDropMode");		
		var DND_IMAGE_OFFSET = questionData.getParamValue("imageOffset");
		var currentQuestion = getQuestion(qid);
		
		//check the match
		var matched = true;
		var i = 0;
		
		checkDNDSubmit(qid, "");
		var at_limit = currentQuestion.getParamValue("attempts");		
		
		var sfeedback =getFeedbackMode(questionData);
		
		var showAdvice = questionData.getParamValue("showAdvice"); 
		
		//Save user positions
		if (at_limit <= 1 && dndDragDropMode != "Practice") {
			var sources = getAllSources(qid);
			for (var i = 0; i < sources.length; i++) {
				var sourceObj = byId(sources[i]);
				userDndPositions[i] = new DNDPoint();
				userDndPositions[i].X = sourceObj.style.left;
				userDndPositions[i].Y = sourceObj.style.top;
			}
			questionData.setParam("userPositions", userDndPositions);
		}
		i = 0;
		while (i < dndMatches.length - 2) {  //do not include last dummy elem
			var dragElement = byId(dndMatches[i]);
			var destinationElem = getDestinationElement(qid, dndMatches[i]);
			if (destinationElem != null && typeof(destinationElem) != 'undefined' && dragElement != null && typeof(dragElement) != 'undefined') {
				if (!(ExtractNumber(destinationElem.style.left) + DND_IMAGE_OFFSET > ExtractNumber(dragElement.style.left) &&
					  ExtractNumber(destinationElem.style.left) - DND_IMAGE_OFFSET < ExtractNumber(dragElement.style.left) + ExtractNumber(dragElement.style.width) &&
					  ExtractNumber(destinationElem.style.top) + DND_IMAGE_OFFSET > ExtractNumber(dragElement.style.top) &&
					  ExtractNumber(destinationElem.style.top) - DND_IMAGE_OFFSET < ExtractNumber(dragElement.style.top) + ExtractNumber(dragElement.style.height))) {
					matched = false;
					if(at_limit <= 1 && dndDragDropMode != "Practice") {
						var img = byId("wrong_" + dndMatches[i+1]);
						if(sfeedback === ShowFeedback.all && img != null && typeof(img) != 'undefined') {
							img.style.left = ExtractNumber(img.offsetLeft) + dragElement.offsetWidth + 'px';
							hide("right_" + dndMatches[i+1]);
							show("wrong_" + dndMatches[i+1]);
						}
					}
				} else {
					if(at_limit <= 1 && dndDragDropMode != "Practice") {
						var img = byId("right_" + dndMatches[i+1]);
						if(sfeedback === ShowFeedback.all && img != null && typeof(img) != 'undefined') {
							img.style.left = ExtractNumber(img.offsetLeft) + dragElement.offsetWidth + 'px';
							show("right_" + dndMatches[i+1]);
							hide("wrong_" + dndMatches[i+1]);
						}
					}
				}
			}
			i = i + 2;
		}
		if (matched) {	// All MATCHED
			currentQuestion.setParam("result", "correct"); // set question result
			setDisabled(qid); // mark question options disabled
			if (doneBtn != null) {
				submitBtn.style.visibility = "hidden";
				doneBtn.style.visibility = "visible";
				doneBtn.disabled = false;
			}
			
			if (sfeedback) {					
			i = 0;
			
			while (i < dndMatches.length - 2) {  //do not include last dummy elem
				var dragElement = byId(dndMatches[i]);			
				var img = byId("right_" + dndMatches[i+1]);
				
				if(at_limit > 1 && dndDragDropMode != "Practice" && img) {				
					img.style.left = ExtractNumber(img.offsetLeft) + dragElement.offsetWidth + "px";
					show("right_" + dndMatches[i+1]);
					hide("wrong_" + dndMatches[i+1]);
				}
				
				i = i + 2;	
			}				
				}
		} else {
			// Any was NOT MATCHED
			currentQuestion.setParam("result", "incorrect"); // set question result
			if ((at_limit > 1 || dndDragDropMode == "Practice")) {
				questionData.setParam("buttonState", "Reset");
				setButtonTitle(qid, langReset);
			} else {
				if (dndShowSolution) {
					questionData.setParam("buttonState", "ShowCorrect");
					setButtonTitle(qid,langShowSolution);
				} else {
					setDisabled(qid);
					hide(qid + "_SubmitBox");
					if (doneBtn != null) {
						submitBtn.style.visibility = "hidden";
						doneBtn.style.visibility = "visible";
						doneBtn.disabled = false;
					}
				}
			}
		}
		
		handleAdvice(qid, showAdvice, at_limit, matched); // show Advice
		handleFeedback(qid, sfeedback, at_limit, matched); // show Feedback
		
		if(dndDragDropMode != "Practice"){
			setAttemptLimit(qid,at_limit);  // decrease attempts + update tailed text
		}
		if (!redraw && dndDragDropMode != "Practice") {
            currentQuestion.setUserResult();//send result to CRE here!
            setUserResults();
        }
		return matched;
	}

	function checkHitDND(qid, dragElement) {
		if (qid != null) {
			var questionData = getQuestionData(qid);
			var DND_IMAGE_OFFSET = questionData.getParamValue("imageOffset");
			var destinationElems =  getAllDestinations(qid);
			var matched = false;
			var destinationElem;
			for (var i = 0; i < destinationElems.length; i++) {
				destinationElem = byId(destinationElems[i]);

				if (typeof(destinationElem) != 'undefined' && destinationElem != null) {
					if (ExtractNumber(destinationElem.style.left) + DND_IMAGE_OFFSET > ExtractNumber(dragElement.style.left) &&
						ExtractNumber(destinationElem.style.left) - DND_IMAGE_OFFSET < ExtractNumber(dragElement.style.left) + ExtractNumber(dragElement.style.width) &&
						ExtractNumber(destinationElem.style.top) + DND_IMAGE_OFFSET > ExtractNumber(dragElement.style.top) &&
						ExtractNumber(destinationElem.style.top) - DND_IMAGE_OFFSET < ExtractNumber(dragElement.style.top) + ExtractNumber(dragElement.style.height)) {
						matched = true;
						break;
					}

				}
			}
			if(matched)
				return destinationElem;
		}
		return null;
	}

	function checkHitFreeDND(qid, dragElement) {
		if (qid != null) {
			var questionData = getQuestionData(qid);
			var DND_IMAGE_OFFSET = questionData.getParamValue("imageOffset");
			var destinationElem = checkHitDND(qid, dragElement);
			if (destinationElem != null) {
				//Remove this for loop and busy variable to enable dropping two images on the same destination
				var sourceElems = getAllSources(qid);
				var busy = false;
				for (var i = 0; i < sourceElems.length; i++) {
					var sourceElem = byId(sourceElems[i]);

					if (typeof(sourceElem) != 'undefined' && sourceElem != null && sourceElem.id != dragElement.id) {
						if (ExtractNumber(sourceElem.style.left) + DND_IMAGE_OFFSET > ExtractNumber(dragElement.style.left) &&
							ExtractNumber(sourceElem.style.left) - DND_IMAGE_OFFSET < ExtractNumber(dragElement.style.left) + ExtractNumber(dragElement.style.width) &&
							ExtractNumber(sourceElem.style.top) + DND_IMAGE_OFFSET > ExtractNumber(dragElement.style.top) &&
							ExtractNumber(sourceElem.style.top) - DND_IMAGE_OFFSET < ExtractNumber(dragElement.style.top) + ExtractNumber(dragElement.style.height)) {
							busy = true;
							break;
						}
					}
				}
				if (!busy)
					return destinationElem;
			}
		}
		return null;
	}

	function rearrangeAllDND(qid) {
		
		var questionData = getQuestionData(qid);
		var startPositions = questionData.getParamValue("startPositions");
		var userDndPositions = questionData.getParamValue("userPositions");
		var newDndPositions = questionData.getParamValue("newPositions");
        var sources = getAllSources(qid);
		
        for(var i=0; i<sources.length; i++) {
            var source = byId(sources[i]);
            if(source.tag == null || source.tag == "") {
                newDndPositions[i] = startPositions[i];
            }
			else {
				newDndPositions[i] = userDndPositions[i];
			}
        }
		questionData.setParam("newPositions", newDndPositions);
        questionData.setParam("snapCurrent", 0);
		
		clearInterval(questionData.getParamValue("snapTimer"));
		var snapTimer = setInterval("snapBackAll('" +qid + "','newPositions','userPositions',15)", 10);
		questionData.setParam("snapTimer", snapTimer);
    }
	
	
	function handleWebDNDActivity(qid, msg, redraw)	{
		var submitBtn = document.getElementById(qid + "_submitBtn");
		var doneBtn = document.getElementById(qid + "_doneBtn");
		var questionData = getQuestionData(qid);
		var dndMatches = questionData.getParamValue("dragMatches");
		var userDndPositions = questionData.getParamValue("userPositions");
		var dndStartPositions = questionData.getParamValue("startPositions");
		var currentQuestion = getQuestion(qid);
		var baseLeft = questionData.getParamValue("baseLeft");
		var baseTop = questionData.getParamValue("baseTop");
		var allSources = getAllSources(qid);
		
		if (questionData.getParamValue("buttonState") == "Submit") {
			checkDNDMatch(qid, redraw);
		} else if (questionData.getParamValue("buttonState") == "Reset") {
			questionData.setParam("snapCurrent", 0);
			//userDndPositions = positions set by user
			for (var i = 0; i < allSources.length; i++) {
				userDndPositions[i] = new DNDPoint();
				var sourceObj = byId(allSources[i]);
				userDndPositions[i].X = sourceObj.style.left;
				userDndPositions[i].Y = sourceObj.style.top;
			}
			questionData.setParam("userPositions", userDndPositions);
			var alreadyOnTarget = 0;
			var targetsCount = questionData.getParamValue("targetsCount");
			if (getQuestion(qid).getParamValue("leaveCorrectBetweenAttempts") == "true") {
				var i = 0;
				
				while ( i < dndMatches.length - 2) {  //do not include last dummy elem
					var dragElement = byId(dndMatches[i]);
					
					if (dragElement != null && typeof(dragElement) != 'undefined' && typeof(dragElement.tag) != 'undefined') {
						if (dragElement.tag == dndMatches[i+1] && dndMatches[i].indexOf('distractor_item') == -1) {
							alreadyOnTarget++;
						} else {
                            dragElement.tag = "";
                            //resize drag text objects
                            if(dragElement.tagName.toLowerCase() == 'div' && dragElement.id.indexOf('source_item') != -1) {
                                dragElement.style.width = "auto";
                            }
						}
					}
					i = i + 2;
				}
                rearrangeAllDND(qid);
			} else {
				restoreAllPositions(qid);
			}
			hide(qid + "_SubmitBox");
			questionData.setParam("alreadyOnTarget",alreadyOnTarget);
			questionData.setParam("lastOnTarget", false);
			hide(qid + "_IncorrectResp");
			hide(qid + "_IncorrectRespDef");
			
			// 'try again' with 'attempts' are not for instant submit
    
			jQuery("#"+qid+"_feedback_q_ir,"+"#"+qid+"_feedback_q_ir_try").css({
					"display" : "block",
					"visibility" : "hidden"
				});
			
			questionData.setParam("buttonState", "Submit");
			setButtonTitle(qid, langSubmit);
			InitDragDrop(qid);
		} else if (questionData.getParamValue("buttonState") == "ShowUser") {
			questionData.setParam("snapCurrent", 0);
			showUserAnswer(qid);
			questionData.setParam("buttonState", "ShowCorrect");
			setButtonTitle(qid, langShowSolution);
			if (doneBtn != null) {
				doneBtn.style.marginLeft = "0px";
				submitBtn.style.visibility = "visible";
				doneBtn.style.visibility = "visible";
				submitBtn.style.display = "block";
				doneBtn.style.display = "block";
				doneBtn.disabled = false;
			}
		} else if (questionData.getParamValue("buttonState") == "ShowCorrect") {
			questionData.setParam("snapCurrent", 0);
			var destinations = getAllDestinations(qid);
			//dndStartPositions = correct answers
			for (var i = 0; i < destinations.length; i++) {
				var destinationObj = byId(destinations[i]);
				if(destinationObj != null) {
					dndStartPositions[i] = new DNDPoint();
					dndStartPositions[i].X = destinationObj.style.left;
					dndStartPositions[i].Y = destinationObj.style.top;
					questionData.setParam("startPositions", dndStartPositions);
				}
			}
			
			//retrieve array and add distractors 
			dndStartPositions = questionData.getParamValue("startPositions");
			
			for(var i=0; i<allSources.length; i++) {
				if(allSources[i].indexOf('distractor_item') >= 0) {
					if (!dndStartPositions[i]) {
						dndStartPositions[i] = new DNDPoint();
					}
					dndStartPositions[i].X = (baseLeft + ExtractNumber(byId(allSources[i]).getAttribute("nativeLeft"))) + "px";
					dndStartPositions[i].Y = (baseTop + ExtractNumber(byId(allSources[i]).getAttribute("nativeTop"))) + "px";
				}
			}
			questionData.setParam("startPositions", dndStartPositions);
									
			restoreAllPositions(qid);
			questionData.setParam("buttonState", "ShowUser");
			setButtonTitle(qid, langUserAnswer);
			if (doneBtn != null) {
				doneBtn.style.marginLeft = "0px";
				submitBtn.style.visibility = "visible";
				doneBtn.style.visibility = "visible";
				submitBtn.style.display = "block";
				doneBtn.style.display = "block";
				doneBtn.disabled = false;
			}
		}
	}
	

function DNDQuestion() {
    this.redraw = function () {
			var questionData = getQuestionData(this.guid);
			
			if (!questionData.getParamValue("arranged")) {
				setTimeout ("getQuestion('"+this.guid+"').redraw()", 500);
				return;
			}
			
			var dndDragDropMode = questionData.getParamValue("dragDropMode");
			
			if (dndDragDropMode == "Practice")
				return;
			//redraw the attempts left (as it goes from XSLT so the number is incorrect)
			var at = document.getElementById(this.guid + "_at_limit"); // change text node informing of remaining attempts
			if (this.attempts == 1) at.firstChild.nodeValue = " " + this.attempts + " " + langAttemptRemaining + ". ";
			else  at.firstChild.nodeValue = " " + this.attempts + " " + langAttemptsRemaining + ". ";
				
			if (this.attempts <= 0 || this.result == "correct") {
				//evaluate question
				//if question is done, add +1 attempt and call handleWebDNDActivity 
				//  to render the question result. Attempts are decreased in this function by 1   
				//if question is not done yet (there are some spare attempts)
				//  show the clear checkboxes, right attempts 
				//  ommitted (AND all hints which were shown before)
				
				var answs = this.userAnswer.split("|");

				for(var i=0; i<answs.length; i++) {
					var ans = answs[i].split(":");
					var source = byId(ans[0]);
					var dest = byId(ans[1]);

					if(source != null && dest != null && typeof(dest) != "undefined") {
						source.tag = ans[1];  
						source.style.left = dest.style.left;
						source.style.top = dest.style.top;
					}
				}	
				
            
                this.attempts = this.attempts + 1; //increase attempts as handleWebDNDActivity 
                                                   //will decrease it back when evaluating		
				removeEvent(byId("WebDragDrop_" + this.guid), 'mousedown', dndOnMouseDown);
				show(this.guid + "_SubmitBox");
				
				handleWebDNDActivity(this.guid,"",true);
            }
		}
}
	
DNDQuestion.prototype = new Question;
	
	function addDNDQuestion(question) {
		dndquestions[dndquestions.length] = question;
		addQuestion(question);
	}

	
function setDNDQuestions() {
    var isAssessment = false;
    for (l=0; l<document.forms.length; l++) {
        var fname = document.forms[l].name;     
        if (fname.toLowerCase().indexOf("questionform") == -1) continue;
        var fid = document.forms[l].id;
        if (fid.toLowerCase().indexOf("webdragdrop") == -1) continue;

        var wab_id = fname.substr(13);
        var wab_obj = document.getElementById("wab_"+wab_id);
        var newDNDQuestion = new DNDQuestion();
		
        newDNDQuestion.setParam("guid", wab_id);

        newDNDQuestion.setParam("mode", 
                wab_obj.getAttribute("wab_Mode"));
		if(wab_obj.getAttribute("wab_Mode") == "Assessment")
			isAssessment = true;
        newDNDQuestion.setParam("attempts", 
                wab_obj.getAttribute("wab_AttemptLimit"));      
        newDNDQuestion.setParam("showHint", 
                wab_obj.getAttribute("wab_ShowHint"));  
        newDNDQuestion.setParam("overlayFeedback", 
                wab_obj.getAttribute("wab_OverlayFeedback"));      
        newDNDQuestion.setParam("hintActive", 
                wab_obj.getAttribute("wab_hint_active"));       
        newDNDQuestion.setParam("showSolution", 
                wab_obj.getAttribute("wab_ShowSolution"));
        newDNDQuestion.setParam("rollupWeight", 
                wab_obj.getAttribute("wab_RollupWeight"));
	newDNDQuestion.setParam("leaveCorrectBetweenAttempts", 
		wab_obj.getAttribute("wab_LeaveCorrectBetweenAttempts"));	

        addDNDQuestion(newDNDQuestion);
		
		if( wab_obj.getAttribute("wab_Mode") == "Assessment"){
			isAssessment = true;
		}
    }
}
	
function initDNDPage() {   
    setDNDQuestions();
    getUserResults(dndquestions);
}	

// keyboard accessebility for drag & drop activity
jQuery(document).ready(function(){
	var dragDropObjectsLinks = jQuery("a[name='DragDropObject']");
	var dragDropTargetsLinks = jQuery("a[name='DragDropTarget']");
	var selectedDragDropObject;
	var previousObject = null;

	dragDropObjectsLinks.each(function() {
			var currentLinkElem = jQuery(this);
			var dragDropObject = currentLinkElem.next();
			var qid = this.id.substr(0, this.id.indexOf("_object"));
			var currentQuestion = getQuestion(qid);
			var questionData = getQuestionData(qid);
			var currentTabIndex = currentLinkElem.attr("tabindex");	
			var dndStartPositions = questionData.getParamValue("startPositions");
			
			currentLinkElem.focus(function() {		
					dragDropObject.css("border", questionData.getParamValue("highlightDropAreaBorder"));	
				})
			.blur(function() {
					dragDropObject.css("border", "none");				
				})
			.keydown(function(event) {
		
				//space or enter was pressed
				if (event.keyCode == 32 || event.keyCode == 13) {
					selectedDragDropObject = dragDropObject;
					
					dragDropObjectsLinks.attr("tabindex", "-1");
					dragDropTargetsLinks.attr("tabindex", "0");
					
					//Save start positions
					if (dndStartPositions.length == 0) {
						var sources = getAllSources(qid);
						
						for (var i = 0; i < sources.length; i++) {
							var sourceObj = byId(sources[i]);
							
							if(sourceObj != null) {
								dndStartPositions[i] = new DNDPoint();				
								dndStartPositions[i].X = sourceObj.style.left;
								dndStartPositions[i].Y = sourceObj.style.top;
								questionData.setParam("startPositions", dndStartPositions);	
							}
						}
					}	
		
					//switch focus
					jQuery(this).blur();
					jQuery("a[id*='"+qid+"'][name='DragDropTarget']").eq(0).focus();
					
					return false;
				}
			});		
		});
		
		dragDropTargetsLinks.each(function() {
			var currentLinkElem = jQuery(this);
			var dragDropTarget = currentLinkElem.next();
			var qid = this.id.substr(0, this.id.indexOf("_target"));
			var currentQuestion = getQuestion(qid);
			var questionData = getQuestionData(qid);
			
			currentLinkElem.attr("tabindex", "-1");
			
			currentLinkElem.focus(function() {
					dragDropTarget.removeClass("dndunhighlighted").addClass("dndhighlighted");

					dragDropTarget.css({
							"border" : questionData.getParamValue("highlightDropAreaBorder"),
							"width" : currentLinkElem.prev().width()+"px",
							"height" : currentLinkElem.prev().height()+"px"
						});
				})
			.blur(function() {
					dragDropTarget.removeClass("dndhighlighted").addClass("dndunhighlighted");	

					dragDropTarget.css({
							"border" : "none",
							"width" : "1px",
							"height" : "1px"
						});
				})			
			.keydown(function(event) {
				//space or enter was pressed
				if (event.keyCode == 32 || event.keyCode == 13) {
					var targetX = dragDropTarget.css("left");
					var targetY = dragDropTarget.css("top");
					
					selectedDragDropObject[0].tag = dragDropTarget.attr("id");
					
					if (previousObject != selectedDragDropObject) {	
						questionData.setParam("alreadyOnTarget", questionData.getParamValue("alreadyOnTarget") + 1);						
					} 
					previousObject = selectedDragDropObject;
						
					selectedDragDropObject.animate({
						"left" : targetX,
						"top" : targetY
						}, 500);
						
					if (questionData.getParamValue("alreadyOnTarget") == questionData.getParamValue("targetsCount")) {	
						show(qid + "_SubmitBox");
						removeEvent(byId("WebDragDrop_" + qid), 'mousedown', dndOnMouseDown);
						removeEvent(byId("WebDragDrop_" + qid), 'mouseup', dndOnMouseUp);
					}
				
					dragDropTargetsLinks.attr("tabindex", "-1");
					dragDropObjectsLinks.attr("tabindex", "0");
					
					//switch focus
					jQuery(this).blur();
					jQuery("a[id*='"+qid+"'][name='DragDropObject']").eq(0).focus();
					
					return false;
				}
			});
		});
	});