/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

// --------------------------------------------------
// JS functions for MediaObject
// --------------------------------------------------
//
// open_popup_window()
// close_popup_window()
// resize_popup_window()
// autofit_iframe()
//

var popopen = false; //global flag for opened popup window
var pop_window;

// --- open popup window ----
// url = media url to open, codeBase = path to js code for newly opened window, 
// mimeType = 'our' mimetype defined in transformation
// height, width = height and width defined in source xml data if available
function open_pop_window(url, codeBase, mimeType, height, width, func) {

    var x = screen.width/2-100;
    var y = screen.height/2-100;

    if (parseInt(navigator.appVersion.charAt(0))>=4) {
        var nn = (navigator.appName=="Netscape")?1:0;
        var ie = (navigator.appName.indexOf("Microsoft")!=-1)?1:0;
    }
    var winHeight = height != ""?height:200;
    var winWidth = width != ""?width:200;
    var features = "toolbar=no,status=no,scrollbars=yes,dependent=no,resizable=yes,modal=no,left="+x+",top="+y;
    if (ie) features += ",width="+winWidth+",height="+winHeight; // for IE
    if (nn) features += ",innerWidth="+winWidth+",innerHeight="+winHeight; // for Netscape, Mozilla

    if (!popopen || pop_window.closed) { 
        popopen = true;
        pop_window = window.open("about:blank","pop_window",features);
    }

    with (pop_window.document){
        open();     //Call open() to clean the document for new writing...
        writeln("<html>");
        writeln("<head>");
        writeln("<title>Pop-up media</title>");
        writeln("<script type='text/javascript'>this.resize_pop_window=this.opener.resize_pop_window;</script>");
		//writeln("<script src='Core/Transforms/code/wz_jsgraphics.js' type='text/javascript'></script>"); fixing for IE https://issues.xyleme.com/browse/CP-6193
        //writeln("<script src='Core/Transforms/code/MediaObject.js' type='text/javascript'></script>"); fixing http://studio.xyleme.com:43434/browse/CP-1755
        writeln("</head>");
    }
    switch (mimeType) {
        case "image":
            var heightParam = height != "" ?" height='"+height+"'" : "";
            var widthParam = width != "" ?" width='"+width+"'" : "";
                with (pop_window.document) {
				    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"image")'+";'>");
					writeln("<div id='pop' style='position:relative; text-align:left; width:auto;'>");
					writeln("<script type='text/javascript'>");
					writeln("function runDrawOverlays(drawOver){")
					writeln("if(window.opener." + func + "!= null)");
					writeln("window.opener." + func + "(document.getElementById('pop'));}");
					writeln("</script>");
					writeln("<img id='pop_obj' src='" + url + "'"+ heightParam +" "+ widthParam +" onload='runDrawOverlays();'/>");
					writeln("</div>");
                }
                break;
        case "flash":
            var heightParam = " height='"+height+"'";
            var widthParam = " width='"+width+"'";
            var base = "";
            var shortUrl = "";
            if ((url.substr(0,5) == "http:") || (url.substr(0,6) == "https:")) {
                base = url.substring(0, url.lastIndexOf("/"));
                shortUrl = url.substr(url.lastIndexOf("/")+1)
            }
                with (pop_window.document) {
                    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"flash")'+";'>");
                    writeln("<object id='pop_obj' classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' ");
                    write("type='application/x-shockwave-flash'"+heightParam+" "+widthParam+"'>");
                    writeln("<param name='movie' value='" + url + "'>");
                    writeln("<param name='loop' value='false'>");
                    writeln("<param name='base' value='" + base + "'>");
                    writeln("<embed src='" + url + "' name='movie' loop='false' type='application/x-shockwave-flash' base='" + base + "'" + heightParam + " " + widthParam + ">");
                    writeln("</object>");
                }
                break;
        case ("audio"):
            var heightParam = " height='"+height+"'";
            var widthParam = " width='"+width+"'";
                with (pop_window.document) {
                    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"audio")'+";'>");
                    writeln("<object id='pop_obj' type='audio'"+heightParam+" "+widthParam+"'>");
                    writeln("<param name='audio' value='" + url + "'>");
                    writeln("<embed src='" + url + "' name='audio' type='audio' autostart='true'");
                    write(heightParam+" "+widthParam+"'>");
                    writeln("</object>");
                }
                break;
        case ("realaudio"):
            var heightParam = " height='"+height+"'";
            var widthParam = " width='"+width+"'";
                with (pop_window.document) {
                    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"realaudio")'+";'>");
                    writeln("<object id='pop_obj' type='audio/x-pn-realaudio-plugin'"+heightParam+" "+widthParam+"'>");
                    writeln("<param name='audio/x-pn-realaudio-plugin' value='" + url + "'>");
                    writeln("<embed src='" + url + "' name='audio/x-pn-realaudio-plugin'");
                    write("type='audio/x-pn-realaudio-plugin' autostart='true' controls='ControlPanel,StatusBar'");
                    write(heightParam+" "+widthParam+"'>");
                    writeln("</object>");
                }
                break;
        case "html":
                with (pop_window.document) {
                    writeln("<body style='overflow:visible; border:none; margin:8px;' " + "onload='resize_pop_window(this,"+'"html")'+";'>");
                    writeln("<iframe id='pop_obj' name='pop_obj' scrolling='yes' frameborder='0' src='" + url + "' height='100%' width='100%'/>");
                }
                break;
        case ("anarkmedia"):
            var heightParam = " height='"+height+"'";
            var widthParam = " width='"+width+"'";
                with (pop_window.document) {
                    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"anarkmedia")'+";'>");
                    writeln("<object id='pop_obj' classid='CLSID:131EB16C-BD58-443f-8151-6DFBB0DA1778' type='application/x-am'"+heightParam+" "+widthParam+"'>");
                    writeln("<param name='src' value='" + url + "'/>");
                    writeln("<param name='BackgroundColor' value='black'/>");
                    writeln("<embed src='" + url + "' name='player'");
                    write("type='application/x-am' autostart='true' controls='ControlPanel,StatusBar'");
                    write("backgroundcolor='#000000' bordercolor='#000000' scalemode='Exact'");
                    write("presentationWidth='" + width + "' presentationHeight='" + height + "'> ");
                    write("</embed>");
                    writeln("</object>");
                }
                break;
        case ("quicktime"):
            var heightParam = " height='"+height+"'";
            var widthParam = " width='"+width+"'";
                with (pop_window.document) {
                    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"quicktime")'+";'>");
                    writeln("<object id='pop_obj' classid='clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B' codebase='http://www.apple.com/qtactivex/qtplugin.cab' type='video/quicktime'"+heightParam+" "+widthParam+"'>");
                    writeln("<param name='src' value='" + url + "'/>");
                    writeln("<param name='autoplay' value='true'/>");
                    writeln("<param name='scale' value='1'/>");
                    writeln("<embed src='" + url + "' name='player' ");
                    write(heightParam + " " + widthParam + " ");
                    write("type='video/quicktime' autoplay='true' scale='1' ");
                    write("pluginspage='http://www.apple.com/quicktime/download'> ");
                    write("</embed>");
                    writeln("</object>");
                }
                break;
		case ("mediaplayer"):
            var heightParam = " height='"+height+"'";
            var widthParam = " width='"+width+"'";
                with (pop_window.document) {
                    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"mediaplayer")'+";'>");
                    writeln("<object TYPE='application/x-oleobject' STANDBY='Loading Microsoft Windows Media Player components...' " + heightParam + " " + widthParam + " CODEBASE='http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701' CLASSID='CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95' ID='mediaPlayer'>");
                    writeln("<param name='fileName' value='" + url + "'/>");
                    writeln("<param name='animationatStart' value='true'> </param>");
                    writeln("<param name='transparentatStart' value='true'> </param>");
                    writeln("<param name='showControls' value='true'>  </param>");
                    writeln("<embed src='" + url + "' name='player' ");
                    write(heightParam + " " + widthParam + " ");
                    write("type='application/x-mplayer2' pluginspage = 'http://www.microsoft.com/Windows/MediaPlayer/' AutoStart='true'>");
                    write("</embed>");
                    writeln("</object>");
                }
                break;
		case ("flvplayer"):
            var heightParam = " height='"+height+"'";
            var widthParam = " width='"+width+"'";
			var sourcefile = codebase + "FLVplayer.swf?theFile=" + url + "&theVolume=100&startPlayingOnload=yes&popUpHelp=no&controllocation=&bufferSeconds=2&videoSmoothing=yes";
                with (pop_window.document) {
                    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"mediaplayer")'+";'>");
                    writeln("<object ID='mediaPlayer' classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' codebase='http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0'" + heightParam + " " + widthParam + ">");
                    writeln("<param name='base' value='" + codebase + "'/>");
                    writeln("<param name='movie' value='" + sourcefile + "'/>");
                    writeln("<param name='bgcolor' value='#000000'/>");
                    writeln("<param name='quality' value='high'/>");
                    writeln("<embed base='" + codebase + "' src='" + sourcefile + "' movie='" + sourcefile + "' quality='high' name='FLVPlayer' bgcolor='0' type='application/x-shockwave-flash' pluginspage='http://www.macromedia.com/go/getflashplayer' ");
                    write(heightParam + " " + widthParam + ">");
                    write("</embed>");
                    writeln("</object>");
                }
                break;
        case "svg":
            var heightParam = height != "" ?" height='"+height+"'" : "";
            var widthParam = width != "" ?" width='"+width+"'" : "";
                with (pop_window.document) {
                    writeln("<body style='margin: 10px;' onload='resize_pop_window(this,"+'"image")'+";'>");
                    writeln("<embed id='pop_obj' src='" + url + "'"+ heightParam +" "+ widthParam +" type='image/svg+xml'/>");
                }
                break;
    }
    with (pop_window.document) {
        writeln("</body>");
        writeln("</html>");
        close();                
    }
    pop_window.focus();
	return pop_window;
}


// ----------------------------
function close_pop_window() {
    pop_window.close();
    popopen = false;
}

// ----------------------------
function resize_pop_window(pop_window,mimeType) {

    if (parseInt(navigator.appVersion.charAt(0))>=4) { //test for browser
        var nn = (navigator.appName=="Netscape")?1:0;
        var ie = (navigator.appName.indexOf("Microsoft")!=-1)?1:0;
    }

    if (mimeType == 'image' || mimeType=='flash' || mimeType=='audio' || mimeType=='realaudio' || mimeType=='anarkmedia' || mimeType=='quicktime') {

        var pop_obj = pop_window.document.getElementById("pop_obj");
        var dif_width = (nn)?pop_window.innerWidth:pop_window.document.body.clientWidth; //get inner width and height of pop_window
        var dif_height = (nn)?pop_window.innerHeight:pop_window.document.body.clientHeight;
        dif_width -= 30; // 10px margins around the image + experimentaly found value to fit
        dif_height -= 37;
        var fixed = false; // if set to true, pop_window set to fixed size

        if (pop_obj.width > screen.availWidth-100) { //image width is over screen size
            dif_width = 0.75*screen.availWidth;  //set fixed pop_window size
            fixed = true;
        }
        else dif_width = pop_obj.width - dif_width; //count difference between pop_window actual width and image width

        if (pop_obj.height > screen.availHeight-100) { //image height is over screen size
            dif_height = 0.75*screen.availHeight; //set fixed pop_window size
            fixed = true;
        }
        else dif_height = pop_obj.height - dif_height; //count difference between pop_window actual height and image height

        if (fixed) {
            pop_window.resizeTo(dif_width, dif_height); //resize to fixed size - for big images
            pop_window.moveTo((screen.width - dif_width)/2,(screen.height - dif_height)/2); //center pop_window on screen
        }
        else {
            pop_window.resizeBy(dif_width, dif_height); //resize pop_window to fit the image
            pop_window.moveTo((screen.width - pop_obj.width)/2,(screen.height - pop_obj.height)/2); //center pop_window on screen
        }
    }
    else {
            if (mimeType == 'html') { pop_window.resizeTo((screen.width - 200),(screen.height - 200));} //
            pop_window.moveTo(100,100); //center pop_window on screen
    }
}



// ----------------------------
function autofit_iframe(id) {
    //   if ((!window.opera) && (!document.mimeType) && (document.all) && (document.getElementById)) {
    //       document.getElementById(id).style.height = window.frames[id].document.body.offsetHeight + "px";
    //   }
    //   else if (document.getElementById) {

    if (document.getElementById) {
        if (window.frames[id].frames['main'] != null) {
            var scrollHInn = window.frames[id].frames['main'].document.body.scrollHeight + 15;
            var scrollHOut = scrollHInn + 15;
            var scrollWInn = window.frames[id].frames['main'].document.body.scrollWidth + 15;
            var scrollWOut = scrollWInn + 15;
            //alert('scrollWOut: '+scrollWOut);
            //outer frame (iframe embed_html_page from MediaObject)
            document.getElementById(id).style.height = scrollHOut + "px";
            document.getElementById(id).style.width = scrollWOut + "px"; //"100%"; 
            //inner frame (from customer's html page)
            var fr_main = window.frames[id].document.getElementsByTagName('frame')['main']; 
            fr_main.scrolling = 'no';
            fr_main.frameborder = '0';
            window.frames[id].document.getElementsByName('main')[0].style.height = scrollHInn + "px";
            window.frames[id].document.getElementsByName('main')[0].style.width = scrollWInn + "px"; //"100%";
            //fr_main.style.height = window.frames[id].frames['main'].document.body.scrollHeight + 15 + "px";
            var onl = window.frames[id].frames['main'].document.body.onload;
            window.frames[id].frames['main'].document.body.onload = onl + ";autofit_iframe('embed_html_page');";
        }
        else {
            document.getElementById(id).style.width = "100%"; 
            document.getElementById(id).style.height = window.frames[id].document.body.scrollHeight + 15 + "px";
        }
   }
}

// call-back function for re-arrange objects e.g. set relative left and top offset
function updateObjectPosition(baseElementID, relativeElementID) {
	var baseElement = document.getElementById(baseElementID);
	var relativeElement = document.getElementById(relativeElementID);
	
	if (typeof(baseElement) != "undefined" && typeof(relativeElement) != "undefined") {
		var baseLeft = baseElement.offsetLeft;
		var baseTop = baseElement.offsetTop;
		
		//set objects relative position
		if (relativeElement!= null && typeof(relativeElement) != 'undefined') {
			relativeElement.style.left = baseLeft + extractNumber(relativeElement.style.left) + "px";
			relativeElement.style.top = baseTop + extractNumber(relativeElement.style.top) + "px";
		}
	}
}

function extractNumber(value)
{
	var n = parseInt(value);		
	return n == null || isNaN(n) ? 0 : n;
}

function getURLParam(strParamName) {
  var strReturn = "";
  var strHref = window.location.href;
  if ( strHref.indexOf("&") > -1 ) {
    var strQueryString = strHref.substr(strHref.indexOf("&"));
    var aQueryString = strQueryString.split("&");
    for ( var iParam = 0; iParam < aQueryString.length; iParam++ ) {
      if (aQueryString[iParam].indexOf(strParamName + "=") > -1 ) {
        var aParam = aQueryString[iParam].split("=");
        strReturn = aParam[1];
        break;
      }
    }
  }
  return strReturn;
}


//flash's accessibility 
var previousFlashFocuser = null;

jQuery(document).ready(function(){	
	jQuery("a[name='mediaPlayerFocuser']").focus(function(){
			previousFlashFocuser = this;
			if(isIE) {
				jQuery(this).next()[0].focus();
			} else {
				jQuery(this).next().find("embed")[0].focus();
			}
		});	
	});
	
/**
* to force flash get rid of focus
* @direction previous or following 
*/
function blurFlash(direction){
	if (previousFlashFocuser) {
		if (direction == "prev") {
			jQuery(previousFlashFocuser).prevALL("a,input,textarea").eq(0).focus();
		} else if (direction == "next") {
			jQuery(previousFlashFocuser).nextALL("a,input,textarea").eq(0).focus();
		}
	}
}