/*

Copyright c 2013 Xyleme, Inc., 1881 9th Street, Suite 300, Boulder, Colorado 80302 USA.
All rights reserved.

This file and related documentation are protected by copyright and
are distributed under licenses regarding their use, copying, distribution,
and decompilation. No part of this product or related documentation may
be reproduced or transmitted in any form or by any means, electronic or
mechanical, for any purpose, without the express written permission of
Xyleme, Inc.

*/

/*
	Initializing card slider, events
*/
var actveCardNumber = 0;
var alreadyInitedCards = new Array();
var cardsCompletionValues = new Array();
var slideCounter = 1;
var allCards = 0;
var actveCardNumber = 0;
var isCardsBeCompleted = false;

function initSlidingCards(id, numberOfCards){
	var elems = getElementsByName("div","CardBack");
	var reviewMode = "learn";

	// Declaring increment vars
	var totIncrement = 0;
	var increment = 685;
	var maxRightIncrement = increment*(-(numberOfCards-1));
		// Hide all inputs and submit buttons
		for(var i=0;i<numberOfCards;i++){
		var	cardId = "CardSubmitBlock_"+ i;
			var	elems = document.getElementById(cardId);
				elems.style.display = "none";
				elems.style.visibility = "hidden";
			}
	
		// Previous Button		
		jQuery("#PreviousCard_" + id).click( function(){
				if(totIncrement < 0){
					totIncrement = totIncrement + increment;
					hideAnswerCards(id, reviewMode);
					jQuery(".CardsSliderList").animate({"margin-left": totIncrement}, 1500, "easeOutQuart");
					//jQuery(".CardsSliderList").effect("bounce", { direction:'right', times:5 }, 300);
					actveCardNumber--;
					hideControls(id, totIncrement, maxRightIncrement);
					setTimeout("showAnswerCards('"+id+"','"+reviewMode+"')",10);
				}
				if(slideCounter > 1 && slideCounter < numberOfCards)
				{
					slideCounter = slideCounter - 1;
				}
		});

		// Next Button
		jQuery("#NextCard_" + id).click( function(){
				if(totIncrement > maxRightIncrement){
					totIncrement = totIncrement - increment;
					hideAnswerCards(id, reviewMode);
					jQuery(".CardsSliderList").animate({"margin-left": totIncrement}, 1500, "easeOutQuart");
					//jQuery(".CardsSliderList").effect("bounce", { direction:'right', times:5 }, 300);
					actveCardNumber++;
					hideControls(id, totIncrement, maxRightIncrement);
					setTimeout("showAnswerCards('"+id+"','"+reviewMode+"')",10);
				}
				if(slideCounter < numberOfCards)
				{
					slideCounter = slideCounter + 1;
				}
		});
		
		//Flip Button
		jQuery("#FlipCard_" + id).click( function(){
				jQuery("#FlipCard_" + id).css("zIndex", "-1");
				hideControls(id, totIncrement, maxRightIncrement);
				showAnswerCards(id, "flipClicked");
		});
		
		//Choose Mode Button
		jQuery("#ChangeMode_" + id).click( function(){
				jQuery("#FlashContentCover_" + id).css("visibility", "visible");
				hideAnswerCards(id, reviewMode);
			
		});
		
		//LearnMode Button
		jQuery("#LearnMode_" + id).click( function(){
				if (reviewMode != "learn"){
					totIncrement = 0;
					openFirstCard(id, reviewMode);
				}
				reviewMode = "learn";
				jQuery("#FlipCard_" + id).css("display", "none");			
				elems = getElementsByName("div","CardCorrectAnswerBlock");
				for (var i = 0; i<elems.length; i++ ){
					elems[i].style.display = "block";
				}
				hideControls(id, totIncrement, maxRightIncrement);
				showAnswerCards(id, reviewMode);
				jQuery("#FlashContentCover_" + id).css("visibility", "hidden");
		});
		
		//PracticeMode Button
		jQuery("#PracticeMode_" + id).click( function(){
				if (reviewMode != "practice"){
					totIncrement = 0;
					openFirstCard(id, reviewMode);
				}
				reviewMode = "practice";	
				jQuery("#FlipCard_" + id).css("display", "block");
				elems = getElementsByName("div","CardCorrectAnswerBlock");
				for (var i = 0; i<elems.length; i++ ){
					elems[i].style.display = "block";
				}
				hideControls(id, totIncrement, maxRightIncrement);
				hideAnswerCards(id, reviewMode);
				jQuery("#FlipCard_" + id).css("zIndex", "0");
				jQuery("#FlashContentCover_" + id).css("visibility", "hidden");
		});
		
		//TestMode Button
		jQuery("#TestMode_" + id).click( function(){
				if (reviewMode != "test"){
					totIncrement = 0;
					openFirstCard(id, reviewMode);
				}
				reviewMode = "test";
				hideControls(id, totIncrement, maxRightIncrement);
				showAnswerCards(id, reviewMode);
				//show up needed card element
				jQuery("#FlipCard_" + id).css("display", "none");				
				elems = getElementsByName("div","CardCorrectAnswerBlock");
				for (var i = 0; i<elems.length; i++ ){
					elems[i].style.display = "none";
				}
				jQuery("#FlashContentCover_" + id).css("visibility", "hidden");
		});

		// onEnter event input element
		jQuery('input[type=text][id*=Answer]').keyup(function(e) {
				if (e.keyCode == 13) {
					jQuery(this).siblings('input[type=button][id*=Submit]').click();
				} else {
					if (jQuery(this).val() == '') {
						jQuery(this)
						.siblings('.CorrResponse').css("visibility", "hidden")
						.end()
						.siblings('.IncorrResponse').css("visibility", "hidden");
					}
				}
		});

		hideControls(id, totIncrement, maxRightIncrement);
		setTimeout("showAnswerCards('"+id+"','"+reviewMode+"')", 10);
		allCards = numberOfCards;
}

/*
* shows cards and other stuff depending on review mode
*/
function showAnswerCards(id, reviewMode){	
	
	switch (reviewMode) {
		case 'learn' :
			// for learn mode 
			var elems = getElementsByName("td","CardBack");
			for (var i = 0; i<elems.length; i++ ){
				elems[i].style.visibility = "visible";
			}
			
			jQuery("#CardsNavigationButtons_" + id).css("visibility", "visible");
		break
		case 'flipClicked' :
			// for practice mode when flipis clicked
			var elems = getElementsByName("td","CardBack");
			for (var i = 0; i<elems.length; i++ ){
				elems[i].style.visibility = "visible";
			}
			jQuery("#CardsNavigationButtons_" + id).css("visibility", "visible");
		break
		
		case 'practice' :
			// for practice mode 
			jQuery("#FlipCard_" + id).css("zIndex", "0");
		break
		case 'test' :
			var elems = getElementsByName("td","CardBack");
			for (var i = 0; i<elems.length; i++ ){
				elems[i].style.visibility = "visible";
			}
			// in test mode show card elements after sliding
			if (reviewMode == "test") {			    
			    var cardId = "CardSubmitBlock_"+actveCardNumber;				
				elems = document.getElementById(cardId);
				elems.style.display = "block";
				elems.style.visibility = "visible";				
			}
			jQuery("#CardsNavigationButtons_" + id).css("visibility", "visible");
		break
	}

}

/*
* hides cards and other stuff depending on review mode
*/
function hideAnswerCards(id, reviewMode){
	//hide for all modes
	jQuery("#CardsNavigationButtons_" + id).css("visibility", "hidden");
	
	switch (reviewMode) {
		case 'learn' :
			// for learn mode 
		break
		case 'practice' :
			// for practice mode 
			jQuery("#FlipCard_" + id).css("zIndex", "-1");
		break
		case 'test' :
			// in test mode hide card elements before sliding
			if (reviewMode == "test") {
				var cardId = "CardSubmitBlock_"+actveCardNumber;				
				elems = document.getElementById(cardId);
				elems.style.display = "none";
				elems.style.visibility = "hidden";				
			}
		break
	}
	
	var elems = getElementsByName("td","CardBack");
	for (var i = 0; i<elems.length; i++ ){
		elems[i].style.visibility = "hidden";
	}
	
}

function checkCardAnswer(id){
	var correct_answer = jQuery("#CorrectAnswer_" + id).val(),
		user_answer = jQuery("#CardAnswer_" + id).val(),
		correct = false;


	// Very sensitive. Do not touch.. ever!
	
	/* start */
	var old_browser = isIE7 || document.documentMode < 8;
	// Text Matches
	if (correct_answer[0] == '{' || correct_answer.indexOf('{') == 0) {

		var Separator = ',';

		try{

			/*-- PARSE CORRECT ANSWER --*/

			//parse parent object - "Text Matches"
			if (!old_browser){
				correct_answer = JSON.parse(correct_answer);	
			} else {
				correct_answer = jQuery.parseJSON(correct_answer);	
			}
			
			
			// redesign child objects to make them possible to parse
			correct_answer.Matches = correct_answer.Matches
			.split('`').join('"')
			.split('~[~').join('{')
			.split('~]~').join('}')
			.split('},]').join('}]')
			.split('}{').join('}|||{').split('|||');
			
			// parse child objects
			for (var i=0, n = correct_answer.Matches.length; i < n; i++) {
				if (!old_browser) {
					correct_answer.Matches[i] = JSON.parse(correct_answer.Matches[i]);	
					correct_answer.Matches[i].patterns = JSON.parse(correct_answer.Matches[i].patterns.split('^').join('"'));
				} else {
					correct_answer.Matches[i] = jQuery.parseJSON(correct_answer.Matches[i]);	
					correct_answer.Matches[i].patterns = jQuery.parseJSON(correct_answer.Matches[i].patterns.split('^').join('"'));
				}
				
				//remove empty patterns
				for (var j in correct_answer.Matches[i].patterns) {
					if (correct_answer.Matches[i].patterns[j].text == '') {
						correct_answer.Matches[i].patterns.splice(j,1);
					}
				}
			}

			//console.log(correct_answer);

			/*-- PARSE USER ANSWER --*/

			if (user_answer.indexOf(Separator) != -1) {
				user_answer = user_answer.split(',');
				//remove empty entry
				for (var j in user_answer) {
					if (user_answer[j] == '') {
						user_answer[j].splice(j,1);
					}
				}
				// remove unneded spaces(at start/end of the word)
				for (var i in user_answer) {
					user_answer[i] = jQuery.trim(user_answer[i])
				}


				// checking correctness
				var match_correct = correct_answer.atLeast,
					match_made    = 0;

					for (var i in correct_answer.Matches){
						var _this = correct_answer.Matches[i],
							pat_correct = _this.atLeast,
							pat_made    = 0;

						for (var i in _this.patterns) {
							for (var j in user_answer) {
								var _pattern = _this.patterns[i].text,
									_answer  = user_answer[j];

								normalizeWords();

								if (_pattern == _answer) {
									pat_made++;
									break;
								}
							}
						}

						if (pat_made >= pat_correct) {
							match_made++;
						}

					}

					correct = match_made >= match_correct;

			} else {
				if (correct_answer.atLeast == 1) {
					user_answer = jQuery.trim(user_answer)
					for (var i in correct_answer.Matches) {
						var _this = correct_answer.Matches[i];
						if (_this.atLeast == 1) {
							for (var j in _this.patterns) {
								var _pattern = _this.patterns[j].text,
									_answer  = user_answer;

								normalizeWords();

								if (_pattern == _answer) {
									correct = true;
									break;
								}
							}
						}
						if (correct) break;
					}
				}
			}
			
		} catch(err) {
			console.warn('sorry, error occured');
			console.log(err);
		}
	// Rich Text
	} else {
		correct = user_answer == correct_answer;
	}
	/* end */
	

	if (correct) {
		jQuery("#CardCorrectFeedback_" + id).css({"visibility": "visible", "display": "block"});
		jQuery("#CardIncorrectFeedback_" + id).css({"visibility": "hidden", "display": "none"});
	} else {
		jQuery("#CardCorrectFeedback_" + id).css({"visibility": "hidden", "display": "none"});
		jQuery("#CardIncorrectFeedback_" + id).css({"visibility": "visible", "display": "block"});
	}

	// helper functions

	function normalizeWords(){
		if (_this.patterns[i].ignoreSpaces == 'true') { 
			_pattern = ignoreSpaces(_pattern);
			_answer  = ignoreSpaces(_answer); 
		}
		if (_this.patterns[i].ignoreCase == 'true') {
			_pattern = ignoreCase(_pattern);
			_answer  = ignoreCase(_answer); 		
		}
		if (_this.patterns[i].ignoreExtraWords == 'true') {
			_pattern = ignoreExtraWords(_pattern);
			_answer  = ignoreExtraWords(_answer); 		
		}
		if (_this.patterns[i].ignoreHyphensAndMinus == 'true') {
			_pattern = ignoreHyphensAndMinus(_pattern);
			_answer  = ignoreHyphensAndMinus(_answer); 		
		}
	}
	
	function ignoreSpaces(s) {
		if (s.indexOf(' ') != -1) {
			return s.split(' ').join('');
		} else {
			return s;
		}
	}
	function ignoreCase(s) {
		return s.toLowerCase();
	}
	function ignoreExtraWords(s) {
		if (s.indexOf(' ') != -1) {
			return s.substr(0, s.indexOf(' '));	
		} else {
			return s;
		}
	}
	function ignoreHyphensAndMinus(s) {
		if (s.indexOf('-') != -1) {
			return	s.split('-').join('');
		} else {
			return s;
		}
	}
}

function openFirstCard(id, reviewMode) { 
	jQuery(".CardsSliderList").animate({"margin-left": 0}, 1500, "easeOutBounce");
	hideAnswerCards(id, reviewMode);
	actveCardNumber = 0;
}

function hideControls(id, totIncrement, maxRightIncrement){
	jQuery("#PreviousCard_" + id).css("visibility", "hidden");
	jQuery("#NextCard_" + id).css("visibility", "hidden");
	if(totIncrement < 0){
		jQuery("#PreviousCard_" + id).css("visibility", "visible");
	}
	if(totIncrement > maxRightIncrement){
		jQuery("#NextCard_" + id).css("visibility", "visible");
	}
}	

// private function, accessible only from checkNavigationRestriction in CommonUtilities
function checkCardVisit(){
	for (i=0; i<cardsCompletionValues.length; i++) {
		if (cardsCompletionValues[i] == true) {
			isCardsBeCompleted = true;
		}
	}
	if (allCards == slideCounter || isCardsBeCompleted == false) return 1;
	return 0;
}
